﻿define("epi-ecf-ui/component/Catalogs", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/topic",
// epi
    "epi-cms/widget/HierarchicalList",
// commerce
    "./CatalogsViewModel",
// Resources
    "epi/i18n!epi/cms/nls/commerce.components.catalogs"
],

function (
// dojo
    declare,
    lang,
    on,
    topic,
    
// epi
    HierarchicalList,
// commerce
    CatalogsViewModel,
// Resources
    res
) {
    // module:
    //      epi-ecf-ui.component.Catalogs

    return declare([HierarchicalList], {
        // summary:
        //      Catalogs component.
        // tags:
        //      public

        res: res,

        // To enable context change when search catalog entries
        triggerContextChange: true,

        modelClassName: CatalogsViewModel,

        startup: function () {
            // summary: 
            //      Adds the breadcrumb widget to the top of the list widget.
            // tags:
            //      protected
            this.inherited(arguments);

            topic.subscribe("relationChanged", lang.hitch(this, function () {
                this.list._updateQuery(this.list.query);
            }));
            // disable DnD action on this gadget
            this.tree.dndController.readOnly = true;
        },

        postCreate: function () {
            this.inherited(arguments);

            this.list.set("noDataMessage", this.res.nocatalogentry);
        },

        setupContextMenu: function () {
            // summary: set up the context menu. Overrriden to not add context menu on the catalog tree gadget
            //      
            // tag:
            //      public

        }
    });
});