﻿define("epi-ecf-ui/component/CommerceMediaItemModel", [
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/Stateful",
    "dojo/when",

// EPi Framework
    "epi/dependency",

// EPi CMS
    "epi-cms/contentediting/editors/model/CollectionEditorItemModel",
    "epi-cms/core/PermanentLinkHelper"

], function (

// Dojo
    array,
    declare,
    lang,
    Deferred,
    Stateful,
    when,

// EPi Framework
    dependency,

// EPi CMS
    CollectionEditorItemModel,
    PermanentLinkHelper
) {

    return declare([CollectionEditorItemModel, Stateful], {
        // summary:
        //      The commerce media item model.
        // module:
        //      "epi-ecf-ui/component/commercemediaitemmodel"
        // description:
        //      That supports: edit, delete, create commerce media link
        // tags:
        // public

        fromItemData: function (itemData) {
            // summary:
            //      Create item model object from raw item data.
            // itemData: Object
            //      The raw item data.
            // tags:
            //      public

            var df = new Deferred();

            itemData.assetKey = itemData.assetKey || itemData.permanentUrl;

            when(PermanentLinkHelper.getContent(itemData.assetKey), lang.hitch(this, function (content) {

                if (content) {
                    itemData.thumbnailUrl = content.thumbnailUrl;
                    itemData.assetName = content.name;
                    itemData.assetKey = PermanentLinkHelper.toPermanentLink(content);
                    itemData.assetType = itemData.assetType || content.typeIdentifier;
                }

                //set default value for groupname and sortorder
                itemData.groupName = itemData.groupName || "default";
                itemData.sortOrder = itemData.sortOrder || 0;

                lang.mixin(this, itemData);
                this._itemData = itemData;

                df.resolve(this);
            }));

            return df;
        }

    });
});