﻿/* TODO: Duplicated from AssociationGroupDefinitionEditor - consolidate */
define("epi-ecf-ui/contentediting/editors/RelationGroupDefinitionEditor", [
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-geometry",
    // dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    // dgrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    // epi
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/widget/dialog/_DialogContentMixin",
    // epi-ecf-ui
    "./AddRelationGroupDefinitionCommand",
    // resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.relationgroupeditor"
], function(
    // dojo
    declare,
    lang,
    aspect,
    domConstruct,
    domStyle,
    domGeometry,
    // dijit
    _LayoutWidget,
    _TemplatedMixin,
    // dgrid
    Grid,
    Selection,
    // epi
    dependency,
    _Command,
    ButtonBuilder,
    _DialogContentMixin,
    // epi-ecf-ui
    AddRelationGroupDefinitionCommand,
    // resources
    resources
){
    return declare([_LayoutWidget, _TemplatedMixin, _DialogContentMixin], {

        templateString: '<div><div data-dojo-attach-point="addNode"></div></div>',

        store: null,

        grid: null,

        addButton: null,

        _builder: null,

        constructor: function(){
            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.commerce.relationgroupdefinition");
            this._builder = new ButtonBuilder({ settings: { showLabel: false } });
        },

        postCreate: function(){
            this.inherited(arguments);

            this.addButton = new AddRelationGroupDefinitionCommand();
            this._builder.create(this.addButton, this.addNode);

            this._setupGrid();

            // Refresh grid when added item
            this.own(aspect.after(this.addButton, "onSaved", lang.hitch(this, function () {
                this.grid.refresh();
            })));
        },

        _setupGrid: function(){
            var gridType = declare([Grid, Selection]);

            this.grid = new gridType({
                columns: {
                    name: resources.groupname,
                    action: {
                        className: "epi-columnNarrow",
                        renderHeaderCell: function (node) { },
                        renderCell: lang.hitch(this, function (object, value, node, options) {
                            var deleteCommand = new _Command({
                                iconClass: "epi-iconClose",
                                canExecute: true,
                                _execute: lang.hitch(this, function(){
                                    this.store.remove(object.name).then(lang.hitch(this, function(){
                                        this.grid.refresh();
                                    }));
                                })
                            });
                            this._builder.create(deleteCommand, node);
                        })
                    }
                },
                store: this.store,
                className: "epi-plain-grid"
            });
            this.grid.set("query", {});
            this.own(this.grid);
            domConstruct.place(this.grid.domNode, this.domNode);
        },

        layout: function () {
            // summary:
            //		Layout the children widgets.
            // tags:
            //		protected

            this.inherited(arguments);

            var dialog = this.getParent();
            if (dialog && dialog.containerNode) {
                var containerNodeHeight = domStyle.get(dialog.containerNode, "height"),
                    gridHeaderHeight = Math.max(domGeometry.getMarginBox(this.grid.headerNode).h, domStyle.get(this.grid.bodyNode, "margin")),
                    addButtonHeight = domGeometry.getMarginBox(this.addNode).h;

                // Set the size of the grid to be the dialog container height
                domStyle.set(this.domNode, "height", containerNodeHeight + "px");
                domStyle.set(this.grid.contentNode, "height", (containerNodeHeight - addButtonHeight - gridHeaderHeight) + "px");
            }
        }
    });
});