require({cache:{
'epi-ecf-ui/layers/epi-ecf-ui-widgets':function(){
define([
    "../CommerceUIModule",
    "../contentediting/editors/AssociationCollectionReadOnlyEditor",
    "../contentediting/editors/AssociationGroupSelectionEditor",
    "../widget/CatalogContentDetails",
    "../component/CatalogNavigationTree",
    "../contentediting/editors/CategoryCollectionReadOnlyEditor",
    "../contentediting/editors/VariantCollectionReadOnlyEditor",
    "../contentediting/editors/BundleEntryCollectionReadOnlyEditor",
    "../contentediting/editors/PackageEntryCollectionReadOnlyEditor",
    "../contentediting/editors/CommerceMediaCollectionEditor",
    "../widget/overlay/CommerceMediaCollection",
    "../contentediting/editors/InventoryCollectionEditor",
    "../contentediting/editors/PriceCollectionReadOnlyEditor",
    "../widget/CatalogContentList",
    "../widget/CatalogList",
    "../widget/CommandButton",
    "../widget/LinkEdit",
    "../widget/VariantEdit",
    "../widget/BundleEdit",
    "../widget/PackageEdit",
    "../component/Catalogs",
    "../component/PricingOverview"
], 1);
},
'epi-ecf-ui/CommerceUIModule':function(){
﻿define("epi-ecf-ui/CommerceUIModule", [
    "dojo/_base/declare",
    "epi/_Module",
    "epi/routes",
    "epi/dependency",
    "epi-cms/store/CustomQueryEngine"
], function (
    declare,
    _Module,
    routes,
    dependency,
    CustomQueryEngine
) {

    return declare([_Module], {
        // summary: this is the initializer of CommerceUIModule.

        _settings: null,

        constructor: function (settings) {
            this._settings = settings;
        },

        initialize: function () {
            // summary:
            //		Initialize module
            //
            // description:
            //

            this.inherited(arguments);

            // Initialize stores
            this._initializeStores();
        },

        _initializeStores: function () {
            var registry = this.resolveDependency("epi.storeregistry");
            registry.create("epi.commerce.market", this._getRestPath("market"), {});
            registry.create("epi.commerce.price", this._getRestPath("price"), {queryEngine: CustomQueryEngine});
            registry.create("epi.commerce.inventory", this._getRestPath("inventory"), {});
            registry.create("epi.commerce.relation", this._getRestPath("relation"), { queryEngine: CustomQueryEngine });
            registry.create("epi.commerce.association", this._getRestPath("association"), { queryEngine: CustomQueryEngine });
            registry.create("epi.commerce.customergroup", this._getRestPath("customergroup"), {});
            registry.create("epi.commerce.associationgroupdefinition", this._getRestPath("associationgroupdefinition"), {});
            registry.create("epi.commerce.relationgroupdefinition", this._getRestPath("relationgroupdefinition"), {});
        },

        _getRestPath: function (name) {
            return routes.getRestPath({ moduleArea: "EPiServer.Commerce.Shell", storeName: name });
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/AssociationCollectionReadOnlyEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    // epi commerce
    "./ReadOnlyCollectionEditor",
    "../viewmodel/AssociationCollectionReadOnlyEditorModel",
        
    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.associationcollectioneditor"
],
function (
    //dojo
    declare,
    // epi commerce
    ReadOnlyCollectionEditor,
    AssociationCollectionReadOnlyEditorModel,

    res
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/AssociationCollectionEditor
        // summary:
        //      Represents the Read-only editor widget for product's association list.

        _renderNoDataMessage: function () {
            this.grid.set("noDataMessage", res.nodatamessage);
            this.inherited(arguments);
        },

        iconClass: "epi-iconReferences",

        modelType: AssociationCollectionReadOnlyEditorModel,
        
        changeToView: "linksview",

        buttonLabel: res.editbuttontext
    });
});
},
'epi-ecf-ui/contentediting/editors/ReadOnlyCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/topic",

    // dijit
    "dijit/form/Button",

    // epi cms
    "epi-cms/contentediting/editors/CollectionEditor"
],
function (
    //dojo
    declare,
    lang,
    domClass,
    topic,

    // dijit
    Button,

    // epi cms
    CollectionEditor
) {
    return declare([CollectionEditor], {
        // module:
        //      epi-ecf-ui/contentediting/editors/ReadOnlyCollectionEditor
        // summary:
        //      Represents the Read-only editor widget for product's price list.

        changeToView: null,

        buttonLabel: null,

        buttonClass: "epi-chromelessButton epi-visibleLink",

        iconClass: null,

        isLanguageSpecific: false,

        //isInMasterLanguage: Boolean
        //      Represents if the current content link is in master language or not
        isInMasterLanguage: false,

        isLinkButtonCreated: false,

        modelBindingMap: {
            "isInMasterLanguage": ["isInMasterLanguage"]
        },

        _setupGrid: function () {
            this.inherited(arguments);
            this.grid.set("selectionMode", "none");
        },

        _getGridDefinition: function () {
            // summary:
            //      Returns grid's columns definition.
            // tags:
            //      protected

            var columns = this.inherited(arguments);
            var typeColumn = columns.contentTypeIdentifier;
            if (typeColumn) {
                typeColumn.className = "epi-columnIcon16x16";
                typeColumn.label = "";
            }
            return columns;
        },

        postCreate: function () {
            this.inherited(arguments);
        },

        _setIsInMasterLanguageAttr: function (value) {
            // summary:
            //      IsInMasterLanguage setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this._set("isInMasterLanguage", value);

            if (this.buttonLabel && !this.get("isLinkButtonCreated") && (this.isLanguageSpecific || value)) {
                //Add button only when button is assigned.
                this.createButton();
            }
        },

        createButton: function () {
            var myButt = new Button({
                label: this.buttonLabel,
                iconClass: this.iconClass,
                "class": this.buttonClass,
                onClick: lang.hitch(this, function () {
                    topic.publish("/epi/shell/action/changeview", this.changeToView, {}, {});
                })
            });
            
            this.set("isLinkButtonCreated", true);

            this.own(myButt);
            this.domNode.appendChild(myButt.domNode);
        }
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/AssociationCollectionReadOnlyEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "./ReadOnlyCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,

    ReadOnlyCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/AssociationCollectionEditorModel
        // summary:
        //      Represents the model for AssocciationCollectionEditor

        _storeKey: "epi.commerce.association"
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/ReadOnlyCollectionEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "epi/dependency",

    // epi cms
    "epi-cms/dgrid/formatters",
    "epi-cms/contentediting/editors/model/CollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,
    when,

    dependency,

    // epi cms
    formatters,
    CollectionEditorModel
) {
    return declare([CollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/ReadOnlyCollectionEditorModel
        // summary:
        //      Represents the model for ReadOnly CollectionEditor

        // _storeKey: String
        //      Represents the key to get the store object. Implementation will set this property, to get, for example, price store, or inventory store
        _storeKey: null,

        // _store: Object
        //      Represents the REST store, to get data from.
        _store: null,

        _contentStructureStore : null,

        // _contentLink: ContentReference
        //      Represents the underlay data, a content reference.
        _contentLink: null,
        
        //isInMasterLanguage: Boolean
        //      Represents if the current content link is in master language or not
        isInMasterLanguage: null,

        postscript: function () {
            // summary:
            //      Post script initialization.
            // description:
            //      Set default values.
	    var registry = dependency.resolve("epi.storeregistry");
            this._store = this._store || registry.get(this._storeKey);
            this._contentStructureStore = this._contentStructureStore || registry.get("epi.cms.content.light");
            this.inherited(arguments);
        },

        _dataSetter: function(value) {
            // summary:
            //      Set data property.
            // value: ContentReference
            //      Model value, which would be a ContentReference.
            // tags: 
            //      private

            // The model value is ContentReference. We need to query to the store, to get the appropriate data (for example: price list, or inventory list)
            this._contentLink = value;
            if (!value) {
                this.data = value;
                this._initData();

                return;
            }

            when(this._store.query(this.createQuery(value)), lang.hitch(this, function(storeResult) {
                if (storeResult.models) {
                    this.data = storeResult.models;
                } else {
                    this.data = storeResult;
                }

                this._initData();
            }));

            when(this.getCurrentContent(), lang.hitch(this, function (content) {
                this.set("isInMasterLanguage", content.currentLanguageBranch.isMasterLanguage);
            }));
        },

        _dataGetter: function () {
            // summary:
            //      Get data property.
            // tags: 
            //      private

            return this._contentLink;
        },
        
        createQuery: function(referenceId) {
            return { referenceId: referenceId };
        },
        
        getCurrentContent: function() {
            return this._contentStructureStore.get(this.get("data"));
        },

        generateFormatters: function (columnDefinitions) {
            // summary:
            //      Generate formatters for the specified column definitions.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags: 
            //      override

            this.inherited(arguments);

            var typeColumn = columnDefinitions.contentTypeIdentifier;

            if (typeColumn) {
                typeColumn.formatter = lang.hitch(this, formatters.contentIcon);
            }
            // Disable sort order in dgrid
            for (var columnName in columnDefinitions) {
                lang.setObject("sortable", false, columnDefinitions[columnName]);
            }

            return columnDefinitions;
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/AssociationGroupSelectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    // dijit
    "dijit/form/Select",
    // epi
    "epi/dependency"
], function(
    // dojo
    declare,
    // dijit
    Select,
    // epi
    dependency
) {
    return declare([Select], {

        storeKey: "epi.commerce.associationgroupdefinition",

        constructor: function () {
            this.store = this.store || dependency.resolve("epi.storeregistry").get(this.storeKey);
            this.labelAttr = "name";
        }
    });
});
},
'epi-ecf-ui/widget/CatalogContentDetails':function(){
﻿define([
        "dojo",
        "dojo/_base/array",
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/_base/url",
        "dojo/_base/window",
        "dojo/aspect",
        "dojo/dom-style",
        "dojo/dom-construct",
        "dojo/when",
        "epi/shell/layout/SimpleContainer",
        "epi/shell/TypeDescriptorManager",
        "epi-cms/contentediting/ContentDetails",
        "epi-cms/core/PermanentLinkHelper",
        "dojo/text!./templates/CatalogContentDetails.html"
],
    function (
        dojo,
        array,
        declare,
        lang,
        url,
        win,
        aspect,
        domStyle,
        domConstruct,
        when,
        SimpleContainer,
        TypeDescriptorManager,
        ContentDetails,
        PermanentLinkHelper,
        template
        ) {

        return declare([ContentDetails], {
            templateString: template,

            // thumbnailToken: String
            //      Represents the thumbnail token / thumbnail size to be displayed on header as content's asset preview.
            //      This should match the LargeThumbnail property name of EPiServer.Commerce.SpecializedProperties.CommerceImage.
            //      In order to modify the thumnail size, please update EPiServer.Commerce.SpecializedProperties.CommerceImage.LargeThumbnail's ImageDescriptor, 
            //      or create a new property, and set this thumbnailToken value to that property name.
            thumbnailToken: "LargeThumbnail",

            // thumbnailNode: DOM node
            //      Represents the thumbnail node, which would be added to the header section, to display content's thumbnail.
            thumbnailNode: null,

            buildRendering: function () {
                this.inherited(arguments);

                // Escaping is tricky in the data-dojo-props JSON notation, so setting tooltip here instead.
                this.dropdownButton.set("tooltip", this.resources.toolsbutton.tooltip);
            },

            _setModelAttr: function () {
                this.inherited(arguments);

                if (this.model) {
                    this.own(this.model.watch("dataModel", lang.hitch(this, this._onDataModelChanged)));
                }
            },

            _onDataModelChanged: function () {
                // summary:
                //      On data model changed, listen for model's onPropertyEdited even, to update thumbnail image in the header.
                // tags:
                //      private

                if (this.model && this.model.dataModel) {
                    this.own(aspect.after(this.model.dataModel, "onPropertyEdited", lang.hitch(this, function (propertyName, value) {
                        if (propertyName !== "commerceMediaCollection") {
                            return;
                        }

                        this._onMediaCollectionPropertyChanged(value);
                    }), true /*receiveArguments setting this as true in order to get corrected propertyName, value arguments (which are original arguments)*/));

                    // we need to update thumbnail on first load too
                    this._onMediaCollectionPropertyChanged(this.model.dataModel.contentModel && this.model.dataModel.contentModel["epi-commerceMediaCollection"] || null);
                }
            },

            _onMediaCollectionPropertyChanged: function (value) {
                // summary:
                //      When commerceMediaCollection property value changed, get the first asset to set as content thumbnail.
                // tags:
                //      private

                if (!value || value.length < 1) {
                    this._renderThumbnail(""); // if content's asset is empty, let's set thumbnail image's source as blank.
                    return;
                }

                var firstAsset = null;
                // looking for the first image in asset list
                array.some(value, function (item) {
                    if (item && TypeDescriptorManager.isBaseTypeIdentifier(item.assetType, "episerver.core.icontentimage")) {
                        firstAsset = item;
                        return item;
                    }
                }, this);

                if (!firstAsset) {
                    this._renderThumbnail("");
                    return;
                }

                if (firstAsset.url) {
                    this._renderThumbnail(firstAsset.url);
                } else {
                    // if firstAsset.url is not ready, we need to get its public URL via PermanentLinkHelper
                    when(PermanentLinkHelper.getContent(firstAsset.assetKey), lang.hitch(this, function (content) {
                        if (!content) { // content not found
                            this._renderThumbnail("");
                        } else {
                            this._renderThumbnail(content.publicUrl);
                        }
                    }));
                }
            },

            addChild: function (w) {
                this.widgetContainer.addChild(w);
            },

            _renderThumbnail: function (imageUrl) {
                // summary:
                //      Injects the thumbnail image to the header section (if it was not added), and update its image URL.
                // tags:
                //      protected

                var parentNode = this.domNode.parentNode;
                if (!parentNode) {
                    return;
                }
                var imageSource = !imageUrl ? "" : (imageUrl + "/" + this.thumbnailToken + "?time=" + new Date().getTime()); // append time parameter to make sure image will be refresh all the time, to avoid cache issue.

                if (!this.thumbnailNode) {
                    this.thumbnailNode = domConstruct.create("img", {
                        src: imageSource,
                        className: "epi-heading-thumbnail"
                    });
                    domConstruct.place(this.thumbnailNode, parentNode, "first");
                } else {
                    this.thumbnailNode.src = imageSource;
                }

                domStyle.set(this.thumbnailNode, "display", !!imageSource ? "block" : "none");
            },

            _setExistingLanguagesAttr: function (languages) {
                this.languagesNode.innerHTML = "";

                // Create text or link elements base on language information.
                array.forEach(languages, function (item, idx) {
                    var elm, isLast = idx === languages.length - 1;
                    if (this.model.dataModel.currentContentLanguage === item.text) {
                        elm = domConstruct.create("span", {
                            innerHTML: item.urlSegment
                        });
                    } else {
                        var url = new dojo._Url(window.top.location.href);
                        elm = domConstruct.create("a", {
                            innerHTML: item.urlSegment,
                            href: [url.scheme, "://", url.authority, url.path, "?language=", item.text, "#context=epi.cms.contentdata:///", item.contentLink].join(""),
                            "class": "epi-visibleLink"
                        });
                    }
                    domConstruct.place(elm, this.languagesNode);

                    if (!isLast) {
                        domConstruct.place(win.doc.createTextNode(", "), this.languagesNode);
                    }
                }, this);
            }
        });
    });

},
'url:epi-ecf-ui/widget/templates/CatalogContentDetails.html':"﻿<div class=\"epi-containerLayout\">\r\n    <div data-dojo-type=\"epi/shell/layout/SimpleContainer\" data-dojo-attach-point=\"widgetContainer\"></div>\r\n    <ul>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.visibleto.title}</label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"visibleToNode\" class=\"dijitInline\"></span>\r\n                <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"manageAccessRightsButton\" data-dojo-attach-event=\"onClick: _onManageAccessRightsClick\" class=\"epi-chromelessButton epi-chromelessLinkButton epi-functionLink\">${resources.manage}</div>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.existinglanguages}</label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"languagesNode\" class=\"dijitInline\"></span>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.idandtypename}</label> \r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"idNode\" class=\"dijitInline\"></span>, <span data-dojo-attach-point=\"typeNode\" class=\"dijitInline\"></span>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label></label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <div data-dojo-attach-point=\"dropdownButton\" data-dojo-type=\"dijit/form/DropDownButton\" class=\"dijit dijitReset dijitInline epi-mediumButton\">\r\n                    <span>${resources.toolsbutton.label}</span>\r\n                    <div data-dojo-type=\"dijit/DropDownMenu\" data-dojo-attach-point=\"additionalActionsMenu\"></div>\r\n                </div>\r\n            </div>\r\n        </li>\r\n    </ul>\r\n</div>",
'epi-ecf-ui/component/CatalogNavigationTree':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
// epi
    "epi-cms/component/ContentNavigationTree",
// commerce
    "../widget/viewmodel/CatalogTreeStoreModel",
    "./ContentContextMenuCommandProvider"
],

function (
// dojo
    array,
    declare,
// epi
    ContentNavigationTree,
    // commerce
    CatalogTreeStoreModel,
    ContextMenuCommandProvider
 ) {
    // module:
    //      epi-ecf-ui.component.CatalogNavigationTree

    return declare([ContentNavigationTree], {
        // summary:
        //      Catalog tree component, which support market filtering.
        // tags:
        //      public

        contextMenuCommandProvider: ContextMenuCommandProvider,

        _createTreeModel: function () {
            // summary:
            //      Create content tree model
            // tags:
            //      protected

            return new CatalogTreeStoreModel({
                root: this.root,
                typeIdentifiers: this.typeIdentifiers,
                containedTypes: this.settings.containedTypes
            });
        },

        _createTreeNode: function () {
            // summary:
            //      Overriden base class. Check whether the node is catalog content root
            //      to set has context menu to false
            var node = this.inherited(arguments);

            if (node.item && node.item.contentLink === this.tree.model.roots[0]) {

                node.hasContextMenu = false;
            }
            return node;
        }
    });
});
},
'epi-ecf-ui/widget/viewmodel/CatalogTreeStoreModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/request",
    "dojo/when",
    "dojo/topic",
// epi
    "epi/dependency",
    "epi/routes",
    "epi/string",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/ContentForestStoreModel",
// epi-ecf-ui
    "../../contentediting/ModelSupport",
    "../CatalogPasteItemDialog",
    // resources
    "epi/i18n!epi/nls/commerce.components.catalogtree"
],

function (
// dojo
    array,
    declare,
    lang,
    Deferred,
    promiseAll,
    request,
    when,
    topic,
// epi
    dependency,
    routes,
    epiString,
    Alert,
    Dialog,
    TypeDescriptorManager,
    ContentReference,
    ContentForestStoreModel,
    ModelSupport,
    CatalogPasteItemDialog,
    resources
) {
    // module:
    //      epi-ecf-ui.widget.viewmodel.CatalogTreeStoreModel

    return declare([ContentForestStoreModel], {
        // summary:
        //      Catalogs tree store model, which support listing catalog content with market filter.
        // tags:
        //      public

        relationStore: null,
        
        typeDescriptorManager: TypeDescriptorManager,

        constructor: function(){
            this.relationStore = this.relationStore || dependency.resolve("epi.storeregistry").get("epi.commerce.relation");
            this.contentTypeStore = this.contentTypeStore  || dependency.resolve("epi.storeregistry").get("epi.cms.contenttype");
            this._handles.push(topic.subscribe("relationChanged", lang.hitch(this, this._relationChanged)));
        },

        _relationChanged: function(addedItem){
            this._childrenChanged(addedItem.target);
        },

        newItems: function(items, newParentItem) {
            this._selectAction(items, newParentItem);
        },

        newItem: function(item, newParentItem, actionType){
            this._performAction(item, newParentItem, actionType);
        },

        pasteItems: function(items, newParentItem) {
            this._selectAction(items, newParentItem);
        },

        pasteItem: function (childItem, oldParentItem, newParentItem, actionType) {
            if (typeof actionType === 'string') {
                if (!childItem || !newParentItem) { return; }

                switch (actionType) {
                    case 'link':
                        return this._addRelation(childItem, newParentItem);
                    case 'move':
                        if (ContentReference.compareIgnoreVersion(childItem.parentLink, oldParentItem.contentLink)) {
                            return this.inherited(arguments, [childItem, oldParentItem, newParentItem, false]);
                        } else {
                            return this._replaceRelation(childItem, oldParentItem, newParentItem);
                        }
                        break; // JsHint requires this
                    case 'duplicate':
                        return this.inherited(arguments, [childItem, oldParentItem, newParentItem, true]);
                    default:
                        break;
                }
            }
        },

        _selectAction: function(items, newParentItem) {
            var checkItems = function(items, availableContentTypeIds) {
                return array.every(items, function(item) {
                    if(!item.dndData || !item.dndData.data) {
                        return false;
                    }
                    return availableContentTypeIds.indexOf(item.dndData.data.contentTypeID) > -1;
                });
            };

            return when(this._isContentTypeAllowed(items, newParentItem, checkItems), lang.hitch(this, function(isContentTypesAllowed){
                if(!isContentTypesAllowed) {
                    this._showContentTypeAlert();
                    return false;
                }
                var isLinkSupported = this._isLinkSupported(newParentItem.typeIdentifier);
                return when(this._newItemConfirmation(false, !isLinkSupported), lang.hitch(this, function (actionType) {
                    var deferreds = array.map(items, function (item) {
                        return this._performAction(item, newParentItem, actionType);
                    }, this);
                    return promiseAll(deferreds);
                }));
            }));
        },

        _showContentTypeAlert: function (response) {
            // summary:
            //      Show an alert dialog if a content type can't be dropped
            // tags:
            //      protected

            if (this._invalidContentTypeAlertDialog) {
                this._invalidContentTypeAlertDialog.destroy();
            }

            this.own(this._invalidContentTypeAlertDialog = new Alert({
                destroyOnHide: true,
                description: epiString.toHTML(resources.contenttypesnotallowed)
            }));

            this._invalidContentTypeAlertDialog.show();
        },

        _performAction: function(item, newParentItem, actionType){
            var content = item.dndData.data;
            if (content){
                var oldParentItem = this.getParentItem(item.dndData);
                return this.pasteItem(content, oldParentItem, newParentItem, actionType);
            }
        },

        getParentItem: function(dndData){
            if (dndData && dndData.options && dndData.options.oldParentItem) {
                return dndData.options.oldParentItem;
            }
            throw "The item is not supported. The drag source must specify options containing the oldParentItem.";
        },

        _newItemConfirmation: function (hideMoveOption, hideLinkOption) {
            var deferred = new Deferred();

            var pasteItemDialog = new CatalogPasteItemDialog({
                hideMoveOption: hideMoveOption,
                hideLinkOption: hideLinkOption,
                executeDialog: function(actionType) {
                    deferred.resolve(actionType);
                },
                cancelDialog: function() {
                    deferred.cancel();
                }
            });

            var dialog = new Dialog({
                dialogClass: "epi-dialog-confirm",
                defaultActionsVisible: false,
                content: pasteItemDialog,
                title: pasteItemDialog.title,
                destroyOnHide: true
            });

            dialog.show();

            return deferred.promise;
        },

        _selectItemOnPasteComplete: function (item, copy, isDeleted, oldParentItem, newParentItem) {
            // summary:
            //		Select an item after a paste operation has completed. Override this function to keep current context when moving content.
            // item: Item
            //      The target item of the operation
            // copy: boolean
            //      If it was a copy operation or not
            // isDeleted: boolean
            //      If the operation resulted in the item being deleted, i.e. moved to the trash
            // oldParentItem: Item
            //      The curent parent item
            // newParentItem: Item
            //      The target item for the operation
            // tags: protected, override

            // override this to keep the selected/viewing page, instead of selecting the new parent page.
        },

        _getRelations: function(contentLink) {
            return this.relationStore.query({ referenceId: contentLink });
        },

        _addRelation: function(childItem, newParentItem) {
            return when(this._getRelations(childItem.contentLink), lang.hitch(this, function(relations) {
                var maxSortOrder = 0;
                array.forEach(relations, function(relation) {
                    if (relation.sortOrder > maxSortOrder) {
                        maxSortOrder = relation.sortOrder;
                    }
                });
                return when(this.relationStore.add({
                    source: childItem.contentLink,
                    target: newParentItem.contentLink,
                    type: ModelSupport.relationType.node,
                    sortOrder: maxSortOrder + 100
                }), function (addedItem) {
                    topic.publish("relationChanged", addedItem);
                });
            }));
        },

        _replaceRelation: function(childItem, oldParentItem, newParentItem) {
            return when(this._getRelations(childItem.contentLink), lang.hitch(this, function(relations) {
                array.forEach(relations, function(oldRelation) {
                    if (oldRelation.type === ModelSupport.relationType.node && ContentReference.compareIgnoreVersion(oldRelation.target, oldParentItem.contentLink)) {
                        var newRelation = {
                            source: childItem.contentLink,
                            target: newParentItem.contentLink,
                            type: ModelSupport.relationType.node,
                            sortOrder: oldRelation.sortOrder
                        };
                        return when(this.relationStore.remove(oldRelation.id), lang.hitch(this, function() {
                            return when(this.relationStore.add(newRelation), function(addedItem) {
                                topic.publish("relationChanged", addedItem);
                                });
                        }));
                    }
                }, this);
            }));
        },

        copy: function (source, target) {
            return when(this._isContentTypeAllowed(source, target), lang.hitch(this, function(isContentTypesAllowed){

                if(!isContentTypesAllowed) {
                    this._showContentTypeAlert();
                    return;
                }
                var isLinkSupported = this._isLinkSupported(target.typeIdentifier);
                return when(this._newItemConfirmation(true, !isLinkSupported), lang.hitch(this, function (choice) {
                    var deferreds = array.map(source, function (item) {
                        return when(this.store.get(item.data.parentLink), lang.hitch(this, function (oldParent) {
                            return this.pasteItem(item.data, oldParent, target, choice);
                        }));
                    }, this);
                    return promiseAll(deferreds).then(lang.hitch(this, function (copiedItem) {
                        topic.publish("itemPasted",copiedItem);
                    }));
                }));
            }));
        },

        _isContentTypeAllowed: function(items, target, checkItemFunc) {
            return when(this.contentTypeStore.query({query: "getavailablecontenttypes", parentReference: target.contentLink}), lang.hitch(this, function(contentTypes){
                var availableTypeIds = array.map(contentTypes, function(contentType){
                    return contentType.id;
                });

                if (!checkItemFunc) {
                    checkItemFunc = function(items, availableContentTypeIds) {
                        return array.every(items, function(item) {
                            if (!item.data) {
                                return false;
                            }
                            return availableContentTypeIds.indexOf(item.data.contentTypeID) > -1;
                        });
                    };
                }
                return checkItemFunc(items, availableTypeIds);
            }));
        },

        move: function (source, target) {
            // summary:
            //      Move source item to target
            if (!target.contentLink) {
                target = this.store.get(target);
            }

            return when(this._isContentTypeAllowed(source, target), lang.hitch(this, function(isContentTypesAllowed){
                if (!isContentTypesAllowed){
                    this._showContentTypeAlert();
                    return;
                }
                var deferreds = array.map(source, function (item) {
                    if (item.data) {
                        var oldParent = { contentLink: new ContentReference(item.data.parentLink).createVersionUnspecificReference().toString() };
                        return this.pasteItem(item.data, oldParent, target, "move");
                    }
                }, this);
                return promiseAll(deferreds).then(lang.hitch(this, function (movedItem) {
                    topic.publish("itemPasted", movedItem);
                }));
            }));
        },

        onDeleted: function (deletedItems) {

            // summary:
            //		Published a "catalogContentDeleted" topic when all rows are deleted.

            topic.publish("catalogContentDeleted", deletedItems);
        },

        remove: function(items) {
            // summary:
            //      Removes the specified items from the catalog


            // since ecf does not handle multiple async delete requests very well
            // we're using a separate delete controller to batch delete multiple items
            var urlToDeleteController = routes.getActionPath({
                    moduleArea: "EPiServer.Commerce.Shell",
                    controller: "Delete",
                    action: "Delete"
                }),
                contentReferences = array.map(items, function(item) {
                    return item.data.contentLink;
                }),
                postRequest = request.post(urlToDeleteController, {
                    data: {
                        contentReferences: contentReferences
                    }
                });

            return when(postRequest, lang.hitch(this, function() {
                return when(this.currentContentService.getCurrentContext(), lang.hitch(this, function(currentContext) {
                    array.some(items, function(item){
                        if (ContentReference.compareIgnoreVersion(currentContext.id, item.data.contentLink) && item.data.parentLink) {
                            // we're deleting the currently selected item and need to change selection.
                            this.onSelect(item.data.parentLink, true);
                            return true;
                        }
                    }, this);

                    //since we're deleting in a separate controller we need to tell the structure store that items are deleted.
                    var promises = array.map(contentReferences, function(contentLink){
                        return this.store.refresh(contentLink);
                    }, this);
                    return when(promiseAll(promises), lang.hitch(this, function(){
                        this.onDeleted(items);
                    }));
                }));
            }));
        },
        
        _isLinkSupported: function(dataType) {
            return this.typeDescriptorManager.isBaseTypeIdentifier(dataType, ModelSupport.contentTypeIdentifier.entryContentBase) ||
                this.typeDescriptorManager.isBaseTypeIdentifier(dataType, ModelSupport.contentTypeIdentifier.nodeContent);
        },

        isSupportedType: function (dataType) {
            var isSupportedType = this.inherited(arguments);
            var inheritFromAnyContainedType = array.some(this.containedTypes, function(containedType){
                return this.typeDescriptorManager.isBaseTypeIdentifier(dataType, containedType);
            }, this);
            return isSupportedType || inheritFromAnyContainedType;
        }
    });
});
},
'dojo/request':function(){
define("dojo/request", [
	'./request/default!'/*=====,
	'./_base/declare',
	'./promise/Promise' =====*/
], function(request/*=====, declare, Promise =====*/){
	/*=====
	request = function(url, options){
		// summary:
		//		Send a request using the default transport for the current platform.
		// url: String
		//		The URL to request.
		// options: dojo/request.__Options?
		//		Options for the request.
		// returns: dojo/request.__Promise
	};
	request.__Promise = declare(Promise, {
		// response: dojo/promise/Promise
		//		A promise resolving to an object representing
		//		the response from the server.
	});
	request.__BaseOptions = declare(null, {
		// query: String|Object?
		//		Query parameters to append to the URL.
		// data: String|Object?
		//		Data to transfer.  This is ignored for GET and DELETE
		//		requests.
		// preventCache: Boolean?
		//		Whether to append a cache-busting parameter to the URL.
		// timeout: Integer?
		//		Milliseconds to wait for the response.  If this time
		//		passes, the then the promise is rejected.
		// handleAs: String?
		//		How to handle the response from the server.  Default is
		//		'text'.  Other values are 'json', 'javascript', and 'xml'.
	});
	request.__MethodOptions = declare(null, {
		// method: String?
		//		The HTTP method to use to make the request.  Must be
		//		uppercase.
	});
	request.__Options = declare([request.__BaseOptions, request.__MethodOptions]);

	request.get = function(url, options){
		// summary:
		//		Send an HTTP GET request using the default transport for the current platform.
		// url: String
		//		URL to request
		// options: dojo/request.__BaseOptions?
		//		Options for the request.
		// returns: dojo/request.__Promise
	};
	request.post = function(url, options){
		// summary:
		//		Send an HTTP POST request using the default transport for the current platform.
		// url: String
		//		URL to request
		// options: dojo/request.__BaseOptions?
		//		Options for the request.
		// returns: dojo/request.__Promise
	};
	request.put = function(url, options){
		// summary:
		//		Send an HTTP POST request using the default transport for the current platform.
		// url: String
		//		URL to request
		// options: dojo/request.__BaseOptions?
		//		Options for the request.
		// returns: dojo/request.__Promise
	};
	request.del = function(url, options){
		// summary:
		//		Send an HTTP DELETE request using the default transport for the current platform.
		// url: String
		//		URL to request
		// options: dojo/request.__BaseOptions?
		//		Options for the request.
		// returns: dojo/request.__Promise
	};
	=====*/
	return request;
});

},
'dojo/request/default':function(){
define("dojo/request/default", [
	'exports',
	'require',
	'../has'
], function(exports, require, has){
	var defId = has('config-requestProvider'),
		platformId;

	if( 1 ){
		platformId = './xhr';
	}else if( 0 ){
		platformId = './node';
	/* TODO:
	}else if( 0 ){
		platformId = './rhino';
   */
	}

	if(!defId){
		defId = platformId;
	}

	exports.getPlatformDefaultId = function(){
		return platformId;
	};

	exports.load = function(id, parentRequire, loaded, config){
		require([id == 'platform' ? platformId : defId], function(provider){
			loaded(provider);
		});
	};
});

},
'epi-ecf-ui/contentediting/ModelSupport':function(){
﻿define([
],

function (
) {
    var modelSupport = {
        // summary:
        //    This class helps dealing with models
        //      * contains enums and constants
        // tags:
        //    public static
        
        // relationType: Object
        //      Types used on catalog relation models
        relationType: {
            undefined: 0,
            node: 1,
            bundleEntry: 2,
            packageEntry: 3,
            productVariation: 4
        },

        // contentTypeIdentifier: Object
        //      Type identifiers for catalog content types
        contentTypeIdentifier: {
            bundleContent: "episerver.commerce.catalog.contenttypes.bundlecontent",
            catalogContent: "episerver.commerce.catalog.contenttypes.catalogcontent",
            catalogContentBase: "episerver.commerce.catalog.contenttypes.catalogcontentbase",
            entryContentBase: "episerver.commerce.catalog.contenttypes.entrycontentbase",
            nodeContent: "episerver.commerce.catalog.contenttypes.nodecontent",
            nodeContentBase: "episerver.commerce.catalog.contenttypes.nodecontentbase",
            packageContent: "episerver.commerce.catalog.contenttypes.packagecontent",
            productContent: "episerver.commerce.catalog.contenttypes.productcontent",
            rootContent: "episerver.commerce.catalog.contenttypes.rootcontent",
            variationContent: "episerver.commerce.catalog.contenttypes.variationcontent"
        },
        
        // linkTypeIdentifier: Object
        //      Type identifiers for catalog link types
        linkTypeIdentifier: {
            association: "episerver.commerce.catalog.linking.association",
            relation: "episerver.commerce.catalog.linking.relation"
        }
    };

    return modelSupport;
});
},
'epi-ecf-ui/widget/CatalogPasteItemDialog':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",

// dijit
    "dijit/_Widget",

// epi
    "epi",
    "epi/shell/widget/_ActionProviderWidget",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/i18n!epi/cms/nls/commerce.widget.pasteitemdialog"

], function (
// dojo
    declare,
    lang,
    domConstruct,

// dijit
    _Widget,

// epi
    epi,
    _ActionProviderWidget,
    _DialogContentMixin,
    resources
){
    return declare([_Widget, _ActionProviderWidget, _DialogContentMixin], {

        hideMoveOption: false,
        
        hideLinkOption: false,

        title: resources.title,

        buildRendering: function () {
            this.inherited(arguments);

            domConstruct.create("span", { innerHTML: resources.message }, this.domNode);
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider

            this._actions = [];
            
            this._actions.push({
                name: "duplicate",
                label: resources.duplicate,
                settings: { type: "button" },
                action: lang.hitch(this, function() {
                    this.executeDialog('duplicate');
                })
            });
            
            if (!this.hideLinkOption) {
                this._actions.push({
                    name: "link",
                    label: resources.link,
                    settings: { type: "button" },
                    action: lang.hitch(this, function() {
                        this.executeDialog('link');
                    })
                });
            }
            
            if (!this.hideMoveOption) {
                this._actions.push({
                    name: "move",
                    label: resources.move,
                    settings: { type: "button" },
                    action: lang.hitch(this, function() {
                        this.executeDialog('move');
                    })
                });
            }
            
            this._actions.push({
                name: "cancel",
                label: epi.resources.action.cancel,
                settings: { type: "button" },
                action: lang.hitch(this, function () {
                    this.cancelDialog();
                })
            });
            
            return this._actions;
        }
    });
});
},
'epi-ecf-ui/component/ContentContextMenuCommandProvider':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
// epi shell
    "epi/shell/selection",
    "epi/shell/command/withConfirmation",
// epi cms
    "epi-cms/component/ContentContextMenuCommandProvider",
    "epi-cms/component/command/ChangeContext",
    "epi-cms/command/DeleteContent",
    "epi-cms/command/CutContent",
    "epi-cms/command/CopyContent",
    "epi-cms/command/PasteContent",
    "epi-cms/command/TranslateContent",
//  commerce
    "./DeleteCatalogContentHandler",
    "../contentediting/ModelSupport",
// Resources
    "epi/i18n!epi/cms/nls/commerce.components.catalogs.commands",
    "epi/i18n!epi/nls/episerver.shared"
],

function (
// dojo
    array,
    declare,
 // epi shell
    Selection,
    withConfirmation,
// epi cms
    ContextMenuCommandProvider,
    ChangeContextCommand,
    DeleteCommand,
    CutCommand,
    CopyCommand,
    PasteCommand,
    TranslateCommand,
// commerce
    DeleteCatalogContentHandler,
    ModelSupport,
// Resources
    res,
    sharedResources
) {
    // module:
    //      epi-ecf-ui.component.ContentContextMenuCommandProvider

    return declare([ContextMenuCommandProvider], {
        // summary:
        //      Command provider for Commerce content context menu.
        // tags:
        //      public

        postscript: function () {
            this.inherited(arguments);

            var commands = this.get("commands");
            array.some(commands, function(command) {
                if (command.isInstanceOf(DeleteCommand)) {
                    this._updateDeleteCommand(command);
                    return true;
                }
            }, this);

            var changeContext = new ChangeContextCommand({
                category: "context",
                forceContextChange: true,
                viewName: "formedit"
            });
            commands.splice(0, 0, changeContext); //add edit first
            this.set("commands",commands);
        },

        updateCommandModel: function (model){
            this.inherited(arguments);

            array.some(this.get("commands"), function (command) {
                if (command.isInstanceOf(TranslateCommand)) {
                    command.set("isAvailable", false);
                }

                if (command.isInstanceOf(ChangeContextCommand)) {
                    command.set("model", model);
                }

                if (command.selection) {
                    command.selection.set("data", model ? [{ type: "epi.cms.contentdata", data: model }] : []);
                }
                if (command.isInstanceOf(CutCommand) || command.isInstanceOf(CopyCommand) || command.isInstanceOf(PasteCommand)) {
                    if (model && model.typeIdentifier !== ModelSupport.contentTypeIdentifier.rootContent
                            && model.typeIdentifier !== ModelSupport.contentTypeIdentifier.catalogContent) {
                        command.set("isAvailable", true);
                    } else {
                        command.set("isAvailable", false);
                    }
                }
                // Hide edit and delete commands when viewing "Catalog Root" and "Departmental Catalog"
                if (command.isInstanceOf(ChangeContextCommand) || command.isInstanceOf(DeleteCommand)) {
                    if (model && model.typeIdentifier !== ModelSupport.contentTypeIdentifier.rootContent
                            && model.typeIdentifier !== ModelSupport.contentTypeIdentifier.catalogContent) {
                        command.set("isAvailable", true);
                    } else {
                        command.set("isAvailable", false);
                    }
                }
            }, this);
        },

        _updateDeleteCommand: function (command) {
            command = withConfirmation(command, DeleteCatalogContentHandler, {
                title: res.deleteconfirmationtitle,
                description: res.deleteconfirmationdescription,
                confirmActionText: sharedResources.action.deletelabel,
                cancelActionText: sharedResources.action.cancel
            });
        }
    });
});
},
'epi-ecf-ui/component/DeleteCatalogContentHandler':function(){
﻿define([
    //Dojo
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/Deferred",
        "dojo/topic",
    //EPi
        "./DeleteConfirmation"
], function (
    //Dojo
        declare,
        lang,
        Deferred,
        topic,
        //Commerce
        DeleteConfirmation
) {
     //summary:
     //     Adds confirmation before executing delete command and hide dialog after delete is done.

    var handler = function (settings) {

        var deferred = new Deferred(),
            dialog = new DeleteConfirmation(settings);

        dialog.connect(dialog, "onAction", function (confirm) {
            if (confirm) {
                deferred.resolve();
            } else {
                deferred.cancel();
            }
        });

        dialog.show();

        topic.subscribe("catalogContentDeleted", function () {
            dialog.hide();
        });
        topic.subscribe("/epi/cms/action/delete/error", function(){
            dialog.hide();
        });

        return deferred;
    };

    return handler;
});
},
'epi-ecf-ui/component/DeleteConfirmation':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// dojox
    "dojox/widget/Standby",
// EPi
    "epi/shell/widget/dialog/Confirmation"
], function (
// Dojo
    declare,
    lang,
// dojox    
    Standby,
// EPi
    Confirmation
) {
    return declare([Confirmation], {

        _standBy: null,

        postCreate: function(){
            this.inherited(arguments);
            this._standBy = new Standby({ target: this.domNode, color: "#fff" }).placeAt(document.body);
            this._standBy.startup();
            this.own(this._standBy);
        },

        _onConfirm: function () {
            // summary:
            //		Called when user has triggered the dialog's confirm action.
            // type:
            //		callback
            
            this._standBy.show();
            for(var index in this.definitionConsumer._widgetMap){
                var widget = this.definitionConsumer._widgetMap[index];
                widget.set("disabled", true);
            }
            this.onAction(true);
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/CategoryCollectionReadOnlyEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",

    // epi commerce
    "./ReadOnlyCollectionEditor",
    "../viewmodel/CategoryCollectionReadOnlyEditorModel",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.categorycollectioneditor"
],
function (
    //dojo
    declare,
    
    // epi commerce
    ReadOnlyCollectionEditor,
    CategoryCollectionReadOnlyEditorModel,

    res
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/RelationCollectionEditor
        // summary:
        //      Represents the Read-only editor widget for product's inventory list.

        iconClass: "epi-iconCategory",

        modelType: CategoryCollectionReadOnlyEditorModel,

        _renderNoDataMessage: function () {
            this.grid.set("noDataMessage", res.nodatamessage);
            this.inherited(arguments);
        },
               
        changeToView: "linksview",

        buttonLabel: res.editbuttontext
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/CategoryCollectionReadOnlyEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "../ModelSupport",
    "./ReadOnlyCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,
    
    ModelSupport,
    ReadOnlyCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/RelationCollectionEditorModel
        // summary:
        //      Represents the model for RelationCollectionEditor

        _storeKey: "epi.commerce.relation",
        
        createQuery: function (referenceId) {
            return { referenceId: referenceId, relationTypes: [ModelSupport.relationType.node] };
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/VariantCollectionReadOnlyEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",

    // epi commerce
    "./ReadOnlyCollectionEditor",
    "../viewmodel/VariantCollectionReadOnlyEditorModel",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.variantcollectioneditor"
],
function (
    //dojo
    declare,
    
    // epi commerce
    ReadOnlyCollectionEditor,
    VariantCollectionReadOnlyEditorModel,

    res
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/VariantCollectionReadOnlyEditor
        // summary:
        //      Represents the Read-only editor widget for variations.

        iconClass: "epi-iconObjectVariation",

        modelType: VariantCollectionReadOnlyEditorModel,

        _renderNoDataMessage: function () {
            this.grid.set("noDataMessage", res.nodatamessage);
            this.inherited(arguments);
        },
               
        changeToView: "variantview",

        buttonLabel: res.editbuttontext
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/VariantCollectionReadOnlyEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "../ModelSupport",
    "./ReadOnlyCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,

    ModelSupport,
    ReadOnlyCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/VariantCollectionReadOnlyEditorModel
        // summary:
        //      Represents the model for VariantCollectionReadOnlyEditor

        _storeKey: "epi.commerce.relation",

        createQuery: function (referenceId) {
            return { referenceId: referenceId, relationTypes: [ModelSupport.relationType.productVariation] };
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/BundleEntryCollectionReadOnlyEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",

    // epi commerce
    "./ReadOnlyCollectionEditor",
    "../viewmodel/BundleEntryCollectionReadOnlyEditorModel",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.bundleentrycollectioneditor"
],
function (
    //dojo
    declare,
    
    // epi commerce
    ReadOnlyCollectionEditor,
    BundleEntryCollectionReadOnlyEditorModel,

    res
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/BundleEntryCollectionReadOnlyEditor
        // summary:
        //      Represents the Read-only editor widget for bundle entries.

        iconClass: "epi-iconObjectBundle",

        modelType: BundleEntryCollectionReadOnlyEditorModel,

        _renderNoDataMessage: function () {
            this.grid.set("noDataMessage", res.nodatamessage);
            this.inherited(arguments);
        },
               
        changeToView: "bundleview",

        buttonLabel: res.editbuttontext
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/BundleEntryCollectionReadOnlyEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "../ModelSupport",
    "./ReadOnlyCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,

    ModelSupport,
    ReadOnlyCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/BundleEntryCollectionReadOnlyEditorModel
        // summary:
        //      Represents the model for BundleEntryCollectionReadOnlyEditor

        _storeKey: "epi.commerce.relation",

        createQuery: function (referenceId) {
            return { referenceId: referenceId, relationTypes: [ModelSupport.relationType.bundleEntry] };
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/PackageEntryCollectionReadOnlyEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",

    // epi commerce
    "./ReadOnlyCollectionEditor",
    "../viewmodel/PackageEntryCollectionReadOnlyEditorModel",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.packageentrycollectioneditor"
],
function (
    //dojo
    declare,
    
    // epi commerce
    ReadOnlyCollectionEditor,
    PackageEntryCollectionReadOnlyEditorModel,

    res
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/PackageEntryCollectionReadOnlyEditor
        // summary:
        //      Represents the Read-only editor widget for package entries.

        iconClass: "epi-iconObjectPackage",

        modelType: PackageEntryCollectionReadOnlyEditorModel,

        _renderNoDataMessage: function () {
            this.grid.set("noDataMessage", res.nodatamessage);
            this.inherited(arguments);
        },
               
        changeToView: "packageview",

        buttonLabel: res.editbuttontext
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/PackageEntryCollectionReadOnlyEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "../ModelSupport",
    "./ReadOnlyCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,

    ModelSupport,
    ReadOnlyCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/PackageEntryCollectionReadOnlyEditorModel
        // summary:
        //      Represents the model for PackageEntryCollectionReadOnlyEditor

        _storeKey: "epi.commerce.relation",

        createQuery: function (referenceId) {
            return { referenceId: referenceId, relationTypes: [ModelSupport.relationType.packageEntry] };
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/CommerceMediaCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/topic",

    // EPi Framework
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/dnd/Target",
   

    // epi cms
    "epi-cms/contentediting/editors/CollectionEditor",
    "epi-cms/contentediting/editors/_TextWithActionLinksMixin",

    // epi commerce
    "epi-ecf-ui/contentediting/editors/model/CommerceMediaCollectionEditorModel",
    "epi-ecf-ui/component/CommerceMediaItemModel",

    // Resources
    "dojo/text!./templates/CommerceMediaEditor.html",
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.commercemediacollectioneditor"

],
function (
    //dojo
    declare,
    lang,
    aspect,
    domClass,
    domStyle,
    topic,

    // EPi Framework
    _FocusableMixin,
    Target,

    // epi cms
    CollectionEditor,
    _TextWithActionLinksMixin,

    // epi commerce
    CommerceMediaCollectionEditorModel,
    CommerceMediaItemModel,

    // Resources
    template,
    res
) {
    return declare([CollectionEditor, _TextWithActionLinksMixin, _FocusableMixin], {
        // module:
        //      epi-ecf-ui/contentediting/editors/commercemediacollectioneditor
        // summary:
        //      Editor widget for commerce media assets

        // _dndTarget: Function
        //      The dnd target area.
        _dndTarget: null,

        templateString: template,

        resources: res,

        gridOverlayClass: "epi-grid-dnd-overlay",

        _noDataMessage: '<span><span class="dijitReset dijitInline">' + res.nodatamessage + '</span></span>',

        // itemModelType: Function
        //      Item Model constructor.
        itemModelType: CommerceMediaItemModel,

        modelType: CommerceMediaCollectionEditorModel,

        // Set autofocus to false to prevent the validate the require fields when opening dialog. 
        dialogParams: { autofocus: false },

        _setupGrid: function () {
            // summary:
            //      Set up the grid.
            // tags:
            //      protected

            this.inherited(arguments);
            domClass.add(this.gridNode, "epi-plain-grid--margin-bottom epi-plain-grid--cell-borders");

            this._settingReadOnlyState();
        },

        postCreate: function () {
            // summary:
            //      Post create initialization.
            // description:
            //      Setup related components.
            // tags:
            //      protected

            this.inherited(arguments);

            this._dndTarget = new Target(this.dropContainer, {
                accept: this.allowedDndTypes,
                insertNodes: function () { }
            });

            this.own(aspect.after(this._dndTarget, "onDropData", lang.hitch(this, this.onDndDrop), true));

            domClass.add(this.domNode, "epi-media-collection");
            this.setupActionLinks(this.dropContainer);
        },

        _settingReadOnlyState: function () {
            if (this.readOnly) {
                // For dnd
                domStyle.set(this.dropContainer, "display", "none");
                domClass.remove(this.overlayDnd, this.gridOverlayClass);

                // For grid
                this.grid.set("selectionMode", "none");
                this.allowedDndTypes = [];
                this.gridSettings.dndDisabled = true;
                this.model.availableCommands = 0;
            }
        },

        _getDialogTitleText: function(existingItem){
            return !existingItem ? res.addlabel : res.editlabel;
        },

        getTemplateString: function () {
            // summary:
            //      The template string for drop area
            // tags:
            //      protected

            return {
                templateString: this.resources.drophere,
                actions: this.resources.actions
            };
        },

        executeAction: function (actionName) {
            // summary:
            //      Called when [items] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/tools/toggle", true);
        },

        _getGridDefinition: function () {
            // summary:
            //      Returns grid's columns definition.
            // tags:
            //      private

            var columns = this.generateColumns ?
                this.model.generateColumnsDefinition(this.excludedColumns) : // If auto generate is on, ask model to compute columns definition.
                this.includedColumns || {}; // Otherwise, use configured ones.

            if (this.readOnly)
            {
                for (var columnName in columns) {
                    lang.setObject("sortable", false, columns[columnName]);
                }
            }

            return this.model.generateFormatters(columns);
        },

        _setupDnD: function () {
            // summary:
            //      Set up the dnd on the grid.
            // tags:
            //      private
            this.inherited(arguments);
            var dndSource = this.grid.dndSource;

            this.own(aspect.after(dndSource, "onDndStart", lang.hitch(this, function (source, nodes, copy) {
                var accepted = dndSource.accept && dndSource.checkAcceptance(source, nodes);
                domClass[accepted ? "add" : "remove"](this.overlayDnd, this.gridOverlayClass);
            }), true));
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/model/CommerceMediaCollectionEditorModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    // epi
    "epi/shell/command/DelegateCommand",
    "epi-cms/contentediting/editors/model/CollectionEditorModel",
    "epi-cms/dgrid/formatters",
    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.commercemediacollectioneditor"
], function (
    array,
    declare,
    lang,
    Deferred,
     // epi
    DelegateCommand,
    CollectionEditorModel,
    formatters,
    // Resources
    res
) {
    return declare([CollectionEditorModel], {

        addItem: function (item, refItem, before) {
            var items = this.get("items");
            if (!items || items.length < 1) {
                return this.inherited(arguments);
            }

            // check if adding item is existed, to move it to top
            // instead of adding duplicated item.
            var itemIdentifier = item.permanentUrl || item.assetKey;
            var existingItem;
            array.some(items, function (oldItem) {
                if (oldItem && oldItem.assetKey === itemIdentifier) {
                    existingItem = oldItem;
                    return true;
                }
            });
            if (existingItem) {
                var def = new Deferred();
                this.moveItem(existingItem, refItem || existingItem, before || true);
                def.resolve();
                return def;
            } else {
                return this.inherited(arguments);
            }
        },

        getListCommands: function (availableCommands) {
            // summary:
            //      get list commands from avaible commands
            // tags:
            //      protected
            return [
                new DelegateCommand({
                    name: "add",
                    label: res.addlabel,
                    iconClass: "epi-iconPlus",
                    canExecute: true,
                    isAvailable: true,
                    delegate: lang.hitch(this, this.addItemDelegate)
                })
            ];
        },

        generateFormatters: function (columnDefinitions) {
            // summary:
            //      Generate formatters for the specified column definitions.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags:
            //      public

            var thumbnailFormatter = function (value) {
                return [formatters.thumbnail(value)];
            };

            for (var columnName in columnDefinitions) {
                if (columnDefinitions[columnName].isThumbnail) {
                    columnDefinitions[columnName].formatter = thumbnailFormatter;

                    break;
                }
            }
            
            return columnDefinitions;
        }
    });
});
},
'epi-ecf-ui/component/CommerceMediaItemModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/Stateful",
    "dojo/when",

// EPi Framework
    "epi/dependency",

// EPi CMS
    "epi-cms/contentediting/editors/model/CollectionEditorItemModel",
    "epi-cms/core/PermanentLinkHelper"

], function (

// Dojo
    array,
    declare,
    lang,
    Deferred,
    Stateful,
    when,

// EPi Framework
    dependency,

// EPi CMS
    CollectionEditorItemModel,
    PermanentLinkHelper
) {

    return declare([CollectionEditorItemModel, Stateful], {
        // summary:
        //      The commerce media item model.
        // module:
        //      "epi-ecf-ui/component/commercemediaitemmodel"
        // description:
        //      That supports: edit, delete, create commerce media link
        // tags:
        // public

        fromItemData: function (itemData) {
            // summary:
            //      Create item model object from raw item data.
            // itemData: Object
            //      The raw item data.
            // tags:
            //      public

            var df = new Deferred();

            itemData.assetKey = itemData.assetKey || itemData.permanentUrl;

            when(PermanentLinkHelper.getContent(itemData.assetKey), lang.hitch(this, function (content) {

                if (content) {
                    itemData.thumbnailUrl = content.thumbnailUrl;
                    itemData.assetName = content.name;
                    itemData.assetKey = PermanentLinkHelper.toPermanentLink(content);
                    itemData.assetType = itemData.assetType || content.typeIdentifier;
                }

                //set default value for groupname and sortorder
                itemData.groupName = itemData.groupName || "default";
                itemData.sortOrder = itemData.sortOrder || 0;

                lang.mixin(this, itemData);
                this._itemData = itemData;

                df.resolve(this);
            }));

            return df;
        }

    });
});
},
'url:epi-ecf-ui/contentediting/editors/templates/CommerceMediaEditor.html':"﻿<div class=\"dijitInline\" style=\"width: 100%;\">    \r\n    <div data-dojo-attach-point=\"commandTargetNode\"></div>\r\n    <div data-dojo-attach-point=\"overlayDnd\">\r\n        <div data-dojo-attach-point=\"gridNode\"></div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"dropContainer\" class=\"epi-content-area-actionscontainer\"></div>\r\n</div>\r\n",
'epi-ecf-ui/widget/overlay/CommerceMediaCollection':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

// EPi CMS
    "epi-cms/widget/overlay/ItemCollection",

// EPi Framework
    "epi/string",

// EPi Commerce
    "../../component/CommerceMediaItemModel"
], function (
// Dojo
    declare,
    lang,
    when,

// EPi CMS
    ItemCollectionOverlay,

// EPi Framework
    epiString,

// EPi Commerce
    CommerceMediaItemModel
) {
    return declare([ItemCollectionOverlay], {
        // summary:
        //      The new overlay item for commerce media collection.
        // module:
        //      "epi-ecf-ui/widget/overlay/CommerceMediaCollection"
        // description:
        //      Drag and drop media to create new asset item (at the very top)
        // tags:
        //    public

        // modelType: [public] String
        //      Used to inject model for this.
        modelType: "epi-ecf-ui/contentediting/editors/model/CommerceMediaCollectionEditorModel",

        onDrop: function (target, value) {
            // summary:
            //      Handles onDrop and add new value to model then raise onValueChange event to save this.
            // target: [Object]
            //      The dnd target.
            // value: [Object || Array]
            //      The dnd data.
            // tags:
            //      private

            // insert new item at the very top
            var topItem = null,
                modelData = this.model.get("items");
            if (modelData) {
                topItem = modelData[0];
            }
            when(this.model.addItem(value, topItem, true), lang.hitch(this, function () {
                var items = this.model.get("data");
                this.onValueChange({
                    propertyName: this.name,
                    value: items
                });
            }));
        },

        _setupModel: function (/*Object*/data) {
            // summary:
            //      setup the viewmodel with latest value
            // tag:
            //      public

            var modelType = epiString.slashName(this.modelType);

            require([modelType], lang.hitch(this, function (modelClass) {
                var modelData = { };
                // set itemModel as Commerce media item model
                modelData.itemModelType = CommerceMediaItemModel;
                // set itemType as Commerce media
                modelData.itemType = "EPiServer.Commerce.Shell.ObjectEditing.InternalMetadata.CommerceMediaModel";
                this.model = new modelClass(modelData, this.modelParams);
                this.model.set("data", data); // set model data
            }));
        },

        _setupAllowedTypes: function () {
            // summary:
            //      Setup the allowed types for drag and drop
            // tags:
            //      Protected

            var converterKey = this.modelParams.itemConverterKey,
                customTypeIdentifier = this.modelParams.customTypeIdentifier;

            this.allowedDndTypes = this.allowedDndTypes || [];

            if (converterKey) {
                customTypeIdentifier = customTypeIdentifier + "." + converterKey;
            }

            if (customTypeIdentifier) {
                // add this commerce media type to the list of allowed DnD type
                this.allowedDndTypes.unshift(customTypeIdentifier);
            }
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/InventoryCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    // epi commerce
    "./ReadOnlyCollectionEditor",

    "../viewmodel/InventoryCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,

    // epi commerce
    ReadOnlyCollectionEditor,

    InventoryCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/InventoryCollectionEditor
        // summary:
        //      Represents the Read-only editor widget for product's inventory list.

        modelType: InventoryCollectionEditorModel
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/InventoryCollectionEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "./ReadOnlyCollectionEditorModel"
],
function (
    //dojo
    declare,
    lang,

    ReadOnlyCollectionEditorModel
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module: 
        //      epi-ecf-ui/contentediting/viewmodel/InventoryCollectionEditorModel
        // summary:
        //      Represents the model for InventoryCollectionEditor

        _storeKey: "epi.commerce.inventory"
    });
});
},
'epi-ecf-ui/contentediting/editors/PriceCollectionReadOnlyEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",

    // epi commerce
    "./ReadOnlyCollectionEditor",
    "../viewmodel/PriceCollectionReadOnlyEditorModel",
        
    // Resources
    "epi/i18n!epi/cms/nls/commerce.components.catalogs.commands"
],
function (
    //dojo
    declare,

    // epi commerce
    ReadOnlyCollectionEditor,
    PriceCollectionReadOnlyEditorModel,
    
    res
) {
    return declare([ReadOnlyCollectionEditor], {
        // module: 
        //      epi-ecf-ui/contentediting/editors/PriceCollectionReadOnlyEditor
        // summary:
        //      Represents the Read-only editor widget for product's price list.

        iconClass: "epi-iconPricing",

        modelType: PriceCollectionReadOnlyEditorModel,
        
        changeToView: "pricingview",
        
        buttonLabel: res.previewprice
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/PriceCollectionReadOnlyEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/currency",

    "epi/datetime",

    "./ReadOnlyCollectionEditorModel",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.widget.pricecollection.message"
],
function (
    //dojo
    declare,
    lang,
    currency,

    epiDate,

    ReadOnlyCollectionEditorModel,

    // Resources
    res
) {
    return declare([ReadOnlyCollectionEditorModel], {
        // module:
        //      epi-ecf-ui/contentediting/viewmodel/PriceCollectionReadOnlyEditorModel
        // summary:
        //      Represents the model for PriceCollectionReadOnlyEditor

        _storeKey: "epi.commerce.price",

        res: res,

        generateFormatters: function (columnDefinitions) {
            // summary:
            //      Generate formatters for the specified column definitions.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags:
            //      override

            this.inherited(arguments);
            columnDefinitions.validDate.formatter = lang.hitch(this, this._formatValidDate);
            columnDefinitions.unitPrice.formatter = function(value) {
                return currency.format(value.amount, { currency: value.currency });
            };
            return columnDefinitions;
        },

        _formatValidDate: function (value) {
            // Format datetime
            return this._formatDate(value.validFrom) + " - " + this._formatDate(value.validUntil);
        },

        _formatDate: function (datetime) {
            // summary:
            //      Format datetime to short type.
            // datetime: Object
            //      The raw data.
            // tags:
            //      public

            return datetime && datetime !== "" ? epiDate.toUserFriendlyString(datetime) : this.res.untildatenotdefined;
        },

        createQuery: function (referenceId) {
            return { referenceId: referenceId, query: "readonlyprices" };
        }
    });
});
},
'dojo/currency':function(){
define("dojo/currency", [
	"./_base/array",
	"./_base/lang",
	/*===== "./_base/declare", =====*/
	"./number",
	"./i18n", "./i18n!./cldr/nls/currency",
	"./cldr/monetary"
], function(darray, lang, /*===== declare, =====*/ dnumber, i18n, nlsCurrency, cldrMonetary){

// module:
//		dojo/currency

var currency = {
	// summary:
	//		localized formatting and parsing routines for currencies
	// description:
	//		extends dojo.number to provide culturally-appropriate formatting of values
	//		in various world currencies, including use of a currency symbol.  The currencies are specified
	//		by a three-letter international symbol in all uppercase, and support for the currencies is
	//		provided by the data in `dojo.cldr`.  The scripts generating dojo.cldr specify which
	//		currency support is included.  A fixed number of decimal places is determined based
	//		on the currency type and is not determined by the 'pattern' argument.  The fractional
	//		portion is optional, by default, and variable length decimals are not supported.
};
lang.setObject("dojo.currency", currency);

currency._mixInDefaults = function(options){
	options = options || {};
	options.type = "currency";

	// Get locale-dependent currency data, like the symbol
	var bundle = i18n.getLocalization("dojo.cldr", "currency", options.locale) || {};

	// Mixin locale-independent currency data, like # of places
	var iso = options.currency;
	var data = cldrMonetary.getData(iso);

	darray.forEach(["displayName","symbol","group","decimal"], function(prop){
		data[prop] = bundle[iso+"_"+prop];
	});

	data.fractional = [true, false];

	// Mixin with provided options
	return lang.mixin(data, options);
};

/*=====
currency.__FormatOptions = declare([dnumber.__FormatOptions], {
	// type: String?
	//		Should not be set.  Value is assumed to be "currency".
	// symbol: String?
	//		localized currency symbol. The default will be looked up in table of supported currencies in `dojo.cldr`
	//		A [ISO4217](http://en.wikipedia.org/wiki/ISO_4217) currency code will be used if not found.
	// currency: String?
	//		an [ISO4217](http://en.wikipedia.org/wiki/ISO_4217) currency code, a three letter sequence like "USD".
	//		For use with dojo.currency only.
	// places: Number?
	//		number of decimal places to show.  Default is defined based on which currency is used.
	type: "",
	symbol: "",
	currency: "",
	places: ""
});
=====*/

currency.format = function(/*Number*/ value, /*__FormatOptions?*/ options){
	// summary:
	//		Format a Number as a currency, using locale-specific settings
	//
	// description:
	//		Create a string from a Number using a known, localized pattern.
	//		[Formatting patterns](http://www.unicode.org/reports/tr35/#Number_Elements)
	//		appropriate to the locale are chosen from the [CLDR](http://unicode.org/cldr)
	//		as well as the appropriate symbols and delimiters and number of decimal places.
	//
	// value:
	//		the number to be formatted.

	return dnumber.format(value, currency._mixInDefaults(options));
};

currency.regexp = function(/*dnumber.__RegexpOptions?*/ options){
	//
	// summary:
	//		Builds the regular needed to parse a currency value
	//
	// description:
	//		Returns regular expression with positive and negative match, group and decimal separators
	//		Note: the options.places default, the number of decimal places to accept, is defined by the currency type.
	return dnumber.regexp(currency._mixInDefaults(options)); // String
};

/*=====
var __ParseOptions = currency.__ParseOptions = declare(dnumber.__ParseOptions, {
	// type: String?
	//		Should not be set.  Value is assumed to be currency.
	// currency: String?
	//		an [ISO4217](http://en.wikipedia.org/wiki/ISO_4217) currency code, a three letter sequence like "USD".
	//		For use with dojo.currency only.
	// symbol: String?
	//		localized currency symbol. The default will be looked up in table of supported currencies in `dojo.cldr`
	//		A [ISO4217](http://en.wikipedia.org/wiki/ISO_4217) currency code will be used if not found.
	// places: Number?
	//		fixed number of decimal places to accept.  The default is determined based on which currency is used.
	// fractional: Boolean|Array?
	//		Whether to include the fractional portion, where the number of decimal places are implied by the currency
	//		or explicit 'places' parameter.  The value [true,false] makes the fractional portion optional.
	//		By default for currencies, it the fractional portion is optional.
});
=====*/

currency.parse = function(/*String*/ expression, /*__ParseOptions?*/ options){
	//
	// summary:
	//		Convert a properly formatted currency string to a primitive Number,
	//		using locale-specific settings.
	// description:
	//		Create a Number from a string using a known, localized pattern.
	//		[Formatting patterns](http://www.unicode.org/reports/tr35/#Number_Format_Patterns)
	//		are chosen appropriate to the locale, as well as the appropriate symbols and delimiters
	//		and number of decimal places.
	// expression:
	//		A string representation of a currency value

	return dnumber.parse(expression, currency._mixInDefaults(options));
};

return currency;
});

},
'dojo/cldr/monetary':function(){
define("dojo/cldr/monetary", ["../_base/kernel", "../_base/lang"], function(dojo, lang){

// module:
//		dojo/cldr/monetary

var monetary = {
	// summary:
	//		TODOC
};
lang.setObject("dojo.cldr.monetary", monetary);

monetary.getData = function(/*String*/ code){
	// summary:
	//		A mapping of currency code to currency-specific formatting information. Returns a unique object with properties: places, round.
	// code:
	//		an [ISO 4217](http://en.wikipedia.org/wiki/ISO_4217) currency code

	// from http://www.unicode.org/cldr/data/common/supplemental/supplementalData.xml:supplementalData/currencyData/fractions

	var placesData = {
		ADP:0,AFN:0,ALL:0,AMD:0,BHD:3,BIF:0,BYR:0,CLF:0,CLP:0,
		COP:0,CRC:0,DJF:0,ESP:0,GNF:0,GYD:0,HUF:0,IDR:0,IQD:0,
		IRR:3,ISK:0,ITL:0,JOD:3,JPY:0,KMF:0,KPW:0,KRW:0,KWD:3,
		LAK:0,LBP:0,LUF:0,LYD:3,MGA:0,MGF:0,MMK:0,MNT:0,MRO:0,
		MUR:0,OMR:3,PKR:0,PYG:0,RSD:0,RWF:0,SLL:0,SOS:0,STD:0,
		SYP:0,TMM:0,TND:3,TRL:0,TZS:0,UGX:0,UZS:0,VND:0,VUV:0,
		XAF:0,XOF:0,XPF:0,YER:0,ZMK:0,ZWD:0
	};

	var roundingData = {CHF:5};

	var places = placesData[code], round = roundingData[code];
	if(typeof places == "undefined"){ places = 2; }
	if(typeof round == "undefined"){ round = 0; }

	return {places: places, round: round}; // Object
};

return monetary;
});

},
'epi-ecf-ui/widget/CatalogContentList':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/window",
    "dojo/keys",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/html",
    "dojo/on",
    "dojo/topic",
    "dojo/when",
    "dojo/dom-class",
//Dgrid
    "dgrid/selector",

// EPi Shell
    "epi",
    "epi/shell/dgrid/util/misc",
    "epi/dependency",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/command/builder/ButtonBuilder",

// EPi CMS
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ConfigurableContentListBase",
    "epi-cms/widget/ContentTreeStoreModel",

// commerce
    "./viewmodel/CatalogContentListViewModel",
    "./CommandToolbar",
    "./CommandButton",
    "./MarketSelector",

// Resources
    "dojo/text!./templates/CatalogContentList.html",
    "epi/i18n!epi/cms/nls/commerce.widget.cataloglist",
    "epi/i18n!epi/cms/nls/commerce.widget.catalogcontentlist"
], function (
// Dojo
    array,
    aspect,
    declare,
    lang,
    window,
    keys,
    domConstruct,
    domGeometry,
    domStyle,
    html,
    on,
    topic,
    when,
    domClass,
//Dgrid
    selector,
// EPi Shell
    epi,
    misc,
    dependency,
    _FocusableMixin,
    ButtonBuilder,

// EPi CMS
    ContentReference,
    ContentActionSupport,
    formatters,
    _ConfigurableContentListBase,
    ContentTreeStoreModel,

// commerce
    CatalogContentListViewModel,
    CommandToolbar,
    CommandButton,
    MarketSelector,
// Resources
    template,
    res,
    catalogContentListResources) {

    return declare([_ConfigurableContentListBase, _FocusableMixin], {
        // summary:
        //    Lists the content of catalogs and categories.
        // description:
        //    This is the widget that lists the content of catalogs and categories.
        // tags:
        //    public
        resources: catalogContentListResources,

        templateString: template,

        _multipleSelectionClassName: "epi-dgrid-multiselect--multiple-selection",

        storeKeyName: "epi.cms.content.light",

        _noDataMessage: catalogContentListResources.nodatamessage,

        // contextChangeEvent: [public] String
        //      Setup so that the context change events are not configured in the base class.
        contextChangeEvent: "",

        commandToolbar: null,

        // Shown thumbnails as default
        toggleThumbnail: true,

        postCreate: function () {
            this.inherited(arguments);

            // Watching instead of binding since we need the old value as well
            this.own(
                this.model.clipboardManager.watch("data", lang.hitch(this, function (name, oldValues, newValues) {
                    var isCopy = this.model.clipboardManager.isCopy(),
                        grid = this.grid;

                    var toggleCut = function (items, isCut) {
                        array.forEach(items, function (clip) {
                            var row;
                            if (clip && clip.data) {
                                var rowId = clip.contextId.concat("-", clip.data.contentLink);
                                row = grid.row(rowId);
                                if (row && row.element) {
                                    domClass.toggle(row.element, "epi-opacity50", isCut);
                                }
                            }
                        });
                    };

                    if (oldValues instanceof Array) {
                        toggleCut(oldValues, false);
                    }

                    if (!isCopy && newValues instanceof Array) {
                        toggleCut(newValues, true);
                    }
                }))
            );
        },

        startup: function () {
            // summary:
            //      Adds the breadcrumb widget to the top of the list widget.
            // tags:
            //      protected
            this.inherited(arguments);

            //only the selection column should update selections.
            this.grid.set("selectionMode", "none");

            //making the dragsource handle multiple selects
            this.grid.dndSource.singular = false;

            this.own(
                topic.subscribe("relationChanged", lang.hitch(this, function() {
                    this.grid.refresh();
                })),
                topic.subscribe("catalogContentDeleted", lang.hitch(this, function(deletedItems){
                    when(this.getCurrentContext(), lang.hitch(this, function(currentContext) {
                        var deletedItemIsChildToCurrentContent = array.some(deletedItems, function(item) {
                            return ContentReference.compareIgnoreVersion(currentContext.id, item.data.parentLink);
                        });
                        if (deletedItemIsChildToCurrentContent) {
                            this.grid.clearSelection();
                            this.onDeselectedRow();
                            this.grid.refresh();
                        }
                    }));
                })),
                topic.subscribe("itemPasted", lang.hitch(this, function () {
                    this.grid.refresh();
                }))
            );

            // grid can handle these, no need to "own" them
            this.grid.on("dgrid-rowcopy", lang.hitch(this, this._onRowCopy));
            this.grid.on("dgrid-rowcut", lang.hitch(this, this._onRowCut));
            this.grid.on("dgrid-rowpaste", lang.hitch(this, this._onRowPaste));
            this.grid.addKeyHandler(keys.ENTER, lang.hitch(this, "_onChangeContext"));
            this.grid.addKeyHandler(keys.SPACE, lang.hitch(this, function (evt) {
                var row = this.grid.row(evt);
                if (this.grid.isSelected(row)){
                    this.grid.deselect(row);
                } else {
                    this.grid.select(row);
                }
            }));
        },

        _onRowCopy: function () {
            this.model._commandRegistry.copy.command.execute();
        },

        _onRowCut: function () {
            this.model._commandRegistry.cut.command.execute();
        },

        _onRowPaste: function () {
            this.model._commandRegistry.pasteOnContext.command.execute();
        },

        _onSwitchListView: function () {
            if (this.toggleThumbnail) {
                this._onToggleThumbnail();
            }
        },

        _onSwitchThumbnail: function () {
            if (!this.toggleThumbnail) {
                this._onToggleThumbnail();
            }
        },

        _onToggleThumbnail: function () {
            this.toggleThumbnail = !this.toggleThumbnail;
            domClass.toggle(this.listview.domNode, "is-active");
            domClass.toggle(this.thumbnail.domNode, "is-active");

            domClass.toggle(this.grid.columns.thumbnail, "epi-hide-thumbnail");
            domClass.toggle(this.grid.columns.thumbnail.headerNode, "epi-hide-thumbnail");
            this.grid.refresh();
        },

        buildRendering: function() {
            this.baseClass = "epi-plain-grid epi-dgrid-multiselect";
            this.inherited(arguments);

            var commands = this.model.getSelectionCommands();
            this.commandToolbar = new CommandToolbar(commands);
            this.own(this.commandToolbar);
            domConstruct.place(this.commandToolbar.domNode, this.leadingNode);

            // listen for command toolbar's layout changed, to resize children (grid)
            this.own(aspect.after(this.commandToolbar, "layout", lang.hitch(this, function () {
                this.resize();
            })));
        },

        resize: function () {
            // summary:
            //		Resize this widget to the given dimensions.
            // tags:
            //		protected

            this.inherited(arguments);

            // make the grid 100% height
            if (this.grid) {
                this.grid.resize();
                var top = domGeometry.position(this.grid.domNode).y;
                var bodyHeight = domGeometry.position(window.body()).h;
                domStyle.set(this.grid.domNode, "height", (bodyHeight - top) + "px");
            }
        },

        setupEvents: function(){
            this.inherited(arguments);
            this.own(this.grid.on("dgrid-deselect", lang.hitch(this, this.onDeselectedRow)));
            this.own(this.grid.on(".epi-iconContextMenu:click", lang.hitch(this, this.onContextMenuClick)));

            var mouseup = lang.hitch(this, function (e) {
                this._isColumnDraggable = true;
            }),
            mousedown = lang.hitch(this, function (e) {
                this._isColumnDraggable = false;
            });
            for (var columnName in this.getColumnSettings()) {
                if (columnName === "checkbox") {
                    this.own(
                        // Use _isColumnDraggable to prevent checkbox column from dragging
                        this.grid.on(".dgrid-cell.dgrid-column-" + columnName + ":mousedown", mousedown),
                        // Reset dragging status
                        on(this.grid.domNode, "mouseup", mouseup)
                    );
                    continue;
                }
                this.own(this.grid.on(".dgrid-cell.dgrid-column-" + columnName + ":click", lang.hitch(this, "_onChangeContext")));
            }

            var self = this;
            aspect.around(this.grid.dndSource, "onMouseMove", function (originalMethod) {
                return function (e) {
                    // Cancel dragging if unable to drag
                    if (!self._isColumnDraggable) {
                        return;
                    }

                    return originalMethod.call(self.grid.dndSource, e);
                };
            });

        },

        onDeselectedRow: function(){
            var selection = [];
            for(var id in this.grid.selection){
                var row = this.grid.row(id);
                selection.push(row.data);
            }

            this.model.updateSelection(selection);
            this._removeContextMenuWhenRowIsSelected();
        },

        getListSettings: function () {
            // summary:
            //      Override to specify the settings used to create the list.
            // tags:
            //      protected

            var settings = this.inherited(arguments);

            return lang.mixin(settings, { cellNavigation: false, noDataMessage: this._noDataMessage });
        },

        _onSelect: function () {
            // summary:
            //		Extends _onSelect to remove context menu when multiple rows are selected
            // tags:
            //		protected

            this.inherited(arguments);
            this._removeContextMenuWhenRowIsSelected();
        },

        _removeContextMenuWhenRowIsSelected: function(){
            // summary:
            //		Removes context menu when multiple rows are selected
            // tags:
            //		protected

            domClass.remove(this.grid.contentNode, this._multipleSelectionClassName);

            if (this.model.numSelectedRows > 0) {
                domClass.add(this.grid.contentNode, this._multipleSelectionClassName);
            }
        },

        onContextMenuClick: function(e){
            // we have to update the commands even though we're technically not selecting this row.
            // Selection should only be done in the checkboxes column.
            var row = this.grid.row(e);
            this.model.set("model", { data: [row.data] });

            // Display arrow for menu item whenever have sub menu in context menu
            array.forEach(this.grid.contextMenu.getChildren(), function (menu, i) {
                if (menu.arrowWrapper && menu.popup) {
                    domStyle.set(menu.arrowWrapper, "visibility", "");
                }
            });
            this.grid.clearSelection();
            this.grid.select(row);
        },

        createModel: function () {
            return new CatalogContentListViewModel();
        },

        fetchData: function (context) {
            // summary:
            //		Fetches data by setting a query on the grid. A getrelations query will be performed on the store.
            // tags:
            //		protected

            this._setGridQuery(context.id);

            when(this.store.get(context.id), lang.hitch(this, function (contentData) {
                this.onDeselectedRow();

                var pasteOnContextCommand = this.model._commandRegistry.pasteOnContext.command;
                pasteOnContextCommand.selection.set("data", [{ type: "epi.cms.contentdata", data: contentData }]);
            }));

        },

        _setGridQuery: function(id){
            var queryOptions = { ignore: ["query"], parentId: id, sort: [{ attribute: "typeSortIndex" }] };

            var queryParameters = {
                referenceId: id,
                query: "getchildren",
                market: this.marketSelector.value,
                includeProperties: true,
                allLanguages: true
            };

            this.grid.set("query", queryParameters, queryOptions);
        },

        getColumnSettings: function () {
            // summary:
            //		Returns an object with the settings for the columns of the grid
            // tags:
            //		private
            var self = this;

            return {
                checkbox: selector({
                    label: "",
                    selectorType: "checkbox",
                    className: "epi-columnVeryNarrow"
                }),
                thumbnail: {
                    renderHeaderCell: function (node) {},
                    get: function (object) {
                        return object.properties.thumbnail;
                    },
                    formatter: formatters.thumbnail,
                    sortable: false
                },
                /* Name of column used in sorting - use typeSortIndex property, not typeIdentifier */
                typeSortIndex: {
                    renderHeaderCell: function (node) { },
                    get: function (object) {
                        return object.typeIdentifier;
                    },
                    formatter: formatters.contentIcon,
                    className: "epi-columnIcon16x16"
                },
                name: {
                    label: epi.resources.header.name,
                    className: "epi-columnWide"
                },
                code: {
                    get: function (object) {
                        return object.properties.code;
                    },
                    label: res.code
                },
                price: {
                    get: function (object) {
                        return object.properties.price;
                    },
                    label: res.price,
                    sortable: false
                },
                stock: {
                    get: function (object) {
                        return { count: object.properties.inStockQuantity, status: object.properties.inStockStatus};
                    },
                    label: res.stock,
                    formatter: this._getStockElement,
                    sortable: false
                },
                isPendingPublish: {
                    get: function (object) {
                        return object.status === ContentActionSupport.versionStatus.Published;
                    },
                    label: res.active,
                    formatter: formatters.friendlyBoolean,
                    className: "epi-columnNarrow"
                },
                startPublish: {
                    get: function (object) {
                        return object.properties.startPublish;
                    },
                    label: res.availablefrom,
                    formatter: this._localizedDateAndSecondaryText
                },
                stopPublish: {
                    get: function (object) {
                        return object.properties.stopPublish;
                    },
                    label: epi.resources.header.expires,
                    formatter: this._localizedDateAndSecondaryText
                },
                metaClassName: {
                    get: function (object) {
                        return object.properties.metaClassName;
                    },
                    label: res.producttype,
                    formatter: formatters.secondaryText
                }
            };
        },

        _getStockElement: function (stock) {
            if (stock.count === undefined || stock.count === null) {
                return "";
            }

            var stateCssClass = "epi-stock-" + stock.status;

            return '<span class="epi-stock ' + stateCssClass + '">' + stock.count + misc.icon('epi-iconBoxes') + '</span>';
        },

        _localizedDateAndSecondaryText: function (value) {
            return formatters.secondaryText(formatters.localizedDate(value), true);
        },

        _onMarketChanged: function(){
            if(!this.grid) return;
            var queryOptions = this.grid.get("queryOptions");
            if (queryOptions){
                this._setGridQuery(queryOptions.parentId);
            }
        }
    });
});

},
'dgrid/selector':function(){
define("dgrid/selector", ["dojo/_base/kernel", "dojo/_base/array", "dojo/on", "dojo/aspect", "dojo/_base/sniff", "put-selector/put"],
function(kernel, arrayUtil, on, aspect, has, put){
	return function(column, type){
		
		var listeners = [],
			grid, headerCheckbox;
		
		if(!column){ column = {}; }
		
		if(column.type){
			column.selectorType = column.type;
			kernel.deprecated("columndef.type", "use columndef.selectorType instead", "dgrid 0.4");
		}
		// accept type as argument to Selector function, or from column def
		column.selectorType = type = type || column.selectorType || "checkbox";
		column.sortable = false;

		function disabled(item) {
			return !grid.allowSelect(grid.row(item));
		}
		
		function changeInput(value){
			// creates a function that modifies the input on an event
			return function(event){
				var rows = event.rows,
					len = rows.length,
					state = "false",
					selection, mixed, i;
				
				for(i = 0; i < len; i++){
					var element = grid.cell(rows[i], column.id).element;
					if(!element){ continue; } // skip if row has been entirely removed
					element = (element.contents || element).input;
					if(element && !element.disabled){
						// only change the value if it is not disabled
						element.checked = value;
						element.setAttribute("aria-checked", value);
					}
				}
				if(headerCheckbox.type == "checkbox"){
					selection = grid.selection;
					mixed = false;
					// see if the header checkbox needs to be indeterminate
					for(i in selection){
						// if there is anything in the selection, than it is indeterminate
						if(selection[i] != grid.allSelected){
							mixed = true;
							break;
						}
					}
					headerCheckbox.indeterminate = mixed;
					headerCheckbox.checked = grid.allSelected;
					if (mixed) {
						state = "mixed";
					} else if (grid.allSelected) {
						state = "true";
					}
					headerCheckbox.setAttribute("aria-checked", state);
				}
			};
		}
		
		function onSelect(event){
			// we would really only care about click, since other input sources, like spacebar
			// trigger a click, but the click event doesn't provide access to the shift key in firefox, so
			// listen for keydown's as well to get an event in firefox that we can properly retrieve
			// the shiftKey property from
			if(event.type == "click" || event.keyCode == 32 || (!has("opera") && event.keyCode == 13) || event.keyCode === 0){
				var row = grid.row(event),
					lastRow = grid._lastSelected && grid.row(grid._lastSelected);

				grid._selectionTriggerEvent = event;
				
				if(type == "radio"){
					if(!lastRow || lastRow.id != row.id){
						grid.clearSelection();
						grid.select(row, null, true);
						grid._lastSelected = row.element;
					}
				}else{
					if(row){
						if(event.shiftKey){
							// make sure the last input always ends up checked for shift key 
							changeInput(true)({rows: [row]});
						}else{
							// no shift key, so no range selection
							lastRow = null;
						}
						lastRow = event.shiftKey ? lastRow : null;
						grid.select(lastRow || row, row, lastRow ? undefined : null);
						grid._lastSelected = row.element;
					}else{
						// No row resolved; must be the select-all checkbox.
						put(this, (grid.allSelected ? "!" : ".") + "dgrid-select-all");
						grid[grid.allSelected ? "clearSelection" : "selectAll"]();
					}
				}
				grid._selectionTriggerEvent = null;
			}
		}
		
		function setupSelectionEvents(){
			// register one listener at the top level that receives events delegated
			grid._hasSelectorInputListener = true;
			listeners.push(grid.on(".dgrid-selector:click,.dgrid-selector:keydown", onSelect));
			var handleSelect = grid._handleSelect;
			grid._handleSelect = function(event){
				// ignore the default select handler for events that originate from the selector column
				if(this.cell(event).column != column){
					handleSelect.apply(this, arguments);
				}
			};
			
			// Set up disabled and grid.allowSelect to match each other's behaviors
			if(typeof column.disabled == "function"){
				var originalAllowSelect = grid.allowSelect,
					originalDisabled = column.disabled;

				// Wrap allowSelect to consult both the original allowSelect and disabled
				grid.allowSelect = function(row){
					var allow = originalAllowSelect.call(this, row);

					if (originalDisabled === disabled) {
						return allow;
					} else {
						return allow && !originalDisabled.call(column, row.data);
					}
				};

				// Then wrap disabled to simply call the new allowSelect
				column.disabled = disabled;
			}else{
				// If no disabled function was specified, institute a default one
				// which honors allowSelect
				column.disabled = disabled;
			}
			// register listeners to the select and deselect events to change the input checked value
			listeners.push(grid.on("dgrid-select", changeInput(true)));
			listeners.push(grid.on("dgrid-deselect", changeInput(false)));
		}
		
		var renderInput = typeof type == "function" ? type : function(value, cell, object){
			var parent = cell.parentNode,
				disabled;
			
			if(!grid._hasSelectorInputListener){
				setupSelectionEvents();
			}
			
			// column.disabled gets initialized or wrapped in setupSelectionEvents
			disabled = column.disabled;

			// must set the class name on the outer cell in IE for keystrokes to be intercepted
			put(parent && parent.contents ? parent : cell, ".dgrid-selector");
			var input = cell.input || (cell.input = put(cell, "input[type="+type + "]", {
				tabIndex: isNaN(column.tabIndex) ? -1 : column.tabIndex,
				disabled: disabled && (typeof disabled == "function" ?
					disabled.call(column, object) : disabled),
				checked: value
			}));
			input.setAttribute("aria-checked", !!value);
			
			return input;
		};
		
		aspect.after(column, "init", function(){
			grid = column.grid;
		});
		
		aspect.after(column, "destroy", function(){
			arrayUtil.forEach(listeners, function(l){ l.remove(); });
			grid._hasSelectorInputListener = false;
		});
		
		column.renderCell = function(object, value, cell, options, header){
			var row = object && grid.row(object);
			value = row && grid.selection[row.id];
			renderInput(value, cell, object);
		};
		column.renderHeaderCell = function(th){
			var label = "label" in column ? column.label :
				column.field || "";
			
			if(type == "radio" || !grid.allowSelectAll){
				th.appendChild(document.createTextNode(label));
				if(!grid._hasSelectorInputListener){
					setupSelectionEvents();
				}
			}else{
				renderInput(false, th, {});
			}
			headerCheckbox = th.lastChild;
		};
		
		return column;
	};
});

},
'epi-cms/widget/_ConfigurableContentListBase':function(){
require({cache:{
'url:epi-cms/widget/templates/_ConfigurableContentListBase.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>"}});
﻿define("epi-cms/widget/_ConfigurableContentListBase", [
// Dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-geometry",

// Dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

// Dgrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/extensions/ColumnResizer",

// epi
    "epi",
    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/Keyboard", // in order to support short cut key for cut, copy and paste action on grid

// EPi CMS
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/widget/_ContentListBase",

// Resources
    "dojo/text!./templates/_ConfigurableContentListBase.html",

// Widgets in the template
    "epi-cms/contentediting/StandardToolbar"
], function (
// Dojo
    dojo,
    declare,
    lang,
    domGeometry,

// Dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

// Dgrid
    OnDemandGrid,
    Selection,
    ColumnResizer,

// epi
    epi,
    Formatter,
    Keyboard,

// EPi CMS
    DnD,
    formatters,
    WithContextMenu,
    _ContentListBase,

// Resources
    template) {

    return declare([_ContentListBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //    Base class for lists with different column needs
        // description:
        //    This is a base class that can be used to quickly create a list with different columns.
        // tags:
        //    public
        _gridClass: declare([OnDemandGrid, Formatter, Selection, DnD, Keyboard, WithContextMenu, ColumnResizer]),

        templateString: template,

        postCreate: function(){
            //need to set gridAttachNode before this.inherited because it's used in the base class
            this.gridAttachNode = this.gridNode;
            this.inherited(arguments);
        },

        getListSettings: function() {
            var columnSettings = this.getColumnSettings();
            var hasModelWithCommands = this.model && this.model.commands && this.model.commands.length > 0;

            if (hasModelWithCommands){
                //mixin the context menu column last.
                columnSettings = lang.mixin(columnSettings, {
                    contextMenu: {
                        renderHeaderCell: function(node) {},
                        formatter: function() {
                            return formatters.menu({
                                title: epi.resources.action.options
                            });
                        },
                        className: "epi-columnNarrow",
                        sortable: false
                    }
                });
            }
            return {
                columns: columnSettings,
                store: this.store
            };
        },

        getColumnSettings: function() {
            // summary:
            //      Override to create the column settings for the grid.
            // tags:
            //      protected
        },

        _onChangeContext: function(e) {
            var row = this.grid.row(e);
            if (row) {
                this._requestNewContext({ uri : row.data.uri }, { sender: this });
            }
        },

        resize: function (changeSize) {
            this.inherited(arguments);

            if (changeSize) {
                var height = changeSize.h - domGeometry.getMarginBox(this.toolbar.domNode).h;
                domGeometry.setContentSize(this.gridNode, { h: height });
            }
        },

        updateView: function (data, context) {
            // summary:
            //		This is called when the context has changed.
            // tags:
            //		public

            this.toolbar.update({
                currentContext: context,
                viewConfigurations: {
                    availableViews: data.availableViews,
                    viewName: data.viewName
                }
            });

            this.fetchData(context);
        }
    });
});
},
'epi/shell/dgrid/Keyboard':function(){
﻿define("epi/shell/dgrid/Keyboard", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dgrid/Keyboard"
],
function (
    declare,
    lang,
    on,
    dgridKeyboard
) {
    return declare([dgridKeyboard], {
        // summary:
        //      Introduced the custom keyboard handler for copy, cut and paste keyboard action for the grid.

        postMixInProperties: function () {
            // summary:
            //      Adds custom key map, in order to handler copy, cut and paste keyboard action for grid.
            // tags:
            //      Protected

            this.inherited(arguments);

            this.keyMap = lang.mixin(this.keyMap, this._createCustomKeyMap());
        },

        _createCustomKeyMap: function () {
            // summary:
            //      Returns custom key map, in order to handler copy, cut and paste keyboard action for grid.
            // tags:
            //      private

            return {
                67: function (event) { // C
                    if (this._isCtrlOrMetaKeyPressed(event)) this._doCopy(event);
                },
                99: function (event) { // c
                    if (this._isCtrlOrMetaKeyPressed(event)) this._doCopy(event);
                },
                88: function (event) { // X
                    if (this._isCtrlOrMetaKeyPressed(event)) this._doCut(event);
                },
                120: function (event) { // x
                    if (this._isCtrlOrMetaKeyPressed(event)) this._doCut(event);
                },
                86: function (event) { // V
                    if (this._isCtrlOrMetaKeyPressed(event)) this._doPaste(event);
                },
                118: function (event) { // v
                    if (this._isCtrlOrMetaKeyPressed(event)) this._doPaste(event);
                }
            };
        },

        _isCtrlOrMetaKeyPressed: function (event) {
            // summary:
            //      Checks if the Ctrl or Meta key is pressed
            // tags:
            //      private

            return event.ctrlKey || event.metaKey;
        },

        _doCopy: function (event) {
            on.emit(this.domNode, "dgrid-rowcopy", event);
        },

        _doCut: function (event) {
            on.emit(this.domNode, "dgrid-rowcut", event);
        },

        _doPaste: function (event) {
            on.emit(this.domNode, "dgrid-rowpaste", event);
        }
    });
});

},
'url:epi-cms/widget/templates/_ConfigurableContentListBase.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>",
'epi-ecf-ui/widget/viewmodel/CatalogContentListViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

// epi
    "epi/shell/ClipboardManager",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/selection",
    "epi/shell/command/withConfirmation",

// epi-cms
    "epi-cms/widget/ContentTreeModelConfirmation",
    "epi-cms/widget/CreateCommandsMixin",
    "epi-cms/component/command/ChangeContext",
    "epi-cms/command/NewContent",
    "epi-cms/command/CopyContent",
    "epi-cms/command/CutContent",
    "epi-cms/command/DeleteContent",
// commerce
    "./CatalogTreeStoreModel",
    "../../command/DetachFromCategory",
    "../../command/PasteCatalogContent",
    "../../component/DeleteCatalogContentHandler",

// resources
    "epi/i18n!epi/cms/nls/commerce.widget.catalogcontentlist",
    "epi/i18n!epi/nls/episerver.shared"
], function(
// dojo
    array,
    declare,
    lang,

// epi
    ClipboardManager,
    _CommandProviderMixin,
    Selection,
    withConfirmation,

// epi-cms
    ContentTreeModelConfirmation,
    CreateCommandsMixin,
    ChangeContextCommand,
    NewContent,
    CopyCommand,
    CutCommand,
    DeleteCommand,

// commerce
    CatalogTreeStoreModel,
    DetachFromCategory,
    PasteCatalogContent,
    DeleteCatalogContentHandler,

// resources
    resources,
    sharedresources
) {
    return declare([_CommandProviderMixin, CreateCommandsMixin], {

        model: null,

        treeStoreModel: null,

        res: resources,

        clipboardManager: null,

        selection: null,

        _commandRegistry: null,

        numSelectedRows: null,

        postscript: function(){
            this.clipboardManager = this.clipboardManager || new ClipboardManager();
            this.selection = this.selection || new Selection();
            this.repositoryKey = "catalog";
            this.inherited(arguments);
            this._setupCommands();       
        },

        getSelectionCommands: function() {
            return [
                this._commandRegistry.cut.command,
                this._commandRegistry.copy.command,
                this._commandRegistry.pasteOnContext.command,
                this._commandRegistry.detach.command,
                this._commandRegistry.remove.command
            ];
        },

        _setupCommands: function () {
            this.treeStoreModel = new CatalogTreeStoreModel();
            this.treeStoreModel.roots = this.roots;
            var modelWithConfirmation = ContentTreeModelConfirmation(this.treeStoreModel);

            var commandSettings = {
                category: "context",
                clipboard: this.clipboardManager,
                selection: this.selection,
                model: modelWithConfirmation
            };

            var toolbarGroupSettings = lang.mixin({ toolbarGroup: "clipboard" }, commandSettings);
            var deleteCommand = new DeleteCommand(lang.mixin({ model: this.treeStoreModel }, commandSettings));

            this._commandRegistry = lang.mixin(this.getCreateCommands(), {
                edit: {
                    command: new ChangeContextCommand({
                        category: "context",
                        forceContextChange: true,
                        viewName: "formedit"
                    }),
                    order: -1
                },
                cut: {
                    command: new CutCommand(toolbarGroupSettings),
                    order: 101
                },
                copy: {
                    command: new CopyCommand(toolbarGroupSettings),
                    order: 102
                },
                paste: {
                    command: new PasteCatalogContent(commandSettings),
                    order: 103
                },
                pasteOnContext: {
                    command: new PasteCatalogContent(lang.mixin(toolbarGroupSettings, { selection: new Selection() }))
                },
                detach: {
                    command: withConfirmation(new DetachFromCategory(commandSettings), null, {
                        title: this.res.detachconfirmation.title,
                        description: this.res.detachconfirmation.description
                    }),
                    order: 104
                },
                remove: {
                    command: withConfirmation(deleteCommand, DeleteCatalogContentHandler, {
                        title: this.res.deleteconfirmation.title,
                        description: this.res.deleteconfirmation.description,
                        confirmActionText: sharedresources.action.deletelabel,
                        cancelActionText: sharedresources.action.cancel
                    }),
                    order: 105
                },                
                sort: function () {
                    var commands = [];
                    for (var key in this) {
                        if (key !== "toArray" && key !== "sort" && this.hasOwnProperty(key) && key !== "pasteOnContext") {
                            var index = this[key].order;
                            if (!index) {
                                index = 100;
                            }
                            commands.push([index, this[key].command]);
                        }
                    }

                    commands.sort(function (a, b) {
                        return a[0] - b[0];
                    });

                    return commands;
                },
                toArray: function () {
                    var sortedCommand = this.sort();
                    var commands = [];
                    array.forEach(sortedCommand, function (key) {
                        commands.push(key[1]);
                    });

                    return commands;
                }
            });
            this.set("commands", this._commandRegistry.toArray());
        },

        _modelSetter: function(model) {
            this.model = model;
            var modelData = model;
            if (model && model.data) {
                modelData = model.data;
            }
            this._commandRegistry.edit.command.set("model", modelData);

            // set model for create commands, to update command's canExecute
            for (var cmd in this._commandRegistry) {
                var createCommand = this._commandRegistry[cmd].command || {};
                if (createCommand instanceof NewContent || createCommand.popup) {
                    createCommand.set("model", modelData);
                }
            }
            this.updateSelection(modelData);
        },

        updateSelection: function(selectionData){
            var selection = [];
            if (selectionData) {
                this.numSelectedRows = selectionData.length;
                selection = array.map(selectionData, function (item) {
                    return { type: "epi.cms.contentdata", data: item, contextId: this.model ? this.model.contextId : null };
                }, this);
            }

            if (this.selection) {
                this.selection.set("data", selection);
            }
        },

        destroy: function(){
            this.treeStoreModel.destroy();
            delete this.treeStoreModel;
        }
    });
});
},
'epi-ecf-ui/command/DetachFromCategory':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
    
// epi-shell
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Alert",

// epi-cms
    "epi-cms/core/ContentReference",

// epi-ecf-ui
    "../contentediting/ModelSupport",

// Resources
    "epi/i18n!epi/cms/nls/commerce.command.detachfromcategory"
],

function (
// dojo
    array,
    declare,
    lang,
    Deferred,
    promiseAll,
    topic,
    when,

// epi-shell
    dependency,
    _Command,
    _SelectionCommandMixin,
    TypeDescriptorManager,
    Alert,

// epi-cms
    ContentReference,

// epi-ecf-ui
    ModelSupport,

// Resources
    res
) {

    // module:
    //      epi-cms/command/PasteContent
    // summary:
    //      A command that pastes whats in the clip board onto the current selection.
    // tags:
    //      public

    return declare([_Command, _SelectionCommandMixin], {

        // label: [readonly] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        // categoryLink: String
        //      Optional. Definies what category the selection should be detached from.
        categoryLink: null,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconDetach",

        _store: null,

        postscript: function () {
            // summary:
            //      init registry and _store
            // tags:
            //      public override
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            this._store = this._store || registry.get("epi.commerce.relation");
        },

        _execute: function() {
            // summary:
            //      Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //      protected
            var categoryLink = this.categoryLink ||
                                when(this.model.currentContentService.getCurrentContext(), lang.hitch(this, function (currentContext) {
                                    return currentContext.id;
                                }));
            var nodeContentLink = new ContentReference(categoryLink).createVersionUnspecificReference();

            var deferreds = array.map(this.selection.data, function(selectionItem) {
                return when(this._store.query(this._getQuery(selectionItem.data.contentLink)), lang.hitch(this, function(relations) {
                    return promiseAll(array.map(relations, function(relation) {
                        var targetContentLink = new ContentReference(relation.target);
                        if (targetContentLink.id === nodeContentLink.id) {
                            return this._store.remove(relation.id).then(function(){
                                topic.publish("relationChanged", relation);
                            });
                        }
                    }, this));
                }));
            }, this);

            promiseAll(deferreds);
        },

        _onModelChange: function() {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var deferreds = [];
            var anythingSelected = this.selection.data.length > 0;
            array.forEach(this.selection.data, function(selectionItem) {
                var deferred = new Deferred();
                deferreds.push(deferred.promise);
                if (selectionItem.type !== "epi.cms.contentdata") {
                    deferred.resolve(false);
                }

                if (!this.isUsedByCollectionEditor) {
                    when(this.model.currentContentService.getCurrentContext(), lang.hitch(this, function (currentContext) {
                        if (ContentReference.compareIgnoreVersion(selectionItem.data.parentLink, currentContext.id)) {
                            deferred.resolve(false);
                        }
                    }));
                }

                when(this._store.query(this._getQuery(selectionItem.data.contentLink)), lang.hitch(this, function (relations) {

                    if (this._typeIsAssignableFrom(selectionItem.data.typeIdentifier, ModelSupport.contentTypeIdentifier.nodeContentBase)) {
                        deferred.resolve(relations.length > 0);
                    }
                    deferred.resolve(relations.length > 1);
                }));

            }, this);
            promiseAll(deferreds).then(lang.hitch(this, function (results) {
                var anyFailingSelections = array.some(results, function(result) {
                    return !result;
                });
                this.set("canExecute", anythingSelected && !anyFailingSelections);
            }));
        },

        _typeIsAssignableFrom: function (/*string*/ type, /*string*/ baseTypeToSupport) {
            return TypeDescriptorManager.isBaseTypeIdentifier(type, baseTypeToSupport);
        },

        _getQuery: function(contentLink) {
            return { referenceId: contentLink, relationTypes: [ModelSupport.relationType.node] };
        }
    });
});
},
'epi-ecf-ui/command/PasteCatalogContent':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    
// framework
    "epi/shell/TypeDescriptorManager",

// cms
    "epi-cms/command/PasteContent",

// epi-ecf-ui
    "../contentediting/ModelSupport"
],

function (
// dojo
    declare,
    
// framework
    TypeDescriptorManager,

// cms
    PasteContent,

// epi-ecf-ui
    ModelSupport
) {

    // module:
    //      epi-ecf-ui/command/PasteCatalogContent
    // summary:
    //      A command that pastes whats in the clip board onto the current selection.
    //      Inherits from the general content past command in cms, and changes behaviour when the command can be executed.
    // tags:
    //      public

    return declare([PasteContent], {

        typeDescriptorManager: TypeDescriptorManager,
        
        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var selectedData = this.get("selectionData");

            if (selectedData && this._typeIsAssignableFrom(selectedData.typeIdentifier, ModelSupport.contentTypeIdentifier.nodeContentBase)) {
                this.inherited(arguments);
                this.set("isAvailable", true);
                return;
            }

            this._hideCommand();
        },

        _typeIsAssignableFrom: function (/*string*/ type, /*string*/ baseTypeToSupport) {
            return this.typeDescriptorManager.isBaseTypeIdentifier(type, baseTypeToSupport);
        },

        _hideCommand: function() {
            this.set("isAvailable", false);
        }
    });

});
},
'epi-ecf-ui/widget/CommandToolbar':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "dijit/Toolbar",
    "dijit/layout/_LayoutWidget",
    "dijit/form/DropDownButton",
    "epi/shell/widget/_AddByDefinition"
], function (array, declare, lang, all, when, Toolbar, _LayoutWidget, DropDownButton, _AddByDefinition) {

    // Important: Mix in _LayoutWidget before Toolbar to get correct CSS classes from Toolbar
    return declare([_LayoutWidget, Toolbar, _AddByDefinition], {

        _commands: null,

        constructor: function(commands) {
            this._commands = commands;
        },

        buildRendering: function() {
            // summary:
            //      Constructs the toolbar container and starts the children setup process.
            // tags:
            //      protected

            this.inherited(arguments);

            // Setup the children items in the toolbar.
            when(this.setupChildren(), lang.hitch(this, function () {
                this.resize();
            }));
        },

        setupChildren: function() {
            // summary:
            //      Setup the items in the toolbar. Inheriting classes should extend this to add more items to the toolbar.
            // tags:
            //      protected

            var toolbarItems = [
            {
                name: "clipboard",
                type: "toolbargroup",
                parent: "leading",
                settings: {"class": "epi-groupedButtonContainer dijitInline" }
            }];

            toolbarItems = toolbarItems.concat(array.map(this._commands, function(command, index) {
                return {
                    name: "command" + index,
                    widgetType: "epi-ecf-ui/widget/CommandButton",
                    parent: command.toolbarGroup,
                    settings: { model: command, "class": "epi-flatButton epi-chromelessButton" },
                    title: command.label
                };
            }));

            return this.add(toolbarItems);        
        }
    });
});
},
'epi-ecf-ui/widget/CommandButton':function(){
define([
    "dojo/_base/declare",
    "dijit/form/Button",
    "epi/shell/command/_CommandModelBindingMixin"
], function (declare, Button, _CommandModelBindingMixin) {

    return declare([Button, _CommandModelBindingMixin]);
});
},
'epi-ecf-ui/widget/MarketSelector':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    // dijit
    "dijit/form/Select",
    // epi
    "epi/dependency"
], function(
    // dojo
    declare,
    // dijit
    Select,
    // epi
    dependency
) {
    return declare([Select], {

        keyProfileSetting: "market",
        addDefaultItem: true,
        excludeCurrencies: true,
        excludeInactive: true,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.labelAttr = "label";
            this.sortByLabel = false;
            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.commerce.market");
            this.query = { addDefaultItem: this.addDefaultItem, excludeCurrencies: this.excludeCurrencies, excludeInactive: this.excludeInactive };
        }
    });
});
},
'url:epi-ecf-ui/widget/templates/CatalogContentList.html':"﻿<div class=\"epi-catalogContentList\">\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div class=\"epi-localToolbar epi-flatToolbar\">\r\n        <div class=\"epi-toolbarGroupContainer\">\r\n            <div class=\"epi-toolbarGroup epi-toolbarLeading\" data-dojo-attach-point=\"leadingNode\"></div>\r\n            <div class=\"epi-toolbarGroup epi-toolbarCenter\" data-dojo-attach-point=\"centerNode\"></div>\r\n            <div class=\"epi-toolbarGroup epi-toolbarTrailing\" data-dojo-attach-point=\"trailingNode\">\r\n                <ul data-dojo-attach-point=\"trailingGroupButton\">\r\n                    <li class=\"epi-trailingCommand\">\r\n                        <div>\r\n                            <label for=\"markets\">${resources.market}</label>\r\n                            <select name=\"markets\" data-dojo-type=\"epi-ecf-ui/widget/MarketSelector\" data-dojo-attach-point=\"marketSelector\" data-dojo-attach-event='onChange: _onMarketChanged' class=\"epi-chromelessSelect epi-flatSelect\"></select>\r\n                        </div>\r\n                    </li>\r\n                    <li class=\"epi-trailingCommand\">\r\n                        <span data-dojo-type=\"epi-ecf-ui/widget/CommandButton\" data-dojo-attach-point=\"listview\" data-dojo-attach-event='onClick: _onSwitchListView' class=\"epi-flatButton epi-chromelessButton\"\r\n                                data-dojo-props=\"iconClass: 'epi-iconList', showLabel: false, title: '${resources.switchbuttons.listview}'\">\r\n                        </span>\r\n                        <span data-dojo-type=\"epi-ecf-ui/widget/CommandButton\" data-dojo-attach-point=\"thumbnail\" data-dojo-attach-event='onClick: _onSwitchThumbnail' class=\"epi-flatButton epi-chromelessButton is-active\"\r\n                                data-dojo-props=\"iconClass: 'epi-iconThumbnails', showLabel: false, title: '${resources.switchbuttons.thumbnail}'\">\r\n                        </span>\r\n                    </li>\r\n                </ul>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>",
'epi-ecf-ui/widget/CatalogList':function(){
﻿define([
// Dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/html",
    "dojo/topic",
    "dojo/dom-class",

// EPi Shell
    "epi",
    "epi/dependency",
    "epi/shell/widget/_FocusableMixin",

// EPi CMS
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ConfigurableContentListBase",
    "epi-cms/contentediting/ContentActionSupport",

// Resources
    "epi/i18n!epi/cms/nls/commerce.widget.cataloglist"
], function (
// Dojo
    dojo,
    declare,
    lang,
    html,
    topic,
    domClass,

// EPi Shell
    epi,
    dependency,
    _FocusableMixin,

// EPi CMS
    formatters,
    _ConfigurableContentListBase,
    ContentActionSupport,

// Resources
    res) {

    return declare([_ConfigurableContentListBase, _FocusableMixin], {
        // summary:
        //    Lists the content of the catalog root.
        // description:
        //    This is the widget that lists the content of the catalog root.
        // tags:
        //    public

        // contextChangeEvent: [public] String
        //      Configure click on a row to cause a context change.
        contextChangeEvent: "click",

        startup: function () {
            // summary:
            //      Adds the breadcrumb widget to the top of the list widget.
            // tags:
            //      protected
            this.inherited(arguments);

            this.own(topic.subscribe("relationChanged", lang.hitch(this, function () {
                this.grid.refresh();
            })));
        },

        buildRendering: function () {
            this.baseClass = "epi-plain-grid";
            this.inherited(arguments);
        },

        fetchData: function (context) {
            // summary:
            //		Fetches data by setting a query on the grid. A getrelations query will be performed on the store.
            // tags:
            //		protected

            var queryOptions = { ignore: ["query"], parentId: context.id, sort: [{ attribute: "name" }] };

            var queryParameters = {
                referenceId: context.id,
                query: "getchildren",
                includeProperties: true,
                allLanguages: true
            };

            this.grid.set("query", queryParameters, queryOptions);
        },

        getColumnSettings: function () {
            // summary:
            //		Returns an object with the settings for the columns of the grid
            // tags:
            //		private

            return {
                /* Name of column used in sorting - use typeSortIndex property, not typeIdentifier */
                typeSortIndex: {
                    renderHeaderCell: function (node) { },
                    get: function (object) {
                        return object.typeIdentifier;
                    },
                    formatter: formatters.contentIcon,
                    className: "epi-columnIcon16x16",
                    sortable: false,
                    renderCell: function (object, value, node, options) {
                        domClass.add(node, "epi-columnPadding--left");
                        node.innerHTML = formatters.contentIcon(value);
                    }
                },
                name: {
                    label: epi.resources.header.name,
                    className: "epi-columnWide"
                },
                language: {
                    get: function (object) {
                        return object.properties.defaultLanguage;
                    },
                    label: epi.resources.header.language,
                    sortable: false
                },
                currency: {
                    get: function (object) {
                        return object.properties.defaultCurrency;
                    },
                    label: epi.resources.header.currency,
                    sortable: false
                },
                baseWeight: {
                    get: function (object) {
                        return object.properties.weightBase;
                    },
                    label: res.baseweight,
                    sortable: false
                },
                isPendingPublish: {
                    get: function (object) {
                        return object.status === ContentActionSupport.versionStatus.Published;
                    },
                    label: res.active,
                    formatter: formatters.friendlyBoolean,
                    className: "epi-columnNarrow"
                },
                startPublish: {
                    get: function (object) {
                        return object.properties.startPublish;
                    },
                    label: res.availablefrom,
                    formatter: this._localizedDateAndSecondaryText
                },
                stopPublish: {
                    get: function (object) {
                        return object.properties.stopPublish;
                    },
                    label: epi.resources.header.expires,
                    formatter: this._localizedDateAndSecondaryText
                },
                owner: {
                    get: function (object) {
                        return object.properties.owner;
                    },
                    label: epi.resources.header.owner,
                    formatter: formatters.secondaryText,
                    sortable: false
                }
            };
        },

        _localizedDateAndSecondaryText: function (value) {
            return formatters.secondaryText(formatters.localizedDate(value), true);
        }
    });
});

},
'epi-ecf-ui/widget/LinkEdit':function(){
﻿define([
// dojo
    "dojo/_base/declare",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/TypeDescriptorManager",

// cms
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",

// commerce
    "../contentediting/editors/CategoryCollectionEditor",
    "../contentediting/editors/AssociationCollectionEditor",
    "../contentediting/ModelSupport",
    "./_RelationViewBase",
// Resources
    "dojo/text!./templates/LinkEdit.html",
// Widgets in the template
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/contentediting/StandardToolbar"
], function (
// dojo
    declare,

// dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

// EPi Framework
    _ModelBindingMixin,
    TypeDescriptorManager,

// CMS
    Breadcrumb,
    BreadcrumbCurrentItem,

// commerce
    CategoryCollectionEditor,
    AssociationCollectionEditor,
    ModelSupport,
    _RelationViewBase,
// Resources
    template
) {

    return declare([_RelationViewBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //    Represents the widget to edit relations and assiciations.
        // tags:
        //    public
        templateString: template,

        contentPane: this.contentPane,

        updateView: function (data, context) {
            // summary:
            //		Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //		protected

            this.inherited(arguments);

            this._setupAssociationsList(context);
            this.set("value", context.id);
        },

        _setupAssociationsList: function(context){
            if (TypeDescriptorManager.isBaseTypeIdentifier(context.dataType, ModelSupport.contentTypeIdentifier.entryContentBase)) {
                if (!this.associationList){
                    this.associationList = new AssociationCollectionEditor();
                    this.own(this.associationList);
                    this.associationList.placeAt(this.associationListNode);
                }
            } else {
                if (this.associationList){
                    this.associationList.destroy();
                    delete this.associationList;
                }
            }
        },

        _setValueAttr: function (value) {
            // summary:
            //      Sets value for this widget.
            // value: ContentReference
            //      Input content link to get data from.

            this.categoryList.set("value", value);
            if (this.associationList){
                this.associationList.set("value", value);
            }
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/CategoryCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/topic",
    // EPi Framework
    "epi/shell/widget/_FocusableMixin",
    // ecf-ui
    "./_RelationCollectionEditorBase",
    "../viewmodel/CategoryCollectionEditorModel",
    "./LinkEditEditor",
    "../ModelSupport",
    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.categorycollectioneditor"
],
function (
    //dojo
    declare,
    topic,
    // Epi Framework
    _FocusableMixin,
    // ecf-ui
    _RelationCollectionEditorBase,
    CategoryCollectionEditorModel,
    LinkEditEditor,
    ModelSupport,
    // Resources
    resources
) {
    var collectionEditor = declare([_RelationCollectionEditorBase, _FocusableMixin], {
        // module:
        //      epi-ecf-ui/contentediting/editors/RelationCollectionEditEditor
        // summary:
        //      Represents the Read-only editor widget for product's price overview list.

        modelType: CategoryCollectionEditorModel,

        allowedDndTypes: [ModelSupport.contentTypeIdentifier.nodeContent, ModelSupport.linkTypeIdentifier.relation],

        itemEditorTypes: [ModelSupport.contentTypeIdentifier.nodeContent],

        resources: resources,

        relationType: ModelSupport.relationType.node
    });

    return declare([LinkEditEditor], {

        resources: resources,

        gridCollectionType: collectionEditor,

        executeAction: function (actionName) {
            // summary:
            //      Called when [categories] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/navigation/toggle", true);
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/_RelationCollectionEditorBase':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-class",

    // dgrid
    "dgrid/Keyboard",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/extensions/ColumnResizer",
    "dgrid/extensions/ColumnReorder",

    // EPi Framework
    "epi/dependency",
    "epi/shell/dgrid/Formatter",

    // epi cms
    "epi-cms/contentediting/editors/CollectionEditor",
    "epi-cms/contentediting/editors/model/CollectionEditorModel",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/widget/ContentSelectorDialog",

    // commerce
    "./RelationCollectionGridAssembler",
    "../ModelSupport",
     "./LinkEditorDndMixin",
     "../../dgrid/_ClickablePathColumnMixin"
],
function (
    //dojo
    declare,
    lang,
    Deferred,
    when,
    aspect,
    domConstruct,
    domClass,

    // dgrid
    Keyboard,
    OnDemandGrid,
    Selection,
    ColumnResizer,
    ColumnReorder,

    // EPi Framework
    dependency,
    Formatter,

    // epi cms
    CollectionEditor,
    CollectionEditorModel,
    DnD,
    WithContextMenu,
    ContentSelectorDialog,

    // commerce
    RelationCollectionGridAssembler,
    ModelSupport,
    LinkEditorDndMixin,
    _ClickablePathColumnMixin
) {
    return declare([CollectionEditor, LinkEditorDndMixin], {
        // module:
        //      epi-ecf-ui/contentediting/editors/RelationCollectionEditEditor
        // summary:
        //      Represents the Read-only editor widget for product's price overview list.

        baseClass: "epi-relationCollectionEditor",

        /*jshint multistr: true */
        templateString: '<div>\
                            <div data-dojo-attach-point="commandTargetNode"></div>\
                            <div data-dojo-attach-point="overlayDnd">\
                                <div class="epi-associationCollectionEditor" data-dojo-attach-point="gridNode"></div>\
                            <div>\
                        </div>',

        resources: null,

        gridOverlayClass: "epi-grid-dnd-overlay",

        itemType: "EPiServer.Commerce.Shell.Rest.Models.RelationModel",

        itemEditorTypes: null,

        storeKey: "epi.commerce.relation",

        itemEditorType: ContentSelectorDialog,

        commands: CollectionEditorModel.commandMask.remove,

        gridAssemblerType: RelationCollectionGridAssembler,

        gridType: declare([OnDemandGrid, Formatter, Selection, Keyboard, DnD, ColumnResizer, ColumnReorder, WithContextMenu, _ClickablePathColumnMixin]),

        postMixInProperties: function() {
            // summary:
            //      init _store and gridSettings
            // tags:
            //      public override
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            this._store = this._store || registry.get(this.storeKey);

            if (!this.roots) {
                var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
                var settings = contentRepositoryDescriptors.catalog;
                this.roots = settings.roots;
            }

            this.gridSettings = lang.mixin(this.gridSettings || {}, {
                useDeleteWithConfirmation: true,
                dndSourceTypes: [ModelSupport.linkTypeIdentifier.relation],
                deleteConfirmationTitle: this.resources.deleteconfirmation.title,
                deleteConfirmationMessage: this.resources.deleteconfirmation.description
            });
        },

        _dndNodeCreator: function(/*Object*/item, /*Object*/hint) {
            var dndTypes = this.allowedDndTypes,
                node = domConstruct.create("div").appendChild(document.createTextNode(item.name));

            return {
                "node": node,
                "type": dndTypes,
                "data": item
            };
        },

        onExecuteDialog: function () {
            var contentLink = this._itemEditor.get("value");
            this.model.addItem(this._createItem(contentLink));
        },

        _renderNoDataMessage: function () {
            this.grid.set("noDataMessage", this.resources.nodatamessage);
            this.inherited(arguments);
        },


        _getDialogTitleText: function () {
            return this.resources.addlabel;
        },

        _createItemEditor: function () {
            return new this.itemEditorType({
                canSelectOwnerContent: false,
                showButtons: false,
                roots: this.roots,
                allowedTypes: this.itemEditorTypes,
                showAllLanguages: false
            });
        },

        _dndGetItemData: function (item) {
            return when(item.data, lang.hitch(this, function (data) {
                if (data) {
                    return this._createItem(data.contentLink, data.name);
                }
            }));
        },

        _createItem: function (targetLink, name) {
            return {
                name: name || targetLink,
                sortOrder: 0,
                source: this.model.get("data"),
                target: targetLink,
                type: this.relationType
            };
        },

        _setupDnD: function () {
            // summary:
            //      Set up the dnd on the grid.
            // tags:
            //      private
            this.inherited(arguments);
            this.setupDndActions(this.grid.dndSource, "checkAcceptance");

            this.own(aspect.after(this.grid.dndSource, "onDndStart", lang.hitch(this, function (source, nodes, copy) {
                var dndSource = this.grid.dndSource,
                                    accepted = dndSource.accept && dndSource.checkAcceptance(source, nodes);

                domClass[accepted ? "add" : "remove"](this.overlayDnd, this.gridOverlayClass);
            }), true));
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/RelationCollectionGridAssembler':function(){
﻿define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/when",
    // epi
    "epi/shell/selection",
    "epi/shell/command/builder/ButtonBuilder",
    // epi-cms
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/editors/DefaultGridAssembler"

],
function (
    //dojo
    array,
    declare,
    when,
    // epi
    selection,
    ButtonBuilder,
    // epi-cms
    _ContentContextMixin,
    DefaultGridAssembler
) {
    return declare([DefaultGridAssembler, _ContentContextMixin], {
        renderActionMenu: function(item, node, commands) {
            var builder = new ButtonBuilder({ settings: { showLabel: false } });
            array.forEach(commands, function(command) {
                builder.create(command, node);
            });
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/LinkEditorDndMixin':function(){
﻿define([
    //dojo
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    // EPi Framework
    "epi/shell/_ContextMixin",

    // epi-cms
    "epi-cms/core/ContentReference"
], function (
    //dojo
    aspect,
    declare,
    lang,
    // EPi Framework
    _ContextMixin,
    // epi-cms
    ContentReference) {

    return declare([_ContextMixin], {

        setupDndActions: function (dndSource, func ) {
            // summary:
            //      Sets Dnd actions.
            // 
            //  
            if (func === "checkAcceptance") {
                this.own(aspect.around(dndSource, func, lang.hitch(this, function (original) {
                    return lang.hitch(this, function (source, nodes) {
                        var items = nodes.map(function (node) {
                            return source.getItem(node.id).data.item;
                        });
                        var item = items[0];
                        //we assume _currentContext is resolved otherwise we'd need to use a deferred and it's not possible here
                        if (this._currentContext && item && ContentReference.compareIgnoreVersion(this._currentContext.id, item.contentLink)) {
                            return false;
                        }
                        return original.apply(dndSource, arguments);
                    });
                })));
            }
        }
    });
});
},
'epi-ecf-ui/dgrid/_ClickablePathColumnMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/topic",
    "epi/shell/DestroyableByKey"
], function(
    declare,
    lang,
    aspect,
    topic,
    DestroyableByKey
){
    return declare([DestroyableByKey], {

        postCreate: function(){
            this.inherited(arguments);
            this._setupClickablePathColumn();
        },

        _setupClickablePathColumn: function(){
            this.ownByKey("pathColumnClick", this.on(".dgrid-cell.dgrid-column-path:click", lang.hitch(this, function(event){
                    var row = this.row(event);
                    topic.publish("/epi/shell/context/request", { uri: "epi.cms.contentdata:///" + row.data.target },{sender: this });
                }))
            );
            for (var columnName in this.columns){
                if (columnName === "path"){
                    this.columns[columnName].className = "epi-ecf-uiPathLink";
                }
            }
        }
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/CategoryCollectionEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    
    // shell
    "epi/shell/selection",

    // epi-cms
    "epi-cms/contentediting/editors/model/CollectionEditorModel",

    // ecf
    "./CategoryCollectionReadOnlyEditorModel",
    "./_RelationCollectionEditorModelMixin",
    "../../command/DetachFromCategory",

    // Resources
    "epi/i18n!epi/nls/episerver.shared",
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.categorycollectioneditor"
],
function (
    //dojo
    declare,
    lang,
    topic,
    when,
    
    // shell
    selection,

    // epi-cms
    CollectionEditorModel,

    // ecf
    CategoryCollectionReadOnlyEditorModel,
    _RelationCollectionEditorModelMixin,
    DetachFromCategory,

    // Resources
    sharedResources,
    res
) {
    return declare([CategoryCollectionReadOnlyEditorModel, _RelationCollectionEditorModelMixin], {
        // module:
        //      epi-ecf-ui/contentediting/viewmodel/CategoryCollectionEditEditorModel
        // summary:
        //      Represents the model for RelationCollectionEditor

        res: res,

        getItemCommands: function (item, availableCommands, category) {
            var commands = this.inherited(arguments);

            if (commands) {
                for (var i = 0; i < commands.length; i++) {
                    if (commands[i].name === "remove") {
                        // Replace remove command with detach command
                        var removeCmd = commands[i];

                        var detachCmd = new DetachFromCategory({
                            name: removeCmd.name,
                            category: removeCmd.category,
                            label: removeCmd.label,
                            iconClass: removeCmd.iconClass,
                            selection: new selection(),
                            categoryLink: item.target,
                            isUsedByCollectionEditor: true
                        });
                        //Todo: move function out from for loop
                        /*jshint loopfunc:true */
                        when(this.getCurrentContent(), function(content) {
                            detachCmd.selection.data = [{ data: content, type: "epi.cms.contentdata" }];
                            detachCmd.set("model", {}); // This will trigger _onModelChange on the command.
                        });

                        commands[i] = detachCmd;
                    }
                }
            }
            return commands;
        },

        addItem: function (item, refItem, before) {
            return when(this.inherited(arguments), function(){
                topic.publish("relationChanged", item);
            });
        }
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/_RelationCollectionEditorModelMixin':function(){
﻿define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
    "dojo/_base/json",

     // dojox
     "dojox/html/entities",

    // epi
    "epi/shell/command/DelegateCommand",
    "epi/shell/widget/dialog/Alert",
    "epi/string",

    // epi cms
    "epi-cms/dgrid/formatters",

    // Resources
    "epi/i18n!epi/nls/episerver.shared"
],
function (
    //dojo
    array,
    declare,
    lang,
    promiseAll,
    topic,
    when,
    json,

     // dojox
    htmlEntities,

    // epi
    DelegateCommand,
    Alert,
    epistring,

    // epi cms
    formatters,

    // Resources
    sharedResources
) {
    
    return declare([], {

        // module:
        //      epi-ecf-ui/contentediting/viewmodel/_RelationCollectionEditorModelMixin
        // summary:
        //      Mixes in overrides of CollectionEditorModel, which can be used by a relation collection editor model to get save, move, remove functionality etz.

        res: null,

        postscript: function(){
            this.inherited(arguments);

            this.own(topic.subscribe("relationChanged", lang.hitch(this, this._refresh)));
        },

        generateColumnsDefinition: function () {
            // summary:
            //      Generate columns definition.
            // tags:
            //      public

            return {
                contentTypeIdentifier: {
                    label: "",
                    className: "epi-columnIcon16x16",
                    formatter: lang.hitch(this, formatters.contentIcon)
                },
                name: {
                    label: this.res.headings.name
                },
                path: {
                    label: this.res.headings.path
                }
            };
        },
        
        getItemCommands: function() {
            var commands = this.inherited(arguments);
            
            if (commands) {
                for (var i = 0; i < commands.length; i++) {
                    if (commands[i].name === "remove") {
                        commands[i].iconClass = "epi-iconClose";
                    }
                }
            }
            
            return commands;
        },

        getListCommands: function (availableCommands) {

            return [
                new DelegateCommand({
                    name: "add",
                    label: this.res.addlabel,
                    tooltip: sharedResources.action.add,
                    iconClass: "epi-iconPlus",
                    canExecute: true,
                    isAvailable: true,
                    delegate: lang.hitch(this, this.addItemDelegate)
                })
            ];
        },
             

        addItem: function (item, refItem, before) {
            var items = this.get("items");
            if (items && items.length > 0) {
                // check if adding item is existed, to move it to above
                // instead of adding duplicated item.
                var itemIdentifier = item.permanentUrl || item.target;
                var existingItem;
                array.some(items, function (oldItem) {
                    if (oldItem && oldItem.target === itemIdentifier) {
                        existingItem = oldItem;
                        return true;
                    }
                });

                if (existingItem) {
                    this.moveItem(existingItem, refItem || existingItem, before || true);
                    return this._refresh();
                }
            }

            // Set sort order before inherited to avoid including new items sort order in calculation
            this._setSortOrder(item, refItem, before);
            return when(this.inherited(arguments), lang.hitch(this, function () {
                return when(this._store.add(item), lang.hitch(this, function () {                    
                    return this._refresh();
                }),
                lang.hitch(this, function (error) {
                    return this._showNotification(error);
                }));
            }));
        },

              moveItem: function (item, refItem, before) {
            return when(this.inherited(arguments), lang.hitch(this, function () {
                this._setSortOrder(item, refItem, before);
                return when(this._store.put(item), lang.hitch(this, function () {
                    return this._refresh();
                }),
                lang.hitch(this, function (error) {
                    return this._showNotification(error);
                }));
            }));
        },

        removeItem: function (item) {
            return when(this.inherited(arguments), lang.hitch(this, function () {
                return when(this._store.remove(item.id), lang.hitch(this, function () {
                    return this._refresh();
                }),
                lang.hitch(this, function (error) {
                    return this._showNotification(error);
                }));
            }));           
        },

        saveItem: function (item, index) {
            return when(this.inherited(arguments), lang.hitch(this, function () {
                return when(this._store.put(item), lang.hitch(this, function () {
                    return this._refresh();
                }),
                lang.hitch(this, function (error) {
                    return this._showNotification(error);
                }));
            }));
        },

        _showNotification: function (error) {
            // summary:
            //      Uses the alert dialog implementation to notify with the error message

            if (error.status === 400) {
                var dialog = new Alert({
                    destroyOnHide: true,
                    description: epistring.toHTML(htmlEntities.encode(json.fromJson(error.xhr.responseText))),
                    onAction: lang.hitch(this, function () {
                        this._refresh();
                    })
                });
                dialog.show();
            }
        },

        _refresh: function () {
            // This will force a refresh of the grid.
            this.set("data", this.get("data"));
        },
        
        _setSortOrder: function(item, refItem, before) {
            if (refItem) {
                // Set sortOrder equal to refItem to place it before
                // The store will update sort index of any items after it
                item.sortOrder = before ? refItem.sortOrder : refItem.sortOrder + 1;
            } else {
                // Place last
                var items = this.get("items");
                var lastSortOrder = (items.length > 0) ? items[items.length - 1].sortOrder : 0;
                if (!item.sortOrder || lastSortOrder >= item.sortOrder) {
                    item.sortOrder = lastSortOrder + 100;
                }
            }
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/LinkEditEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",

    // EPi Framework
    "epi/shell/dnd/Target",
     
    // epi-cms
    "epi-cms/contentediting/editors/_TextWithActionLinksMixin",
    //epi_commerce
    "./LinkEditorDndMixin",

    // Resources
    "dojo/text!./templates/LinkEditEditor.html"
],
function (
    //dojo
    declare,
    lang,
    aspect,

    // dijit
    _Widget,
    _TemplatedMixin,

    // EPi Framework
    Target,
    
    // epi-cms
    _TextWithActionLinksMixin,
    //commerce
    LinkEditorDndMixing,
    // Resources
    template
) {
    return declare([_Widget, _TemplatedMixin, _TextWithActionLinksMixin, LinkEditorDndMixing], {

        templateString: template,

        gridCollectionType: null,

        gridCollection: null,

        _dndTarget: null,

        buildRendering: function () {
            this.inherited(arguments);

            this.gridCollection = this.gridCollectionType();

            this._dndTarget = new Target(this.dropContainer, {
                accept: this.gridCollection.allowedDndTypes,
                insertNodes: function () { }
            });
            
            this.own(aspect.after(this._dndTarget, "onDropData", lang.hitch(this, function (dndData) {
                this.gridCollection._addItem(dndData[0], true);
            }), true));

            this.setupDndActions(this._dndTarget, "checkAcceptance");
           
            this.own(this.gridCollection);
            this.collectionList.appendChild(this.gridCollection.domNode);
        },

        postCreate: function () {
            this.inherited(arguments);
            this.setupActionLinks(this.dropContainer);
        },

        getTemplateString: function () {
            // summary:
            //      The template string for drop area
            // tags:
            //      protected

            return {
                templateString: this.resources.drophere,
                actions: this.resources.actions
            };
        },

        updateView: function (data) {
            // summary:
            //		Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //		protected

            this.set("value", data.value);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Sets value for this widget.
            // value: ContentReference
            //      Input content link to get data from.

            this.gridCollection.set("value", value);
        }
    });
});

},
'url:epi-ecf-ui/contentediting/editors/templates/LinkEditEditor.html':"﻿<div class=\"epi-linkeditcollectionediteditor\">\r\n    <h1>${resources.title}</h1>\r\n    <div data-dojo-attach-point=\"collectionList\"></div>\r\n    <div data-dojo-attach-point=\"dropContainer\" class=\"epi-content-area-actionscontainer\"></div>\r\n</div>",
'epi-ecf-ui/contentediting/editors/AssociationCollectionEditor':function(){
﻿define([
// dojo
     "dojo/_base/array",
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/when",
    "dojo/topic",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",

// dgrid
    "dgrid/editor",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",

// epi
    "epi/shell/_ContextMixin",
    "epi/shell/dgrid/_EditorMetadataMixin",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/widget/dialog/Confirmation",
    "epi/dependency",
    "epi/string",

// epi cms
    "epi-cms/contentediting/editors/_AddItemDialogMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/dgrid/DnD",

// epi ecf
    "../viewmodel/AssociationCollectionEditorModel",
    "../../store/CompositeKey",
    "./LinkEditEditor",
    "./_CollectionEditorDndMixin",
     "../../dgrid/_ClickablePathColumnMixin",
    "../ModelSupport",

// resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.associationcollectioneditor",
    "epi/i18n!epi/nls/episerver.shared"
],
function (
// dojo
    array,
    aspect,
    declare,
    Deferred,
    domConstruct,
    lang,
    Stateful,
    when,
    topic,

// dijit
    _TemplatedMixin,
    _Widget,

// dgrid
    editor,
    Grid,
    Selection,

// epi
    _ContextMixin,
    _EditorMetadataMixin,
    _FocusableMixin,
    _ModelBindingMixin,
    ButtonBuilder,
    Confirmation,
    dependency,
    epiString,

// epi cms
    _AddItemDialogMixin,
    ContentReference,
    ContentSelectorDialog,
    formatters,
    WithContextMenu,
    DnD,

// epi ecf
    AssociationCollectionEditorModel,
    CompositeKey,
    LinkEditEditor,
    _CollectionEditorDndMixin,
    _ClickablePathColumnMixin,
    ModelSupport,

// resources
    resources,
    sharedResources

) {
    var collectionEditor = declare([_Widget, _TemplatedMixin, _ModelBindingMixin, _AddItemDialogMixin, _FocusableMixin, _CollectionEditorDndMixin, _ContextMixin], {

        /*jshint multistr: true */
        templateString: '<div>\
                            <div data-dojo-attach-point="commandTargetNode"></div>\
                            <div data-dojo-attach-point="overlayDnd">\
                                <div class="epi-associationCollectionEditor" data-dojo-attach-point="gridNode"></div>\
                            </div>\
                        </div>',

        grid: null,

        gridOverlayClass: "epi-grid-dnd-overlay",

        modelType: AssociationCollectionEditorModel,

        itemType: "EPiServer.Commerce.Shell.Rest.Models.AssociationModel",

        allowedDndTypes: [ModelSupport.contentTypeIdentifier.entryContentBase, ModelSupport.linkTypeIdentifier.association],

        includedColumns: ["ContentTypeIdentifier", "Name", "Code", "Path", "GroupName"],

        editableColumns: ["GroupName"],

        // Grid action column name
        cellActionName: "epiGridAction",

        itemEditorType: ContentSelectorDialog,

        postMixInProperties: function () {
            this.model = this.model || new this.modelType({
                itemType: this.itemType
            });
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.roots) {
                var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors"),
                    settings = contentRepositoryDescriptors.catalog;
                this.roots = settings.roots;
            }
            var builder = new ButtonBuilder({ settings: { showLabel: true } }),
                command = this.model.getListCommand();
            builder.create(command, this.commandTargetNode);

            // Set up metadata capable grid type
            var EditorGrid = declare([Grid, Selection, editor, _EditorMetadataMixin, WithContextMenu, DnD, _ClickablePathColumnMixin], {});

            // Get metadata for itemType
            when(this.model.metadataManager.getMetadataForType(this.itemType), lang.hitch(this, function (metadata) {
                // Set up columns object with one column for context menu
                var columns = [
                    {
                        field: "contentTypeIdentifier",
                        renderHeaderCell: function () { }, // no header
                        get: function (object) {
                            return object.contentTypeIdentifier;
                        },
                        label: "",
                        formatter: formatters.contentIcon,
                        className: "epi-columnIcon16x16",
                        sortable: false
                    },
                    {
                        field: this.cellActionName,
                        renderHeaderCell: function () { }, // no header
                        renderCell: lang.hitch(this, function (object, value, node, options) {

                                  var builder = new ButtonBuilder({ settings: { showLabel: false } }),
                                    commands = this.model.getCommands(this.grid, null);

                                  array.forEach(commands, function (command) {
                                      builder.create(command, node);
                                  });
                    }),
                        className: "epi-columnNarrow",
                        sortable: false
                    }],
                    // Prepare store capable of doing remove/re-add on changes that affect composite keys
                    compositeKeyProperties = ["groupName", "type"],
                    ckStore = new CompositeKey(dependency.resolve("epi.storeregistry").get("epi.commerce.association"), compositeKeyProperties, true),
                    // Create grid
                    grid = this.grid = new EditorGrid({
                        store: ckStore,
                        minWidth: 100,
                        noDataMessage: resources.nodatamessage,
                        selectionMode: "single",
                        "class": "epi-plain-grid epi-plain-grid-modal epi-plain-grid--margin-bottom epi-plain-grid--cell-borders",
                        columns: columns,
                        metadata: {
                            properties: metadata.properties,
                            gridIncluded: this.includedColumns,
                            gridEditable: this.editableColumns
                        },
                        dndSourceTypes: [ModelSupport.linkTypeIdentifier.association],
                        dndParams: {
                            copyOnly: true,
                            accept: this.allowedDndTypes || [],
                            creator: lang.hitch(this, this._dndNodeCreator)
                        }
                    });
                domConstruct.place(this.grid.domNode, this.gridNode);
                this.own(grid,
                    ckStore,
                    // Since grid will not be able to update the row due to the changed Id, we force a refresh
                    aspect.after(ckStore, "removeReAdd", function (promise) {
                        when(promise, function () {
                            grid.refresh();
                        });
                    }),
                    // Refresh grid when model has changed
                    this.model.on("itemAdded", lang.hitch(this, function () {
                        this.grid.refresh();
                    })),
                    this.model.on("itemSaved", lang.hitch(this, function () {
                        this.grid.refresh();
                    })),
                    this.model.on("itemRemoved", lang.hitch(this, function () {
                        this.grid.refresh();
                    })),
                    // Set query depending on contentLink property on model
                    this.model.watch("contentLink", lang.hitch(this, function (property, oldValue, newValue) {
                        if (oldValue !== newValue) {
                            this._updateGridQuery(newValue);
                            grid.resize();
                        }
                    })),
                    // Listen to remove command event
                    this.model.on("removeCommandEvent", lang.hitch(this, function () {
                        // Show confirmation dialog to confirm delete price item
                        when(this._showConfirmation(resources.deleteconfirmation.title, resources.deleteconfirmation.description), lang.hitch(this, function () {
                            if (this.model) {
                                var remove = [];
                                for (var selected in this.grid.selection) {
                                    if (this.grid.selection.hasOwnProperty(selected)) {
                                        remove.push(this.model.store.get(selected));
                                    }
                                }
                                return this.model.removeItems(remove);
                            }
                        }));
                    }))
                );

                this._setupDnD();
                when(this.getCurrentContext(), lang.hitch(this, function (currentContext) {
                    this._updateGridQuery(currentContext.id);
                    this.grid.startup();
                }));
            }));

        },

        _updateGridQuery: function(value){
            this.grid.set("query", { referenceId: new ContentReference(value).createVersionUnspecificReference().toString() });
        },

        _addItem: function (item) {
            when(this._dndGetItemData(item), lang.hitch(this, function (itemData) {
                if (itemData) {
                    return this.model.addItem(itemData);
                }
            }));
        },

        _noDataMessage: resources.nodatamessage,

         resize: function () {
             this.inherited(arguments);

             if (this.grid) {
                 this.grid.resize();
             }
         },

        _getDialogTitleText: function() {
            return resources.addlabel;
        },

        _createItemEditor: function() {
            return new this.itemEditorType({
                canSelectOwnerContent: false,
                showButtons: false,
                roots: this.roots,
                allowedTypes: [ModelSupport.contentTypeIdentifier.entryContentBase],
                showAllLanguages: false
            });
        },

        _dndGetItemData: function (item) {
            return when(item.data, lang.hitch(this, function (data) {
                if (data) {
                    return this._createItem(data.contentLink, data.name);
                }
            }));
        },

        _createItem: function (targetLink, name) {
            return {
                name: name || targetLink,
                sortOrder: 0,
                source: this.model.get("contentLink"),
                target: targetLink
            };
        },

        onExecuteDialog: function () {
            var item = this._itemEditor.get("value");
            this._addItem({ data: { contentLink: item } }, true);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this._set("value", value);

            if (this.model) {
                this.model.set("contentLink", value);
            }
        },

        destroy: function () {
            // summary:
            //		Destroy the object.

            if (this.grid) {
                this.grid.destroy();
                this.grid = null;
            }

            this.inherited(arguments);
        },

        _showConfirmation: function (title, description) {
            // summary:
            //      Wrap epi.shell.widget.dialog.Confirmation for short type
            //      and return deferred object
            // description:
            //      String: Text to display on dialog
            // tags:
            //      private

            var deferred = new Deferred();

            var dialog = new Confirmation({
                destroyOnHide: true,
                title: epiString.toHTML(title),
                description: epiString.toHTML(description),
                onAction: function (confirmed) {
                    if (confirmed) {
                        deferred.resolve();
                    } else {
                        deferred.cancel();
                    }
                }
            });
            dialog.show();

            return deferred.promise;
        }
    });

    return declare([LinkEditEditor], {

        resources: resources,

        gridCollectionType: collectionEditor,

        executeAction: function (actionName) {
            // summary:
            //      Called when [Related entries] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/tools/toggle", true);
        }
    });

});

},
'dgrid/editor':function(){
define("dgrid/editor", [
	"dojo/_base/kernel",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojo/_base/Deferred",
	"dojo/on",
	"dojo/aspect",
	"dojo/has",
	"dojo/query",
	"./Grid",
	"put-selector/put",
	"dojo/_base/sniff"
], function(kernel, lang, arrayUtil, Deferred, on, aspect, has, query, Grid, put){

// Variables to track info for cell currently being edited (editOn only).
var activeCell, activeValue, activeOptions;

function updateInputValue(input, value){
	// common code for updating value of a standard input
	input.value = value;
	if(input.type == "radio" || input.type == "checkbox"){
		input.checked = input.defaultChecked = !!value;
	}
}

function dataFromValue(value, oldValue){
	// Default logic for translating values from editors;
	// tries to preserve type if possible.
	if(typeof oldValue == "number"){
		value = isNaN(value) ? value : parseFloat(value);
	}else if(typeof oldValue == "boolean"){
		value = value == "true" ? true : value == "false" ? false : value;
	}else if(oldValue instanceof Date){
		var asDate = new Date(value);
		value = isNaN(asDate.getTime()) ? value : asDate;
	}
	return value;
}

// intermediary frontend to dataFromValue for HTML and widget editors
function dataFromEditor(column, cmp){
	if(typeof cmp.get == "function"){ // widget
		return dataFromValue(cmp.get("value"));
	}else{ // HTML input
		return dataFromValue(
			cmp[cmp.type == "checkbox" || cmp.type == "radio"  ? "checked" : "value"]);
	}
}

function setProperty(grid, cellElement, oldValue, value, triggerEvent){
	// Updates dirty hash and fires dgrid-datachange event for a changed value.
	var cell, row, column, eventObject;
	// test whether old and new values are inequal, with coercion (e.g. for Dates)
	if((oldValue && oldValue.valueOf()) != (value && value.valueOf())){
		cell = grid.cell(cellElement);
		row = cell.row;
		column = cell.column;
		if(column.field && row){
			// TODO: remove rowId in lieu of cell (or grid.row/grid.cell)
			// (keeping for the moment for back-compat, but will note in changes)
			eventObject = {
				grid: grid,
				cell: cell,
				rowId: row.id,
				oldValue: oldValue,
				value: value,
				bubbles: true,
				cancelable: true
			};
			if(triggerEvent && triggerEvent.type){
				eventObject.parentType = triggerEvent.type;
			}
			
			if(on.emit(cellElement, "dgrid-datachange", eventObject)){
				if(grid.updateDirty){
					// for OnDemandGrid: update dirty data, and save if autoSave is true
					grid.updateDirty(row.id, column.field, value);
					// perform auto-save (if applicable) in next tick to avoid
					// unintentional mishaps due to order of handler execution
					column.autoSave && setTimeout(function(){ grid._trackError("save"); }, 0);
				}else{
					// update store-less grid
					row.data[column.field] = value;
				}
			}else{
				// Otherwise keep the value the same
				// For the sake of always-on editors, need to manually reset the value
				var cmp;
				if(cmp = cellElement.widget){
					// set _dgridIgnoreChange to prevent an infinite loop in the
					// onChange handler and prevent dgrid-datachange from firing
					// a second time
					cmp._dgridIgnoreChange = true;
					cmp.set("value", oldValue);
					setTimeout(function(){ cmp._dgridIgnoreChange = false; }, 0);
				}else if(cmp = cellElement.input){
					updateInputValue(cmp, oldValue);
				}
				
				return oldValue;
			}
		}
	}
	return value;
}

// intermediary frontend to setProperty for HTML and widget editors
function setPropertyFromEditor(grid, column, cmp, triggerEvent) {
	var value, id, editedRow;
	if(!cmp.isValid || cmp.isValid()){
		value = setProperty(grid, (cmp.domNode || cmp).parentNode,
			activeCell ? activeValue : cmp._dgridLastValue,
			dataFromEditor(column, cmp), triggerEvent);
		
		if(activeCell){ // for editors with editOn defined
			activeValue = value;
		}else{ // for always-on editors, update _dgridLastValue immediately
			cmp._dgridLastValue = value;
		}

		if(cmp.type === "radio" && cmp.name && !column.editOn && column.field){
			editedRow = grid.row(cmp);
			
			// Update all other rendered radio buttons in the group
			query("input[type=radio][name=" + cmp.name + "]", grid.contentNode).forEach(function(radioBtn){
				var row = grid.row(radioBtn);
				// Only update _dgridLastValue and the dirty data if it exists
				// and is not already false
				if(radioBtn !== cmp && radioBtn._dgridLastValue){
					radioBtn._dgridLastValue = false;
					if(grid.updateDirty){
						grid.updateDirty(row.id, column.field, false);
					}else{
						// update store-less grid
						row.data[column.field] = false;
					}
				}
			});
			
			// Also update dirty data for rows that are not currently rendered
			for(id in grid.dirty){
				if(editedRow.id !== id && grid.dirty[id][column.field]){
					grid.updateDirty(id, column.field, false);
				}
			}
		}
	}
}

// editor creation/hookup/placement logic

function createEditor(column){
	// Creates an editor instance based on column definition properties,
	// and hooks up events.
	var editor = column.editor,
		editOn = column.editOn,
		grid = column.grid,
		isWidget = typeof editor != "string", // string == standard HTML input
		args, cmp, node, putstr, handleChange;
	
	args = column.editorArgs || {};
	if(typeof args == "function"){ args = args.call(grid, column); }
	
	if(isWidget){
		cmp = new editor(args);
		node = cmp.focusNode || cmp.domNode;
		
		// Add dgrid-input to className to make consistent with HTML inputs.
		node.className += " dgrid-input";
		
		// For editOn editors, connect to onBlur rather than onChange, since
		// the latter is delayed by setTimeouts in Dijit and will fire too late.
		cmp.connect(cmp, editOn ? "onBlur" : "onChange", function(){
			if(!cmp._dgridIgnoreChange){
				setPropertyFromEditor(grid, column, this, {type: "widget"});
			}
		});
	}else{
		handleChange = function(evt){
			var target = evt.target;
			if("_dgridLastValue" in target && target.className.indexOf("dgrid-input") > -1){
				setPropertyFromEditor(grid, column, target, evt);
			}
		};

		// considerations for standard HTML form elements
		if(!column.grid._hasInputListener){
			// register one listener at the top level that receives events delegated
			grid._hasInputListener = true;
			grid.on("change", function(evt){ handleChange(evt); });
			// also register a focus listener
		}
		
		putstr = editor == "textarea" ? "textarea" :
			"input[type=" + editor + "]";
		cmp = node = put(putstr + ".dgrid-input", lang.mixin({
			name: column.field,
			tabIndex: isNaN(column.tabIndex) ? -1 : column.tabIndex
		}, args));
		
		if(has("ie") < 9 || (has("ie") && has("quirks"))){
			// IE<9 / quirks doesn't fire change events for all the right things,
			// and it doesn't bubble.
			if(editor == "radio" || editor == "checkbox"){
				// listen for clicks since IE doesn't fire change events properly for checks/radios
				on(cmp, "click", function(evt){ handleChange(evt); });
			}else{
				on(cmp, "change", function(evt){ handleChange(evt); });
			}
		}
	}
	
	// XXX: stop mousedown propagation to prevent confusing Keyboard mixin logic
	// with certain widgets; perhaps revising KB's `handledEvent` would be better.
	on(node, "mousedown", function(evt){ evt.stopPropagation(); });
	
	return cmp;
}

function createSharedEditor(column, originalRenderCell){
	// Creates an editor instance with additional considerations for
	// shared usage across an entire column (for columns with editOn specified).
	
	var cmp = createEditor(column),
		grid = column.grid,
		isWidget = cmp.domNode,
		node = cmp.domNode || cmp,
		focusNode = cmp.focusNode || node,
		reset = isWidget ?
			function(){ cmp.set("value", cmp._dgridLastValue); } :
			function(){
				updateInputValue(cmp, cmp._dgridLastValue);
				// call setProperty again in case we need to revert a previous change
				setPropertyFromEditor(column.grid, column, cmp);
			},
		keyHandle;
	
	function blur(){
		var element = activeCell;
		focusNode.blur();
		
		if(typeof grid.focus === "function"){
			// Dijit form widgets don't end up dismissed until the next turn,
			// so wait before calling focus (otherwise Keyboard will focus the
			// input again).  IE<9 needs to wait longer, otherwise the cell loses
			// focus after we've set it.
			setTimeout(function(){
				grid.focus(element);
			}, isWidget && has("ie") < 9 ? 15 : 0);
		}
	}
	
	function onblur(){
		var parentNode = node.parentNode,
			i = parentNode.children.length - 1,
			options = { alreadyHooked: true },
			cell = grid.cell(node);
		
		// emit an event immediately prior to removing an editOn editor
		on.emit(cell.element, "dgrid-editor-hide", {
			grid: grid,
			cell: cell,
			column: column,
			editor: cmp,
			bubbles: true,
			cancelable: false
		});
		column._editorBlurHandle.pause();
		// Remove the editor from the cell, to be reused later.
		parentNode.removeChild(node);
		
		put(cell.element, "!dgrid-cell-editing");
		
		// Clear out the rest of the cell's contents, then re-render with new value.
		while(i--){ put(parentNode.firstChild, "!"); }
		Grid.appendIfNode(parentNode, column.renderCell(
			column.grid.row(parentNode).data, activeValue, parentNode,
			activeOptions ? lang.delegate(options, activeOptions) : options));
		
		// reset state now that editor is deactivated
		activeCell = activeValue = activeOptions = null;
	}
	
	function dismissOnKey(evt){
		// Contains logic for reacting to enter/escape keypresses to save/cancel edits.
		// Calls `focusNode.blur()` in cases where field should be dismissed.
		var key = evt.keyCode || evt.which;
		
		if(key == 27){ // escape: revert + dismiss
			reset();
			activeValue = cmp._dgridLastValue;
			blur();
		}else if(key == 13 && column.dismissOnEnter !== false){ // enter: dismiss
			// FIXME: Opera is "reverting" even in this case
			blur();
		}
	}
	
	// hook up enter/esc key handling
	keyHandle = on(focusNode, "keydown", dismissOnKey);
	
	// hook up blur handler, but don't activate until widget is activated
	(column._editorBlurHandle = on.pausable(cmp, "blur", onblur)).pause();
	
	return cmp;
}

function showEditor(cmp, column, cellElement, value){
	// Places a shared editor into the newly-active cell in the column.
	// Also called when rendering an editor in an "always-on" editor column.
	
	var isWidget = cmp.domNode,
		grid = column.grid;
	
	// for regular inputs, we can update the value before even showing it
	if(!isWidget){ updateInputValue(cmp, value); }
	
	cellElement.innerHTML = "";
	put(cellElement, ".dgrid-cell-editing");
	put(cellElement, cmp.domNode || cmp);
	
	if(isWidget){
		// For widgets, ensure startup is called before setting value,
		// to maximize compatibility with flaky widgets like dijit/form/Select.
		if(!cmp._started){ cmp.startup(); }
		
		// Set value, but ensure it isn't processed as a user-generated change.
		// (Clear flag on a timeout to wait for delayed onChange to fire first)
		cmp._dgridIgnoreChange = true;
		cmp.set("value", value);
		setTimeout(function(){ cmp._dgridIgnoreChange = false; }, 0);
	}
	// track previous value for short-circuiting or in case we need to revert
	cmp._dgridLastValue = value;
	// if this is an editor with editOn, also update activeValue
	// (activeOptions will have been updated previously)
	if(activeCell){ 
		activeValue = value; 
		// emit an event immediately prior to placing a shared editor
		on.emit(cellElement, "dgrid-editor-show", {
			grid: grid,
			cell: grid.cell(cellElement),
			column: column,
			editor: cmp,
			bubbles: true,
			cancelable: false
		});
	}
}

function edit(cell) {
	// summary:
	//		Method to be mixed into grid instances, which will show/focus the
	//		editor for a given grid cell.  Also used by renderCell.
	// cell: Object
	//		Cell (or something resolvable by grid.cell) to activate editor on.
	// returns:
	//		If the cell is editable, returns a promise resolving to the editor
	//		input/widget when the cell editor is focused.
	//		If the cell is not editable, returns null.
	
	var row, column, cellElement, dirty, field, value, cmp, dfd;
	
	if(!cell.column){ cell = this.cell(cell); }
	if(!cell || !cell.element){ return null; }
	
	column = cell.column;
	field = column.field;
	cellElement = cell.element.contents || cell.element;
	
	if((cmp = column.editorInstance)){ // shared editor (editOn used)
		if(activeCell != cellElement &&
				(!column.canEdit || column.canEdit(cell.row.data, value))){
			activeCell = cellElement;
			row = cell.row;
			dirty = this.dirty && this.dirty[row.id];
			value = (dirty && field in dirty) ? dirty[field] :
				column.get ? column.get(row.data) : row.data[field];
			
			showEditor(column.editorInstance, column, cellElement, value);
			
			// focus / blur-handler-resume logic is surrounded in a setTimeout
			// to play nice with Keyboard's dgrid-cellfocusin as an editOn event
			dfd = new Deferred();
			setTimeout(function(){
				// focus the newly-placed control (supported by form widgets and HTML inputs)
				if(cmp.focus){ cmp.focus(); }
				// resume blur handler once editor is focused
				if(column._editorBlurHandle){ column._editorBlurHandle.resume(); }
				dfd.resolve(cmp);
			}, 0);
			
			return dfd.promise;
		}
	}else if(column.editor){ // editor but not shared; always-on
		cmp = cellElement.widget || cellElement.input;
		if(cmp){
			dfd = new Deferred();
			if(cmp.focus){ cmp.focus(); }
			dfd.resolve(cmp);
			return dfd.promise;
		}
	}
	return null;
}

// editor column plugin function

return function(column, editor, editOn){
	// summary:
	//		Adds editing capability to a column's cells.
	
	var originalRenderCell = column.renderCell || Grid.defaultRenderCell,
		listeners = [],
		isWidget;
	
	if(!column){ column = {}; }
	
	// accept arguments as parameters to editor function, or from column def,
	// but normalize to column def.
	column.editor = editor = editor || column.editor || "text";
	column.editOn = editOn = editOn || column.editOn;
	
	isWidget = typeof editor != "string";
	
	// warn for widgetArgs -> editorArgs; TODO: remove @ 0.4
	if(column.widgetArgs){
		kernel.deprecated("column.widgetArgs", "use column.editorArgs instead",
			"dgrid 0.4");
		column.editorArgs = column.widgetArgs;
	}
	
	aspect.after(column, "init", editOn ? function(){
		var grid = column.grid;
		if(!grid.edit){ grid.edit = edit; }
		
		// Create one shared widget/input to be swapped into the active cell.
		column.editorInstance = createSharedEditor(column, originalRenderCell);
	} : function(){
		var grid = column.grid;
		if(!grid.edit){ grid.edit = edit; }
		
		if(isWidget){
			// add advice for cleaning up widgets in this column
			listeners.push(aspect.before(grid, "removeRow", function(rowElement){
				// destroy our widget during the row removal operation,
				// but don't trip over loading nodes from incomplete requests
				var cellElement = grid.cell(rowElement, column.id).element,
					widget = cellElement && (cellElement.contents || cellElement).widget;
				if(widget){ widget.destroyRecursive(); }
			}));
		}
	});
	
	aspect.after(column, "destroy", function(){
		arrayUtil.forEach(listeners, function(l){ l.remove(); });
		if(column._editorBlurHandle){ column._editorBlurHandle.remove(); }
		
		if(editOn && isWidget){ column.editorInstance.destroyRecursive(); }
	});
	
	column.renderCell = editOn ? function(object, value, cell, options){
		// TODO: Consider using event delegation
		// (Would require using dgrid's focus events for activating on focus,
		// which we already advocate in README for optimal use)
		
		if(!options || !options.alreadyHooked){
			// in IE<8, cell is the child of the td due to the extra padding node
			on(cell.tagName == "TD" ? cell : cell.parentNode, editOn, function(){
				activeOptions = options;
				column.grid.edit(this);
			});
		}
		
		// initially render content in non-edit mode
		return originalRenderCell.call(column, object, value, cell, options);
		
	} : function(object, value, cell, options){
		// always-on: create editor immediately upon rendering each cell
		if(!column.canEdit || column.canEdit(object, value)){
			var cmp = createEditor(column);
			showEditor(cmp, column, cell, value);
			// Maintain reference for later use.
			cell[isWidget ? "widget" : "input"] = cmp;
		}else{
			return originalRenderCell.call(column, object, value, cell, options);
		}
	};
	
	return column;
};
});

},
'epi/shell/dgrid/_EditorMetadataMixin':function(){
﻿define("epi/shell/dgrid/_EditorMetadataMixin", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dgrid/editor",
    "epi/string",
    "./_MetadataMixin"
],
function(
    array,
    declare,
    lang,
    Deferred,
    all,
    editor,
    epiString,
    _MetadataMixin
) {
    return declare([_MetadataMixin], {

        editableProperties: null,
        _editorWidgetsReady: null,
        editorSettings: { editOn: "click", autoSave: "true" },
        editorArgs: null,
        editorType: null,

        postMixInProperties: function() {
            this.inherited(arguments);
            this.metadata.gridEditable = this.metadata.gridEditable || [];
            this.editorType = this.editorType || editor;
            this._editorWidgetPromises = [];
        },

        _metadataPropertiesToColumnsDefinition: function(properties, include) {
            // summary:
            //		Get columns definition from metadata properties
            // tags:
            //		private

            var colDefs = this.inherited(arguments),
                filteredProps = this._filterProperties(properties, this.metadata.gridEditable),
                uiWidgets = [];

            for (var i = 0, j = filteredProps.length; i < j; i += 1) {
                var uiType = filteredProps[i].uiType;
                if (uiType) {
                    uiWidgets.push(epiString.slashName(uiType));
                }
            }

            this._editorWidgetsReady = new Deferred();
            require(uiWidgets, lang.hitch(this, function() {
                for (var i = 0, j = filteredProps.length; i < j; i += 1) {
                    var prop = filteredProps[i],
                        widget = arguments[array.indexOf(uiWidgets, prop.uiType)],
                        colName = epiString.pascalToCamel(prop.name),
                        selections = prop.selections && prop.selections.length > 0 ? { selections: prop.selections } : {};

                        colDefs[colName] = this.editorType(lang.mixin(
                            colDefs[colName],   // the column definition settings
                            this.editorSettings,
                            {
                                editor: widget,
                                editorArgs: lang.mixin(colDefs[colName].editorArgs,  
                                    this.editorArgs,    // grid.editorArgs settings
                                    prop.settings,      // The "settings" property from the metadata object contains editor arguments
                                    selections)         // Selections are mixed on to the editorArgs
                            }));
                }
                this._editorWidgetsReady.resolve();
            }));

            return colDefs;
        },

        startup: function() {
            // summary:
            //		Startup function delaying execution until widgets are resolved

            var inherited = this.getInherited(arguments),
                args = arguments;

            return this._editorWidgetsReady.then(lang.hitch(this, function () {
                this.set("columns", this.columns);
                return inherited.apply(this, args);
            }));
        }
    });
});
},
'epi/shell/dgrid/_MetadataMixin':function(){
﻿define("epi/shell/dgrid/_MetadataMixin", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/string"
],
function (
    array,
    declare,
    lang,
    epiString
) {
    return declare([], {
        
        metadata: null,

        postMixInProperties: function () {
            this.inherited(arguments);
            this.metadata = this.metadata || {};
            this.metadata.gridIncluded = this.metadata.gridIncluded || [];
            this.metadata.placeColumns = this.metadata.placeColumns || "prepending";
            this.columns = this.columns && this.columns instanceof Array ? this._columnsArrayToObject(this.columns) : this.columns || {};
        },

        postCreate: function() {
            this.inherited(arguments);
            // Where to put the metadata created columns (useful when mixing normal columns and metadata columns)
            if(this.metadata.placeColumns === "appending") {
                lang.mixin(this.columns, this._metadataPropertiesToColumnsDefinition(this.metadata.properties, this.metadata.gridIncluded));
            } else {
                this.columns = lang.mixin(this._metadataPropertiesToColumnsDefinition(this.metadata.properties, this.metadata.gridIncluded), this.columns);
            }
        },

        _columnsArrayToObject: function (columnsArray) {
            // summary:
            //      Creates a columns object from a columns array
            // tags:
            //      private
            var columnsObject = {};
            for(var i=0,j=columnsArray.length; i<j; i+=1) {
                columnsObject[columnsArray[i].field] = columnsArray[i];
            }
            return columnsObject;
        },

        _metadataPropertiesToColumnsDefinition: function (properties, include) {
            // summary:
            //		Get columns definition from metadata properties
            // tags:
            //		private
            var colDefs = {},
                filteredProperties = this._filterProperties(properties, include);

            for(var i=0,j=filteredProperties.length; i<j; i+=1) {
                var definition = this.getColumnDefinition(filteredProperties[i]);
                colDefs[definition.field] = definition;
            }

            return colDefs;
        },

        _filterProperties: function (properties, include) {
            // summary:
            //      Filter included properties
            // tags:
            //      private

            if(include.length > 0) {
                return array.filter(properties, function (property) {
                    return array.indexOf(include, property.name) > -1;
                });
            }
            return [];
        },

        getColumnDefinition: function (property) {
            // summary:
            //      Returns a basic column definition
            return {
                label: property.displayName,
                field: epiString.pascalToCamel(property.name),
                sortable: false
            };
        }
    });
});

},
'epi-ecf-ui/contentediting/viewmodel/AssociationCollectionEditorModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
// epi-ecf-ui
    "./_BaseEntryCollectionEditorModel",
//Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.associationcollectioneditor"
],
function (
//dojo
    declare,
    lang,
    when,
// epi-ecf-ui
    _BaseEntryCollectionEditorModel,
// Resources
    res
) {
    return declare([_BaseEntryCollectionEditorModel], {
        // module:
        //      epi-ecf-ui/contentediting/viewmodel/AssociationCollectionEditEditorModel
        // summary:
        //      Represents the model for AssocciationCollectionEditor

        storeKey: "epi.commerce.association",

        resources: res,

        saveItem: function (model) {
            // This is overriden from the base class, and will be called when one item are updated.
            var promise = when(this.store.get(model.id), lang.hitch(this, function(oldItem)
            {
                // groupName and type are part of id so if they are changed we have to
                // create a new item, otherwise update
                if (oldItem.groupName === model.groupName && oldItem.type === model.type) {
                    return this.store.put(model);
                } else {
                    // Clone the model and remove its ID so that JsonRest understands this is a new object
                    // and not an attempt to update an existing object
                    var clone = lang.clone(model);
                    delete clone.id;
                    return when(this.store.remove(oldItem.id), lang.hitch(this, function () {
                        return this.store.add(clone);
                    }));
                }
            }));

            when(promise, lang.hitch(this, function(data) {
                this.emit("itemSaved", { id: data.id });
            }));

            return promise;
        }
    });
});
},
'epi-ecf-ui/contentediting/viewmodel/_BaseEntryCollectionEditorModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/promise/all",
    "dojo/Stateful",
    "dojo/when",
// epi
    "epi/dependency",
    "epi/shell/command/DelegateCommand",
// resources
    "epi/i18n!epi/nls/episerver.shared"
], function(
//dojo
    declare,
    lang,
    Evented,
    all,
    Stateful,
    when,
// epi
    dependency,
    DelegateCommand,
// resources
    sharedResources
){
    return declare([Stateful, Evented], {

        storeKey: null,

        resources: null,

        postscript: function () {
            this.inherited(arguments);

            this.storeRegistry = dependency.resolve("epi.storeregistry");
            this.store = this.store || this.storeRegistry.get(this.storeKey);
            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");
        },

        getCommands: function (model, category) {
            var commonSettings = {
                category: category,
                model: model,
                canExecute: true,
                isAvailable: true
            };

            return [
                new DelegateCommand(lang.mixin({
                    name: "remove",
                    label: this.resources.commands.remove,
                    iconClass: "epi-iconClose",
                    delegate: lang.hitch(this, function (cmd) {
                        this.emit("removeCommandEvent");
                    })
                }, commonSettings))
            ];
        },

        addItem: function(item) {
            return when(this.store.add(item), lang.hitch(this, function(data) {
                this.emit("itemAdded", { id: data.id });
            }));
        },

        removeItems: function (models) {
            var promises = [];

            for (var i = 0, j = models.length; i < j; i += 1) {
                promises.push(this.store.remove(models[i].id));
            }

            return all(promises).then(lang.hitch(this, function (removed) {
                this.emit("itemsRemoved");
            }));
        },

        getListCommand: function (availableCommands) {
            return new DelegateCommand({
                name: "add",
                label: this.resources.addlabel,
                tooltip: sharedResources.action.add,
                iconClass: "epi-iconPlus",
                canExecute: true,
                isAvailable: true,
                delegate: lang.hitch(this, this.addItemDelegate)
            });
        },

        addItemDelegate: function () {
            // summary:
            //      execute delegate for add command.
            // tags:
            //      protected

            this.emit("toggleItemEditor", null);
        },

        moveItem: function(item, refItem, before) {
            this._setSortOrder(item, refItem, before);
            return when(this.store.put(item), lang.hitch(this, function(data) {
                this.emit("itemSaved", { id: data.id });
            }));
        },

        _setSortOrder: function (item, refItem, before) {
            if (refItem) {
                // Set sortOrder equal to refItem to place it before
                // The store will update sort index of any items after it
                item.sortOrder = before ? refItem.sortOrder : refItem.sortOrder + 1;
            }
        }

    });
});
},
'epi-ecf-ui/store/CompositeKey':function(){
﻿define([
    "dojo/_base/lang",
    "dojo/when"
    ],
function (lang, when) {

    // module:
    //		epi-ecf-ui/store/CompositeKey

    var CompositeKey = function (masterStore, keys, getClones) {
        return lang.delegate(masterStore, 
            {
                keys: keys,
                getClones: getClones,
                removeReAdd: function(object, directives) {
                    var newObj = lang.clone(object),
                        promise = this.remove(object[this.idProperty]);
                    delete newObj[this.idProperty];
                    return when(promise, function() {  // Wait for remove to finish before adding
                        return masterStore.add(newObj, directives);
                    });
                },
                put: function(object, directives) {
                    var oldObj = this.get(object[this.idProperty]);
                    if(oldObj && this.keys) {
                        for(var i=0, j=this.keys.length; i<j ; i+=1) {
                            if(oldObj[keys[i]] !== object[keys[i]]) {
                                return this.removeReAdd(object, directives);
                            }
                        }
                    }
                    return masterStore.put.apply(masterStore, arguments);
                },
                get: function(id) {
                    return getClones ? lang.clone(masterStore.get.apply(masterStore, arguments)) : masterStore.get.apply(masterStore, arguments);
                }
        });
    };

    /*=====
    
    CompositeKey = declare(Store, {
        // summary:
        //		The CompositeKey store looks for changes in attributes that make
        //		out composite keys and does a re-add if any of them have changed.
        // example:
        //	|	var master = new Memory(data);
        //	|	var store = new CompositeKey(master, cacher);
        //
        constructor: function(masterStore){
            // masterStore:
            //		This is the store that serves object with composite keys.
            // keys:
            //      These are the keys used to determine if key is invalid.
            // getClones:
            //      Decides whether the get method should deliver cloned objects, needed
            //      when implementations are running get before put.
        }
        put: function(object, directives){
            // summary:
            //		Put the object into the store, evaluating whether to do a delete/readd.
            // object: Object
            //		The object to put to the store.
            // directives: dojo/store/api/Store.PutDirectives?
            //		Any additional parameters needed to describe how the put should be performed.
            // returns: Promise
            //		Returns a promise for the result
        },
        removeReAdd: function(object){
            // summary:
            //		Remove the object with the specific id.
             // object: Object
            //		The object to remove and re-add to the store.
            // directives: dojo/store/api/Store.PutDirectives?
        }
    });
    =====*/

    return CompositeKey;
});

},
'epi-ecf-ui/contentediting/editors/_CollectionEditorDndMixin':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/aspect",

    "epi-cms/dgrid/DnD"
],
function (
    array,
    declare,
    lang,
    domConstruct,
    domClass,
    aspect,

    DnD
) {
    return declare([], {

        _dndNodeCreator: function (/*Object*/item, /*Object*/hint) {
            // summary:
            //      Custom DnD avatar creator method
            //  tags:
            //      private

            var dndTypes = this.allowedDndTypes,
                node = domConstruct.create("div");

            return {
                "node": node,
                "type": dndTypes,
                "data": item
            };
        },

        _setupDnD: function () {
            // summary:
            //      Set up the dnd on the grid.
            // tags:
            //      private

            this.own(
                aspect.after(this.grid.dndSource, "onDndStart", lang.hitch(this, function (source, nodes, copy) {
                    var dndSource = this.grid.dndSource,
                        accepted = dndSource.accept && dndSource.checkAcceptance(source, nodes);

                    domClass[accepted ? "add" : "remove"](this.overlayDnd, this.gridOverlayClass);
                }), true),
                aspect.after(this.grid.dndSource, "onDropData", lang.hitch(this, this.onDndDrop), true)
            );
        },

        onDndDrop: function (dndData, source, nodes, copy) {
            var i;

            // internal move
            if (this.grid.dndSource === source) {
                for (i = 0; i < nodes.length; i++) {
                    this.model.moveItem(
                        this.grid.dndSource.getItem(nodes[i].id).data,
                        this.grid.dndSource.current !== null ?
                            this.grid.dndSource.getItem(this.grid.dndSource.current.id).data :
                            null,
                        this.grid.dndSource.before
                    );
                }
                // external drop
            } else {
                // Set focus to mark start editing
                // make sure editor will be marked as start-editing immediately by invoking onDropping
                // to fix an issue in IE9, which was caused by the race condition,
                // which would lead to a problem of auto save.
                this.onDropping && this.onDropping();
                this.onFocus();

                for (i = 0; i < dndData.length; i++) {
                    this._addItem(dndData[i]);

                    // Remove from source?
                    // TODO: Simplify
                    if (source && source.grid && source.grid.consumer && source.grid.consumer !== this) {
                        source.grid.consumer.model.removeItem(this.grid.dndSource.getItem(nodes[i].id).data);
                    }
                }
            }
        }
    });
});
},
'epi-ecf-ui/widget/_RelationViewBase':function(){
﻿define([
// dojo
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Evented",
    "dojo/topic",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/_base/window",

// dijit
    "dijit/layout/_LayoutWidget",

// cms
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",

// commerce
    "./BackToPreviousViewNotification"

], function (
// dojo
    aspect,
    declare,
    lang,
    array,
    Evented,
    topic,
    domGeometry,
    domStyle,
    window,

// dijit
    _LayoutWidget,

// CMS
    Breadcrumb,
    BreadcrumbCurrentItem,

// commerce
    BackToPreviousViewNotification
) {

    return declare([_LayoutWidget], {
        // summary:
        //    Represents the widget to edit relations and assiciations.
        // tags:
        //    public

        // Classes inheriting from this class needs to specify a dijit/layout/ContentPane.
        contentPane: null,

        _backToPreviousViewNotification: null,

        postCreate: function(){
            this.inherited(arguments);
            this._backToPreviousViewNotification = new BackToPreviousViewNotification();
            this.own(
                this._backToPreviousViewNotification.watch("notification", lang.hitch(this, this._defaultNotificationWatchHandler))
            );
        },

        _defaultNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue) {
            // summary:
            //      Add/remove notification to/from notification bar
            // tags:
            //      private

            if (oldValue) {
                this.notificationBar.remove(oldValue);
            }

            if (newValue && newValue.content) {
                this.notificationBar.add(newValue);
            }
        },

        updateView: function (data, context) {
            // summary:
            //		Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //		protected

            this.toolbar.update({
                currentContext: context,
                viewConfigurations: {
                    availableViews: data.availableViews,
                    viewName: data.viewName
                }
            });

            this._backToPreviousViewNotification.showNotification();
        },

        resize: function () {
            // summary:
            //		Resize this widget to the given dimensions.
            // tags:
            //		protected
            this.inherited(arguments);

            // make the grid 100% height
            var top = domGeometry.position(this.contentPane.domNode).y;
            var bodyHeight = domGeometry.position(window.body()).h;
            domStyle.set(this.contentPane.domNode, "height", (bodyHeight - top) + "px");
        }
    });
});

},
'epi-ecf-ui/widget/BackToPreviousViewNotification':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dojo/Stateful",
    "dojo/topic",
    "epi-cms/command/BackCommand",
    "epi/i18n!epi/cms/nls/commerce.widget.backtodefaultview"
],function(
    declare,
    domConstruct,
    Stateful,
    topic,
    BackCommand,
    resources
){
    return declare([Stateful], {

        _command: null,

        notification: null,

        constructor: function(){
            this._command = new BackCommand({
                canExecute: true,
                _execute: function(){
                    //we're overriding the default back command execute to just switch back to the previously used widget.
                    topic.publish("/epi/shell/action/changeview/back", true/* force the widget to reload, in order to reflect changes if any. */);
                },
                _onModelChange: function() {/*I don't care about the model.*/}
            });
        },

        showNotification: function(){
            var notificationText = domConstruct.create("div", {
                innerHTML: resources.notificationtext
            });

            this.set("notification", {
                content: notificationText,
                commands: [this._command]
            });
        }
    });
});
},
'url:epi-ecf-ui/widget/templates/LinkEdit.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-attach-point=\"notificationBar\" data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-props=\"region:'top'\"></div>\r\n    <div data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"contentPane\" class=\"epi-linkEdit\">\r\n        <div data-dojo-type=\"epi-ecf-ui/contentediting/editors/CategoryCollectionEditor\" data-dojo-attach-point=\"categoryList\"></div>\r\n        <div data-dojo-attach-point=\"associationListNode\"></div>\r\n    </div>\r\n</div>",
'epi-ecf-ui/widget/VariantEdit':function(){
﻿define([
// dojo
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    
// dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/dnd/Target",
    
// cms
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",
    "epi-cms/contentediting/editors/_TextWithActionLinksMixin",

// commerce
    "../contentediting/editors/VariantCollectionEditor",
    "./_RelationViewBase",
    
// Resources
    "dojo/text!./templates/VariantEdit.html",
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.variantcollectioneditor",
// Widgets in the template
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/contentediting/StandardToolbar"
], function (
// dojo
    aspect,
    declare,
    lang,
    topic,
    
// dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

// EPi Framework
    _ModelBindingMixin,
    Target,

// CMS
    Breadcrumb,
    BreadcrumbCurrentItem,
    _TextWithActionLinksMixin,

// commerce
    VariantCollectionEditor,
    _RelationViewBase,

// Resources
    template,
    resources
) {

    return declare([_RelationViewBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, _TextWithActionLinksMixin], {
        // summary:
        //    Represents the widget to edit variants.
        // tags:
        //    public
        templateString: template,
        
        _dndTarget: null,
        
        resources: resources,
        
        contentPane: this.contentPane,

        postCreate: function () {
            this.inherited(arguments);
            this.setupActionLinks(this.dropContainer);
        },

        buildRendering: function () {
            this.inherited(arguments);

            this._dndTarget = new Target(this.dropContainer, {
                accept: this.collectionList.allowedDndTypes,
                insertNodes: function () { }
            });

            this.own(aspect.after(this._dndTarget, "onDropData", lang.hitch(this, function (dndData) {
                this.collectionList._addItem(dndData[0], true);
            }), true));
        },

        updateView: function (data, context) {
            // summary:
            //		Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //		protected

            this.inherited(arguments);
            this.set("value", context.id);
        },
        
        getTemplateString: function () {
            // summary:
            //      The template string for drop area
            // tags:
            //      protected

            return {
                templateString: this.resources.drophere,
                actions: this.resources.actions
            };
        },

        executeAction: function (actionName) {
            // summary:
            //      Called when [entries] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/tools/toggle", true);
        },

        _setValueAttr: function (value) {
            this.collectionList.set("value", value);
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/VariantCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
     // EPi Framework
    "epi/shell/widget/_FocusableMixin",
    // epi-cms
    "epi-cms/contentediting/editors/model/CollectionEditorModel",
    // ecf-ui
    "./_RelationCollectionEditorBase",
    "../viewmodel/VariantCollectionEditorModel",
    "../ModelSupport",
    
    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.variantcollectioneditor"
],
function (
    //dojo
    declare,
     // EPi Framework
     _FocusableMixin,
    // epi-cms
    CollectionEditorModel,
    // ecf-ui
    _RelationCollectionEditorBase,
    VariantCollectionEditorModel,
    ModelSupport,
    
    // Resources
    resources
) {
    return declare([_RelationCollectionEditorBase, _FocusableMixin], {
        // module:
        //      epi-ecf-ui/contentediting/editors/VariantCollectionEditEditor
        // summary:
        //      Represents the variant editable collection
                
        modelType: VariantCollectionEditorModel,

        allowedDndTypes: [ModelSupport.contentTypeIdentifier.variationContent, ModelSupport.contentTypeIdentifier.productContent, ModelSupport.linkTypeIdentifier.relation],

        itemEditorTypes: [ModelSupport.contentTypeIdentifier.variationContent, ModelSupport.contentTypeIdentifier.productContent],
        
        resources: resources,

        relationType: ModelSupport.relationType.productVariation
    });
});

},
'epi-ecf-ui/contentediting/viewmodel/VariantCollectionEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",

    // ecf
    "./VariantCollectionReadOnlyEditorModel",
    "./_RelationCollectionEditorModelMixin",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.variantcollectioneditor"
],
function (
    //dojo
    declare,

    // ecf
    VariantCollectionReadOnlyEditorModel,
    _RelationCollectionEditorModelMixin,

    // Resources
    res
) {
    return declare([VariantCollectionReadOnlyEditorModel, _RelationCollectionEditorModelMixin], {
        // module:
        //      epi-ecf-ui/contentediting/viewmodel/VariantCollectionEditEditorModel
        // summary:
        //      Represents the model for VariantCollectionEditor

        res: res
    });
});
},
'url:epi-ecf-ui/widget/templates/VariantEdit.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-attach-point=\"notificationBar\" data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-props=\"region:'top'\"></div>\r\n    \r\n    <div data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"contentPane\" class=\"epi-linkEdit\">\r\n        <h1>${resources.title}</h1>\r\n        <div data-dojo-attach-point=\"collectionList\" data-dojo-type=\"epi-ecf-ui/contentediting/editors/VariantCollectionEditor\"></div>\r\n        <div data-dojo-attach-point=\"dropContainer\" class=\"epi-content-area-actionscontainer\"></div>\r\n    </div>\r\n</div>",
'epi-ecf-ui/widget/BundleEdit':function(){
﻿define([
// dojo
    "dojo/_base/declare",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/TypeDescriptorManager",

// cms
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",
// commerce
    "./_RelationViewBase",
// Resources
    "dojo/text!./templates/BundleEdit.html",
// Widgets in the template
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/contentediting/StandardToolbar",
"../contentediting/editors/BundleEntryCollectionEditor"
], function (
// dojo
    declare,

// dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

// EPi Framework
    _ModelBindingMixin,
    TypeDescriptorManager,

// CMS
    Breadcrumb,
    BreadcrumbCurrentItem,

// commerce
    _RelationViewBase,
// Resources
    template
) {

    return declare([_RelationViewBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //    Represents the widget to edit bundle entries
        // tags:
        //    public
        templateString: template,

        contentPane: this.contentPane,

        updateView: function (data, context) {
            // summary:
            //      Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //      protected

            this.inherited(arguments);

            this.set("value", context.id);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Sets value for this widget.
            // value: ContentReference
            //      Input content link to get data from.

            this.collectionList.set("value", value);
        }
    });
});

},
'url:epi-ecf-ui/widget/templates/BundleEdit.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-attach-point=\"notificationBar\" data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-props=\"region:'top'\"></div>\r\n    <div data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"contentPane\" class=\"epi-bundleEdit\">\r\n        <div data-dojo-attach-point=\"collectionList\" data-dojo-type=\"epi-ecf-ui/contentediting/editors/BundleEntryCollectionEditor\"></div>\r\n    </div>\r\n</div>",
'epi-ecf-ui/contentediting/editors/BundleEntryCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/topic",

    // ecf-ui
    "../ModelSupport",
    "../viewmodel/EntryRelationCollectionEditorModel",
    "./LinkEditEditor",
    "./_BundleEntryCollectionEditorGrid",
    "./_GroupDefinitionEditorMixin",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.bundleentrycollectioneditor"
],
function (
    //dojo
    declare,
    topic,

    // ecf-ui
    ModelSupport,
    EntryRelationCollectionEditorModel,
    LinkEditEditor,
    _BundleEntryCollectionEditorGrid,
    _GroupDefinitionEditorMixin,

    // Resources
    resources
) {
    var collectionEditor = declare([_BundleEntryCollectionEditorGrid], {

        modelType: EntryRelationCollectionEditorModel,

        relationType: ModelSupport.relationType.bundleEntry,

        deleteConfirmationTitle: resources.deleteconfirmation.title,

        deleteConfirmationDescription: resources.deleteconfirmation.description

    });

    return declare([LinkEditEditor, _GroupDefinitionEditorMixin], {
        resources: resources,
        gridCollectionType: collectionEditor,

        executeAction: function (actionName) {
            // summary:
            //      Called when [variants and products] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/tools/toggle", true);
        }
    });
});

},
'epi-ecf-ui/contentediting/viewmodel/EntryRelationCollectionEditorModel':function(){
﻿/* TODO: Much borrowed from AssociationCollectionEditorModel - consolidate */
define([
    // dojo
    "dojo/_base/declare",
    //epi-ecf-ui
    "./_BaseEntryCollectionEditorModel",
    //Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.relationcollectioneditor"
],
function (
    //dojo
    declare,
    //epi-ecf-ui
    _BaseEntryCollectionEditorModel,
    // Resources
    res
) {
    return declare([_BaseEntryCollectionEditorModel], {
        // module:
        //      epi-ecf-ui/contentediting/viewmodel/EntryRelationCollectionEditorModel
        // summary:
        //      Represents the model for bundle/package editors

        storeKey: "epi.commerce.relation",

        resources: res
    });
});
},
'epi-ecf-ui/contentediting/editors/_BundleEntryCollectionEditorGrid':function(){
﻿/* TODO: Much borrowed from AssociationCollectionEditor - consolidate */
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/aspect",
    "dojo/Deferred",
    "dojo/when",
    "dojo/Stateful",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dgrid/editor",
    "dgrid/Selection",
    "dijit/form/Button",
    "dgrid/OnDemandGrid",
    "epi/dependency",
    "epi/string",
    "epi/shell/_ContextMixin",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/dgrid/_EditorMetadataMixin",
    "epi-cms/dgrid/DnD",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/Confirmation",
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/contentediting/editors/_AddItemDialogMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/dgrid/formatters",
    "../ModelSupport",
    "./_CollectionEditorDndMixin",
     "../../dgrid/_ClickablePathColumnMixin",

    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.relationcollectioneditor"
],
function (
    array,
    declare,
    lang,
    domConstruct,
    aspect,
    Deferred,
    when,
    Stateful,
    _Widget,
    _TemplatedMixin,
    editor,
    Selection,
    Button,
    Grid,
    dependency,
    epiString,
    _ContextMixin,
    ButtonBuilder,
    Dialog,
    _EditorMetadataMixin,
    DnD,
    _FocusableMixin,
    _ModelBindingMixin,
    Confirmation,
    ContentSelectorDialog,
    _AddItemDialogMixin,
    ContentReference,
    WithContextMenu,
    formatters,
    ModelSupport,
    _CollectionEditorDndMixin,
    _ClickablePathColumnMixin,

    resources
) {
    return declare([_Widget, _TemplatedMixin, _ModelBindingMixin, _AddItemDialogMixin, _FocusableMixin, _CollectionEditorDndMixin, _ContextMixin], {

        /*jshint multistr: true */
        templateString: '<div>\
                            <div data-dojo-attach-point="commandTargetNode"></div>\
                            <div data-dojo-attach-point="overlayDnd">\
                                <div class="epi-relationCollectionEditor" data-dojo-attach-point="gridNode"></div>\
                            </div>\
                        </div>',

        grid: null,

        storeKey: "epi.commerce.relation",

        gridOverlayClass: "epi-grid-dnd-overlay",

        itemType: "EPiServer.Commerce.Shell.Rest.Models.RelationModel",

        allowedDndTypes: [ModelSupport.contentTypeIdentifier.variationContent, ModelSupport.contentTypeIdentifier.productContent, ModelSupport.linkTypeIdentifier.relation],

        includedColumns: ["ContentTypeIdentifier", "Name", "Path", "Quantity", "GroupName"],

        editableColumns: ["Quantity", "GroupName"],

        // Grid action column name
        cellActionName: "epiGridAction",

        itemEditorType: ContentSelectorDialog,

        noDataMessage: resources.nodatamessage,

        addLabelText: resources.addlabel,

        postMixInProperties: function () {
            this.model = this.model || new this.modelType({
                itemType: this.itemType
            });
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.roots) {
                var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors"),
                    settings = contentRepositoryDescriptors.catalog;
                this.roots = settings.roots;
            }
            var builder = new ButtonBuilder({ settings: { showLabel: true } }),
                command = this.model.getListCommand();
            builder.create(command, this.gridNode);

            // Set up metadata capable grid type
            var EditorGrid = declare([Grid, Selection, editor, _EditorMetadataMixin, WithContextMenu, DnD, _ClickablePathColumnMixin], {});

            // Get metadata for itemType
            when(this.model.metadataManager.getMetadataForType(this.itemType), lang.hitch(this, function (metadata) {
                // Set up columns object with one column for context menu
                var columns = [
                    {
                        field: "contentTypeIdentifier",
                        renderHeaderCell: function () { }, // no header
                        get: function (object) {
                            return object.contentTypeIdentifier;
                        },
                        label: "",
                        formatter: formatters.contentIcon,
                        className: "epi-columnIcon16x16",
                        sortable: false
                    },
                    {
                        field: this.cellActionName,
                        renderHeaderCell: function () { }, // no header
                        renderCell: lang.hitch(this, function (object, value, node, options) {
                            var builder = new ButtonBuilder({ settings: { showLabel: false } }),
                                commands = this.model.getCommands(this.grid, null);

                            array.forEach(commands, function(command) {
                                builder.create(command, node);
                            });
                        }),
                        className: "epi-columnNarrow",
                        sortable: false
                    }],
                    store = dependency.resolve("epi.storeregistry").get(this.storeKey),
                    // Create grid
                    grid = this.grid = new EditorGrid({
                        store: store,
                        minWidth: 100,
                        noDataMessage: this.noDataMessage,
                        selectionMode: "single",
                        "class": "epi-plain-grid epi-plain-grid-modal epi-plain-grid--margin-bottom epi-plain-grid--cell-borders",
                        columns: columns,
                        metadata: {
                            properties: metadata.properties,
                            gridIncluded: this.includedColumns,
                            gridEditable: this.editableColumns
                        },
                        dndSourceTypes: [ModelSupport.linkTypeIdentifier.relation],
                        dndParams: {
                            copyOnly: true,
                            accept: this.allowedDndTypes || [],
                            creator: lang.hitch(this, this._dndNodeCreator)
                        }
                    });
                domConstruct.place(this.grid.domNode, this.gridNode);
                this.own(grid,
                    this.model.on("itemAdded", lang.hitch(this, function (e) {
                        this.grid.refresh();
                    })),
                    this.model.on("itemRemoved", lang.hitch(this, function (e) {
                        this.grid.refresh();
                    })),
                    this.model.on("itemSaved", lang.hitch(this, function () {
                        this.grid.refresh();
                    })),
                    this.model.watch("contentLink", lang.hitch(this, function (property, oldValue, newValue) {
                        // Set query even if the content link is the same, to update bundle entry grid
                        this._updateGridQuery(newValue);
                        grid.resize();
                    })),
                    // Listen remove command event
                    this.model.on("removeCommandEvent", lang.hitch(this, function () {
                        // Show confirmation dialog to confirm delete bundle item
                        when(this._showConfirmation(this.deleteConfirmationTitle, this.deleteConfirmationDescription), lang.hitch(this, function () {
                            if (this.model) {
                                var remove = [];
                                for (var selected in this.grid.selection) {
                                    if (this.grid.selection.hasOwnProperty(selected)) {
                                        remove.push(this.model.store.get(selected));
                                    }
                                }
                                return this.model.removeItems(remove);
                            }
                        }));
                    }))
                );
                this._setupDnD();
                when(this.getCurrentContext(), lang.hitch(this, function(currentContext){
                    this._updateGridQuery(currentContext.id);
                    this.grid.startup();
                }));
            }));

        },

        _updateGridQuery: function(value){
            var queryOptions = this.getQueryOptions(value);
            this.grid.set("query", queryOptions.query, queryOptions.options);
        },

        getQueryOptions: function(referenceId) {
            return {
                query: {
                    referenceId: new ContentReference(referenceId).createVersionUnspecificReference().toString(),
                    relationTypes: [this.relationType]
                },
                options: {
                    ignore: ["referenceId", "relationTypes"]
                }
            };
        },

        _addItem: function (item) {
            when(this._dndGetItemData(item), lang.hitch(this, function (itemData) {
                return this.model.addItem(itemData);
            }));
        },

        resize: function () {
            this.inherited(arguments);

            if (this.grid) {
                this.grid.resize();
            }
        },

        _getDialogTitleText: function () {
            return this.addLabelText;
        },

        _createItemEditor: function () {
            return new this.itemEditorType({
                canSelectOwnerContent: false,
                showButtons: false,
                roots: this.roots,
                allowedTypes: [ModelSupport.contentTypeIdentifier.variationContent, ModelSupport.contentTypeIdentifier.productContent],
                showAllLanguages: false
            });
        },

        _dndGetItemData: function (item) {
            return when(item.data, lang.hitch(this, function (data) {
                return this._createItem(data.contentLink, data.name);
            }));
        },

        _createItem: function (targetLink, name) {
            return {
                name: name || targetLink,
                groupName: "Default",
                quantity: 1,
                sortOrder: 0,
                source: this.model.get("contentLink"),
                target: targetLink,
                type: this.relationType
            };
        },

        onExecuteDialog: function () {
            var item = this._itemEditor.get("value");
            this._addItem({ data: { contentLink: item } }, true);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this._set("value", value);

            if (this.model) {
                this.model.set("contentLink", value);
            }
        },

        destroy: function () {
            // summary:
            //      Destroy the object.

            if (this.grid) {
                this.grid.destroy();
                this.grid = null;
            }

            this.inherited(arguments);
        },

        _showConfirmation: function (title, description) {
            // summary:
            //      Wrap epi.shell.widget.dialog.Confirmation for short type
            //      and return deferred object
            // description:
            //      String: Text to display on dialog
            // tags:
            //      private

            var deferred = new Deferred();

            var dialog = new Confirmation({
                destroyOnHide: true,
                title: epiString.toHTML(title),
                description: epiString.toHTML(description),
                onAction: function (confirmed) {
                    if (confirmed) {
                        deferred.resolve();
                    } else {
                        deferred.cancel();
                    }
                }
            });
            dialog.show();

            return deferred.promise;
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/_GroupDefinitionEditorMixin':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/dom-construct",
    
    // dijit
    "dijit/form/Button",
    
    // epi
    "epi/shell/widget/dialog/Dialog",
    
    // epi-ecf-ui
    "./RelationGroupDefinitionEditor",

    // resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.relationgroupeditor",
    "epi/i18n!epi/nls/episerver.shared"

],
function (
    // dojo
    declare,
    domConstruct,
    
    // dijit
    Button,

    // epi
    Dialog,
    
    // epi-ecf-ui
    RelationGroupDefinitionEditor,

    // resources
    groupEditorResources,
    sharedResources
) {

    return declare([], {

        buildRendering: function () {
            this.inherited(arguments);
            var button = new Button({
                "class": "epi-trailingButton",
                label: groupEditorResources.editbuttontext,
                title: groupEditorResources.editbuttontext
            });

            domConstruct.place(button.domNode, this.collectionList, "before");

            this.own(button.on("click", function () {
                var groupDefinitionEditor = new RelationGroupDefinitionEditor();
                var dialog = new Dialog({
                    defaultActionsVisible: false,
                    content: groupDefinitionEditor,
                    title: groupEditorResources.title,
                    destroyOnHide: true,
                    closeIconVisible: false,
                    getActions: function(){
                        var done = {
                            name: "done",
                            label: sharedResources.action.done,
                            title: null,
                            settings: { type: "submit", "class": "Salt" }
                        };
                        return [done];
                    }
                });
                dialog.show();
            }));
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/RelationGroupDefinitionEditor':function(){
﻿/* TODO: Duplicated from AssociationGroupDefinitionEditor - consolidate */
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-geometry",
    // dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    // dgrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    // epi
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/widget/dialog/_DialogContentMixin",
    // epi-ecf-ui
    "./AddRelationGroupDefinitionCommand",
    // resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.relationgroupeditor"
], function(
    // dojo
    declare,
    lang,
    aspect,
    domConstruct,
    domStyle,
    domGeometry,
    // dijit
    _LayoutWidget,
    _TemplatedMixin,
    // dgrid
    Grid,
    Selection,
    // epi
    dependency,
    _Command,
    ButtonBuilder,
    _DialogContentMixin,
    // epi-ecf-ui
    AddRelationGroupDefinitionCommand,
    // resources
    resources
){
    return declare([_LayoutWidget, _TemplatedMixin, _DialogContentMixin], {

        templateString: '<div><div data-dojo-attach-point="addNode"></div></div>',

        store: null,

        grid: null,

        addButton: null,

        _builder: null,

        constructor: function(){
            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.commerce.relationgroupdefinition");
            this._builder = new ButtonBuilder({ settings: { showLabel: false } });
        },

        postCreate: function(){
            this.inherited(arguments);

            this.addButton = new AddRelationGroupDefinitionCommand();
            this._builder.create(this.addButton, this.addNode);

            this._setupGrid();

            // Refresh grid when added item
            this.own(aspect.after(this.addButton, "onSaved", lang.hitch(this, function () {
                this.grid.refresh();
            })));
        },

        _setupGrid: function(){
            var gridType = declare([Grid, Selection]);

            this.grid = new gridType({
                columns: {
                    name: resources.groupname,
                    action: {
                        className: "epi-columnNarrow",
                        renderHeaderCell: function (node) { },
                        renderCell: lang.hitch(this, function (object, value, node, options) {
                            var deleteCommand = new _Command({
                                iconClass: "epi-iconClose",
                                canExecute: true,
                                _execute: lang.hitch(this, function(){
                                    this.store.remove(object.name).then(lang.hitch(this, function(){
                                        this.grid.refresh();
                                    }));
                                })
                            });
                            this._builder.create(deleteCommand, node);
                        })
                    }
                },
                store: this.store,
                className: "epi-plain-grid"
            });
            this.grid.set("query", {});
            this.own(this.grid);
            domConstruct.place(this.grid.domNode, this.domNode);
        },

        layout: function () {
            // summary:
            //		Layout the children widgets.
            // tags:
            //		protected

            this.inherited(arguments);

            var dialog = this.getParent();
            if (dialog && dialog.containerNode) {
                var containerNodeHeight = domStyle.get(dialog.containerNode, "height"),
                    gridHeaderHeight = Math.max(domGeometry.getMarginBox(this.grid.headerNode).h, domStyle.get(this.grid.bodyNode, "margin")),
                    addButtonHeight = domGeometry.getMarginBox(this.addNode).h;

                // Set the size of the grid to be the dialog container height
                domStyle.set(this.domNode, "height", containerNodeHeight + "px");
                domStyle.set(this.grid.contentNode, "height", (containerNodeHeight - addButtonHeight - gridHeaderHeight) + "px");
            }
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/AddRelationGroupDefinitionCommand':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/ValidationTextBox",
    // epi
    "epi/dependency",
    "epi/shell/command/_Command",
    // epi-cms
    "epi-cms/contentediting/command/_CommandWithDialogMixin",
    // resources
    "epi/i18n!epi/nls/episerver.shared",
    "epi/i18n!epi/cms/nls/commerce.command.addgroup",
    "dojo/text!./templates/ManageGroupDefinitionDialog.html"

], function (
    // dojo
    declare,
    lang,
    when,
    // dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    ValidationTextBox,
    // epi
    dependency,
    _Command,
    // epi-cms
    _CommandWithDialogMixin,
    // resources
    sharedResources,
    commandResources,
    template
) {
    var AddGroupDefinitionContent = declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {

        templateString: template,

        store: null,

        resources: sharedResources.header,

        constructor: function () {
            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.commerce.relationgroupdefinition");
        },

        saveToStore: function () {
            if (this.nameTextBox.validate()) {
                return this.store.put({
                    name: this.nameTextBox.value
                });
            }
        }
    });

    return declare([_Command, _CommandWithDialogMixin], {
        dialogContentClass: AddGroupDefinitionContent,

        dialogClass: "epi-dialog-confirm",

        // Set autofocus to false to prevent the validate the require fields when opening dialog.
        dialogParams: { autofocus: true },

        iconClass: "epi-iconPlus",

        confirmActionText: sharedResources.action.add,

        title: commandResources.title,

        postscript: function () {
            // summary:
            //      Hide close icon
            // tags:
            //      public override
            this.inherited(arguments);

            if (!this.dialogParams) {
                this.dialogParams = {};
            }

            this.dialogParams.closeIconVisible = false;
        },

        _execute: function () {
            this.showDialog();

            if (this._dialog) {
                this._setDialogConfirmActionStatus();

                this.dialogContent.nameTextBox.on("change", lang.hitch(this, this._setDialogConfirmActionStatus));
            }
        },

        _setDialogConfirmActionStatus: function () {
            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "disabled", !this.dialogContent.nameTextBox.validate());
        },

        onDialogExecute: function () {
            when(this.dialogContent.saveToStore(), lang.hitch(this, this.onSaved));
        },

        onSaved: function () {
            // summary:
            //      Process value when saved store.
            //      Need to override.
            // tags:
            //      public virtual 
        },

        canExecute: true
    });
});

},
'url:epi-ecf-ui/contentediting/editors/templates/ManageGroupDefinitionDialog.html':"﻿<div>\r\n    <label for=\"name\">${resources.name} </label>\r\n    <div data-dojo-type=\"dijit/form/ValidationTextBox\" data-dojo-attach-point=\"nameTextBox\" name=\"name\" required=\"true\" data-dojo-props=\"intermediateChanges:true, regExp:'^[A-Za-z0-9]([A-Za-z0-9 _\\-])*$'\"></div>\r\n</div>",
'epi-ecf-ui/widget/PackageEdit':function(){
﻿define([
// dojo
    "dojo/_base/declare",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/TypeDescriptorManager",

// cms
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",

// commerce
    "./_RelationViewBase",
// Resources
    "dojo/text!./templates/PackageEdit.html",
// Widgets in the template
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/contentediting/StandardToolbar",
    "../contentediting/editors/PackageEntryCollectionEditor"
], function (
// dojo
    declare,

// dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

// EPi Framework
    _ModelBindingMixin,
    TypeDescriptorManager,

// CMS
    Breadcrumb,
    BreadcrumbCurrentItem,

// commerce
    _RelationViewBase,
// Resources
    template
) {

    return declare([_RelationViewBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //    Represents the widget to edit bundle entries
        // tags:
        //    public
        templateString: template,

        contentPane: this.contentPane,

        updateView: function (data, context) {
            // summary:
            //      Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //      protected

            this.inherited(arguments);

            this.set("value", context.id);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Sets value for this widget.
            // value: ContentReference
            //      Input content link to get data from.

            this.collectionList.set("value", value);
        }
    });
});

},
'url:epi-ecf-ui/widget/templates/PackageEdit.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-attach-point=\"notificationBar\" data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-props=\"region:'top'\"></div>\r\n    <div data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"contentPane\" class=\"epi-packageEdit\">\r\n        <div data-dojo-attach-point=\"collectionList\" data-dojo-type=\"epi-ecf-ui/contentediting/editors/PackageEntryCollectionEditor\"></div>\r\n    </div>\r\n</div>",
'epi-ecf-ui/contentediting/editors/PackageEntryCollectionEditor':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/topic",

    // ecf-ui
    "../ModelSupport",
    "../viewmodel/EntryRelationCollectionEditorModel",
    "./LinkEditEditor",
    "./_BundleEntryCollectionEditorGrid",
    "./_GroupDefinitionEditorMixin",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.packageentrycollectioneditor"
],
function (
    //dojo
    declare,
    topic,

    // ecf-ui
    ModelSupport,
    EntryRelationCollectionEditorModel,
    LinkEditEditor,
    _BundleEntryCollectionEditorGrid,
    _GroupDefinitionEditorMixin,

    // Resources
    resources
) {
    var collectionEditor = declare([_BundleEntryCollectionEditorGrid], {

        modelType: EntryRelationCollectionEditorModel,

        relationType: ModelSupport.relationType.packageEntry,

        deleteConfirmationTitle: resources.deleteconfirmation.title,

        deleteConfirmationDescription: resources.deleteconfirmation.description

    });

    return declare([LinkEditEditor, _GroupDefinitionEditorMixin], {
        resources: resources,
        gridCollectionType: collectionEditor,

        executeAction: function (actionName) {
            // summary:
            //      Called when [variants and products] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/tools/toggle", true);
        }
    });
});

},
'epi-ecf-ui/component/Catalogs':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/topic",
// epi
    "epi-cms/widget/HierarchicalList",
// commerce
    "./CatalogsViewModel",
// Resources
    "epi/i18n!epi/cms/nls/commerce.components.catalogs"
],

function (
// dojo
    declare,
    lang,
    on,
    topic,
    
// epi
    HierarchicalList,
// commerce
    CatalogsViewModel,
// Resources
    res
) {
    // module:
    //      epi-ecf-ui.component.Catalogs

    return declare([HierarchicalList], {
        // summary:
        //      Catalogs component.
        // tags:
        //      public

        res: res,

        // To enable context change when search catalog entries
        triggerContextChange: true,

        modelClassName: CatalogsViewModel,

        startup: function () {
            // summary: 
            //      Adds the breadcrumb widget to the top of the list widget.
            // tags:
            //      protected
            this.inherited(arguments);

            topic.subscribe("relationChanged", lang.hitch(this, function () {
                this.list._updateQuery(this.list.query);
            }));
            // disable DnD action on this gadget
            this.tree.dndController.readOnly = true;
        },

        postCreate: function () {
            this.inherited(arguments);

            this.list.set("noDataMessage", this.res.nocatalogentry);
        },

        setupContextMenu: function () {
            // summary: set up the context menu. Overrriden to not add context menu on the catalog tree gadget
            //      
            // tag:
            //      public

        }
    });
});
},
'epi-ecf-ui/component/CatalogsViewModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
// epi
    "epi-cms/widget/viewmodel/HierarchicalListViewModel",
// Commerce
    "../widget/viewmodel/CatalogTreeStoreModel"
],

function (
// dojo
    declare,
// epi
    HierarchicalListViewModel,
// Commerce
    CatalogTreeStoreModel
) {
    // module:
    //      epi-ecf-ui.component.CatalogsViewModel

    return declare([HierarchicalListViewModel], {

        treeStoreModelClass: CatalogTreeStoreModel,

        // summary:
        //      Catalogs view model.
        // tags:
        //      public
        postscript: function () {
            /*jslint bitwise: true*/
            this.isAvailableFlags = this.isAvailableFlags || this.menuType.ROOT | this.menuType.TREE | this.menuType.LIST;

            this.inherited(arguments);
            this.set("commands", []);
        },

        _getSortSettings: function () {
            // summary:
            //      Returns the list of sort criteria.
            // tags:
            //      protected

            // overwrite to return empty sort setting, which means that the default content's sort order will be used.
            return [];
        },

        contentContextChanged: function (context, callerData) {
            // summary:
            //      Called when the currently loaded content changes. I.e. a new content data object is loaded into the preview area.
            //      Override _ContextContextMixin.contentContextChanged
            // tags:
            //      protected
           
            // If the list already has a context, don't change it
            var oldListRef = this.get("currentListItem");
            if (oldListRef) {
                return;
            }

            // If not, let the base implementation set up the initial context
            this.inherited(arguments);
        }
    });
});
},
'epi-ecf-ui/component/PricingOverview':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-geometry",
// dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
// resources
    "dojo/text!./templates/PricingOverview.html",
    "epi/i18n!epi/cms/nls/commerce.components.pricingoverview",
// Widgets in the template
    "epi-cms/contentediting/StandardToolbar",
    "../widget/PricingOverview"
], function (
    declare,
    domGeometry,
// dijit
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
// resources
    template,
    resources
) {
    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //      This is the initializer of Price Preview.
        resources: resources,

        templateString: template,

        updateView: function (data, context) {
            // summary:
            //		Updates the view, to reflect data changes.(when opening this view second time)
            // tags:
            //		protected

            this.toolbar.update({
                currentContext: context,
                viewConfigurations: {
                    availableViews: data.availableViews,
                    viewName: data.viewName
                }
            });
            this.set("value", context);
            // display top notification bar
            this.pricingOverview.showNotification();
        },

        _setValueAttr: function (value) {
            this.pricingOverview.set("value", value);
        },

        layout: function () {
            // summary:
            //		Layout the children widgets.
            // tags:
            //		protected

            var toolbarSize = domGeometry.getMarginBox(this.toolbar.domNode);

            // Set the size of the pricing overview to be the content height minus the toolbar height.
            this.pricingOverview.resize({
                h: this._contentBox.h - toolbarSize.h,
                w: this._contentBox.w
            });
        }

    });

});

},
'url:epi-ecf-ui/component/templates/PricingOverview.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div data-dojo-type='epi-ecf-ui/widget/PricingOverview' data-dojo-attach-point='pricingOverview'></div>\r\n</div>",
'epi-ecf-ui/widget/PricingOverview':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/when",
    "dojo/dom",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",

// dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Select",
// dojox
    "dojox/html/entities",
// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/TypeDescriptorManager",
// EPi CMS
    "epi-cms/contentediting/NotificationBar", // used in template
// commerce
    "../contentediting/editors/PricingOverviewEditor",
    "../contentediting/ModelSupport",
    "./BackToPreviousViewNotification",
    "./MarketSelector",
    "./viewmodel/PricingOverviewModel",
// Resources
    "epi/i18n!epi/cms/nls/commerce.widget.pricingoverview",
    "epi/i18n!epi/cms/nls/commerce.widget.market",
    "epi/i18n!epi/cms/nls/commerce.widget.customergroup",
    "dojo/text!./templates/PricingOverview.html"
], function (
// dojo
    declare,
    lang,
    array,
    when,
    dom,
    domConstruct,
    domGeo,
    domStyle,
// dijit
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Select,
// dojox
    entities,
// EPi Framework
    _ModelBindingMixin,
    TypeDescriptorManager,
// EPi CMS
    NotificationBar,
// commerce
    PricingOverviewEditor,
    ModelSupport,
    BackToPreviousViewNotification,
    MarketSelector,
    PricingOverviewModel,
// Resources
    resources,
    resDefaultMarket,
    resDefaultCustomerGroup,
    template
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //    Represents the widget to preview price for entries.
        // tags:
        //    public
        resources: resources,

        templateString: template,

        modelClassName: PricingOverviewModel,

        defaultCGItem: { id: "ALL", name: resDefaultCustomerGroup.defaultitem },

        _backToPreviousViewNotification: null,

        // Map property name in view model to a list of properties in this widget
        modelBindingMap: {
            "markets": ["markets"],
            "customerGroups": ["customerGroups"]
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.model && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.set("model", new modelClass());
            }
            this.model.populateData(); // load market list and customer groups.

            this._backToPreviousViewNotification = new BackToPreviousViewNotification();
            this.own(
                this._backToPreviousViewNotification.watch("notification", lang.hitch(this, this._defaultNotificationWatchHandler))
            );
        },

        buildRendering: function() {
            this.inherited(arguments);

            this.priceList = new PricingOverviewEditor();
            this.own(this.priceList);
            domConstruct.place(this.priceList.domNode, this.priceListNode);
        },

        showNotification: function () {
            // summary:
            //      Displays notification bar
            // tags:
            //      public
            this._backToPreviousViewNotification.showNotification();
        },

        _defaultNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue) {
            // summary:
            //      Add/remove notification to/from notification bar
            // tags:
            //      private

            if (oldValue) {
                this.notificationBar.remove(oldValue);
            }

            if (newValue && newValue.content) {
                this.notificationBar.add(newValue);
            }

            this.layout();
        },

        layout: function () {
            // summary:
            //		Layout the pricing overview editor.
            // tags:
            //		protected

            var headerSize = domGeo.getMarginBox(this.header);

            domGeo.setMarginBox(this.priceListNode, {
                h: this._contentBox.h - headerSize.h,
                w: this._contentBox.w
            });
        },

        _setCustomerGroupsAttr: function (customerGroupList) {
            // summary:
            //		Sets customer group list. Let's bind this list to customer groups selector.
            // tags:
            //		private

            // Turn off change notifications while we make all these changes
            this.customerGroupSelector._onChangeActive = false;
            this.customerGroupSelector.removeOption(this.customerGroupSelector.options);

            if (customerGroupList) {
                customerGroupList.unshift(this.defaultCGItem);

                array.forEach(customerGroupList, function (customerGroup) {
                    this.customerGroupSelector.addOption({ label: entities.encode(customerGroup.name), value: customerGroup.id });
                }, this);
            }

            // Turn on change notifications when we made all these changes
            this.customerGroupSelector._onChangeActive = true;
        },

        _onMarketChanged: function () {
            // summary:
            //      Filter the price list by selected market.
            var val = this.marketSelector.value;

            // Show market column when market seletor is ALL, otherwise hide it.
            if (this.priceList.grid){
                if (val === "ALL") {
                    this.priceList.grid.styleColumn("marketId", "display: table-cell;");
                } else {
                    this.priceList.grid.styleColumn("marketId", "display: none;");
                }
            }

            this.priceList.set("marketId", val);
        },

        _onAddNewPrice: function () {
            // summary:
            //      Add new price to a variation/package.

            var marketId = this.marketSelector.value;
            if (marketId === "ALL") {
                marketId = null;
            }
            var priceCode = this.customerGroupSelector.value;
            if (priceCode === "ALL") {
                priceCode = null;
            }

            var newPrice = this.model.getDefaultPrice(marketId, priceCode);
            this.priceList.addPrice(newPrice);
        },

        _onCustomerGroupChanged: function (){
            // summary:
            //      Filter the price list by selected customer group.
            var val = this.customerGroupSelector.value;

            // Show price type & price code column when customer group seletor is ALL, otherwise hide them.
            if (val === "ALL") {
                this.priceList.grid.styleColumn("priceCode", "display: table-cell;");
                this.priceList.grid.styleColumn("priceType", "display: table-cell;");
            } else {
                this.priceList.grid.styleColumn("priceCode", "display: none;");
                this.priceList.grid.styleColumn("priceType", "display: none;");
            }

            this.priceList.set("priceCode", val);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Sets value for this widget.
            // value: content data
            //      Input content link to get data from.

            this.priceList.set("value", value.id);

            //if the current content type has base type which is variation or package, then show add new price button
            if (TypeDescriptorManager.isBaseTypeIdentifier(value.dataType, ModelSupport.contentTypeIdentifier.variationContent) ||
                TypeDescriptorManager.isBaseTypeIdentifier(value.dataType, ModelSupport.contentTypeIdentifier.packageContent)) {
                domStyle.set(this.addNewPrice.domNode, "display", "");
                this.model.set("value", value.id);
            }
            else {
                domStyle.set(this.addNewPrice.domNode, "display", "none");
            }
        }
    });
});

},
'epi-ecf-ui/contentediting/editors/PricingOverviewEditor':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/Deferred",

    "dojo/dom-construct",
    "dojo/Stateful",
    "dojo/when",

    // Dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/focus",

    // Dojox
    "dojox/html/entities",

    // DGrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/extensions/ColumnResizer",
    "dgrid/editor",

    // EPi
    "epi/dependency",
    "epi/string",
    "epi/shell/_ContextMixin",
    "epi/shell/dgrid/_EditorMetadataMixin",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/Confirmation",

    //epi-CMS
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/dgrid/formatters",

    // epi commerce
    "../viewmodel/PricingOverviewEditorModel",
    "./SaleCodeEditor",
    "./MoneyEditor",

    //resources
    "epi/i18n!epi/cms/nls/commerce.widget.pricingoverview.grid",
    "epi/i18n!epi/cms/nls/commerce.widget.pricecollection.message"
],
function (
    // Dojo
    array,
    declare,
    lang,

    Deferred,

    domConstruct,
    Stateful,
    when,

    // Dijit
    _LayoutWidget,
    _TemplatedMixin,
    focusUtil,

    // Dojox
    entities,

    // DGrid
    OnDemandGrid,
    Selection,
    ColumnResizer,
    editor,

    // EPi
    dependency,
    epiString,
    _ContextMixin,
    _EditorMetadataMixin,
    _FocusableMixin,
    _ModelBindingMixin,
    Confirmation,

    //epi-CMS
    WithContextMenu,
    formatters,

    // epi commerce
    PricingOverviewEditorModel,
    SaleCodeEditor,
    MoneyEditor,

    // Resources
    resources,
    messageResources
) {
    return declare([_LayoutWidget, _TemplatedMixin, _ModelBindingMixin, _FocusableMixin, _ContextMixin], {

        templateString: '<div class="epi-pricingOverviewEditor" data-dojo-attach-point="gridNode"></div>',

        grid: null,

        modelType: PricingOverviewEditorModel,

        itemType: "EPiServer.Commerce.Shell.ObjectEditing.InternalMetadata.PriceModel",

        activeEditor: null,

        includedColumns: ["Name", "Code", "MarketId", "PriceType", "MinQuantity", "PriceCode", "UnitPrice", "ValidDate"],

        editableColumns: ["MarketId", "PriceType", "MinQuantity", "PriceCode", "UnitPrice", "ValidDate"],

        postMixInProperties: function () {
            this.model = this.model || new this.modelType({
                itemType: this.itemType
            });
        },

        postCreate: function() {
            this.inherited(arguments);

            // Set up metadata capable grid type
            var EditorGrid = declare([OnDemandGrid, Selection, editor, _EditorMetadataMixin, ColumnResizer, WithContextMenu], {

                //Todo: Break out to mixin
                getColumnDefinition: function(column) {
                    var columnDef = this.inherited(arguments);

                    //Format text instead value for selector widget
                    if (columnDef.field !== "unitPrice" && column.selections && column.selections.length > 0) {
                        columnDef.renderCell = this._renderSelectorValue(column.selections);
                    }

                    return columnDef;
                },
                //Todo: Break out to mixin
                _renderSelectorValue: function(selections) {
                    return lang.hitch(this, function(item, value, node, options) {
                        selections.some(function(selection) {
                            if (selection.value === value) {
                                node.innerHTML = typeof selection.text === "string" ? entities.encode(selection.text) : selection.text;
                                return true;
                            }
                        });

                        if (!node.innerHTML) {
                            node.innerHTML = typeof value === "string" ? entities.encode(value) : value;
                        }
                    });
                }
            });

            // Get metadata for itemType
            when(this.model.metadataManager.getMetadataForType(this.itemType), lang.hitch(this, function(metadata) {
                // Set up columns object with one column for context menu
                var columns = [{
                    field: "epiGridAction",
                    renderHeaderCell: function() {}, // no header
                    formatter: function() {
                        return formatters.menu({
                            title: resources.commands.title
                        });
                    },
                    className: "epi-columnNarrow",
                    sortable: false
                    }],
                    store = dependency.resolve("epi.storeregistry").get("epi.commerce.price"),
                    // Create grid
                    grid = this.grid = new EditorGrid({
                        selectionMode: "single",
                        store: store,
                        minWidth: 100,
                        noDataMessage: resources.nodatamessage,
                        "class": "epi-plain-grid",
                        columns: columns,
                        metadata: {
                            properties: metadata.properties,
                            gridIncluded: this.includedColumns,
                            gridEditable: this.editableColumns
                        }
                    });

                this.model.generateFormatters(grid.columns);
                domConstruct.place(this.grid.domNode, this.gridNode);
                this._setupEvents(grid);

                this._setupContextMenu();

                // Update the grid query in case the contentlink value set but the model or setupEvent hasn't been initialized.
                when(this.getCurrentContext(), lang.hitch(this, function(currentContext){
                    if (this.model.get("contentLink") !== currentContext.id){
                        //we're setting the value, since that will update the models content link
                        //which will update the grids query
                        this.set("value", currentContext.id);
                    } else {
                        //the model already has correct contentLink. Here we just make sure
                        //the grid gets the correct query before starting it
                        this._updateGridQuery(grid);
                    }
                    grid.startup();
                }));
            }));
            this._setMarkets();
        },

        _setupEvents: function(grid){
            var customerPriceGroupType = 2;
            this.own(grid,
                grid.on("dgrid-editor-show", lang.hitch(this, function(e) {
                    if(e.editor instanceof SaleCodeEditor) {
                        //The salecode editor should be updated according to what priceType has been set
                        e.editor.showDropDown(e.cell.row.data.priceType === customerPriceGroupType);
                    } else if (e.editor instanceof MoneyEditor){
                        this._setCurrencySelections(e);
                    }
                    this.activeEditor = e.editor;
                })),
                grid.on("dgrid-datachange", lang.hitch(this, function(e){
                    // when pricetype is changed to/from customer price group clear priceCode value
                    if (e.cell.column.field === "priceType" && (e.value === customerPriceGroupType || e.oldValue === customerPriceGroupType)){
                        e.cell.row.data.priceCode = "";
                    }
                    
                    //invalid value / validation error will result in no changes to the price row
                    if (this.activeEditor && this.activeEditor.isValid && !this.activeEditor.isValid()) {
                        e.preventDefault();
                    }
                })),
                this.model.watch("contentLink", lang.hitch(this, this._changeGridQuery)),
                this.model.watch("marketId", lang.hitch(this, this._changeGridQuery)),
                this.model.watch("priceCode", lang.hitch(this, this._changeGridQuery)),
                this.model.on("itemAdded", lang.hitch(this, function(e) {
                    when(this.grid.refresh(), lang.hitch(this, function(){
                        var newRow = this.grid.row(e.id);
                        if (newRow){
                            // Move row to top by doing insertRow to parent with parent's first child as beforeNode argument
                            var parentNode = newRow.element.parentNode;
                            newRow = this.grid.insertRow(newRow.data, parentNode, parentNode.firstChild, 1, {});
                            // Select row
                            this.grid.select(newRow);
                            focusUtil.focus(this.grid.domNode);
                        }
                    }));
                })),
                this.model.on("itemsRemoved", lang.hitch(this, function(e) {
                    this.grid.refresh();
                })),
                // Listen remove command event
                this.model.on("removeCommandEvent", lang.hitch(this, function() {
                    // Show confirmation dialog to confirm delete price item
                    when(this._showConfirmation(resources.deleteconfirmation.pricetitle, resources.deleteconfirmation.pricedescription), lang.hitch(this, function() {
                        if (this.model) {
                            var remove = [];
                            for (var selected in this.grid.selection) {
                                if (this.grid.selection.hasOwnProperty(selected)) {
                                    remove.push(this.model.store.get(selected));
                                }
                            }
                            return this.model.removeItems(remove);
                        }
                    }));
                })),
                this.model.on("duplicateCommandEvent", lang.hitch(this, function() {
                    var row = this._getSelectedRow(),
                        price = row.data,
                        rowElement = row.element;

                    if (price && this.model) {
                        // Clone the model and remove its ID so that JsonRest understands this is a new object
                        // and not an attempt to update an existing object
                        var clone = lang.clone(price);
                        delete clone.id;

                        this.model.addItem(clone);
                    }
                }))
            );
        },

        _updateGridQuery: function (grid) {
            // summary:
            //      update the query for grid.
            //  tags:
            //      private

            var queryOptions = this.model._createQueryOptions();
            grid.set("query", queryOptions.query, queryOptions.options);
        },

        _changeGridQuery: function (property, oldValue, newValue) {
            // summary:
            //      event to update the grid query.
            //  tags:
            //      private

            if (oldValue !== newValue) {
                this._updateGridQuery(this.grid);
            }
        },

        _setCurrencySelections: function(e){
            //the curreny editor should only show currencies that match the current selected market.
            var currentCurrencyCode = e.cell.row.data.unitPrice.currency;
            var currentCurrency = null;
            array.some(e.editor.get("selections"), function(selection){
                if (selection.value === currentCurrencyCode){
                    currentCurrency = selection;
                    return true;
                }
            });

            var market = this._getMarket(e.cell.row.data.marketId);
            if (market) {
                //create a copy of the array so that we can add values to if without affecting the market currencies
                var currenciesForSelectedMarket = market.currencies.slice(0);
                if(currentCurrency){
                    var marketHasCurrentCurrency = array.some(currenciesForSelectedMarket, function(currency){
                        return currency.value === currentCurrency.value;
                    });
                    //if the current currency does not exist in the selected market, we will add that currency as a selection.
                    if (!marketHasCurrentCurrency){
                        currenciesForSelectedMarket.push(currentCurrency);
                    }
                }
                e.editor.set("selections", currenciesForSelectedMarket);
                //sometimes setting selections seems to clear the value of the selection editor
                e.editor.set("value", e.cell.row.data.unitPrice);
            }
        },

        _setupContextMenu: function(){
            this.commands = this.model.getCommands(this.grid, "context");

            this.grid.contextMenu.addProvider(new Stateful({
                commands: this.commands
            }));
        },

        _setMarkets: function(){
            if(!this.get("markets")){
                var marketStore = dependency.resolve("epi.storeregistry").get("epi.commerce.market");
                marketStore.query().then(lang.hitch(this, function(marketList){
                    this.set("markets", marketList);
                }));
            }
        },

        _getMarket: function(marketId){
            var markets = this.get("markets"),
                market = null;
            array.some(markets, function (m) {
                if (m.id === marketId) {
                    market = m;
                    return true;
                }
            });
            return market;
        },

        _getSelectedRow: function () {
            // summary:
            //      Get current selected row.
            // tags:
            //      private

            return this.grid.row(this._getSelectedRowId());
        },

        _getSelectedRowId: function () {
            // summary:
            //      Get Id of current selected row.
            // tags:
            //      private

            for (var id in this.grid.selection) {
                return id;
            }
        },

        _noDataMessage: resources.nodatamessage,

        _setValueAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this._set("value", value);

            if (this.model) {
                this.model.set("contentLink", value);
            }
        },

        _setMarketIdAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this.model.set("marketId", value);
        },

        _setPriceCodeAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this.model.set("priceCode", value);
        },

        _showConfirmation: function (title, description) {
            // summary:
            //      Wrap epi.shell.widget.dialog.Confirmation for short type
            //      and return deferred object
            // description:
            //      String: Text to display on dialog
            // tags:
            //      private

            var deferred = new Deferred();

            var dialog = new Confirmation({
                destroyOnHide: true,
                title: epiString.toHTML(title),
                description: epiString.toHTML(description),
                onAction: function (confirmed) {
                    if (confirmed) {
                        deferred.resolve();
                    } else {
                        deferred.cancel();
                    }
                }
            });
            dialog.show();

            return deferred.promise;
        },

        addPrice: function (newPrice) {
            // summary:
            //      Add new price to the grid
            // tags:
            //      protected

            // Set default value for marketId column
            var markets = this.get("markets");
            if (!newPrice.marketId && markets && markets.length > 0) {
                var defaultMarket = markets[0];
                newPrice = lang.mixin(newPrice, {
                    marketId: defaultMarket.id,
                    currency: defaultMarket.currencies[0].value
                });
            }

            // Insert new row in grid then edit
            return this.model.addItem(newPrice);
        }
    });
});

},
'epi-ecf-ui/contentediting/viewmodel/PricingOverviewEditorModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/currency",
    "dojo/when",
    "dojo/Stateful",
    "dojo/Evented",
    "dojo/promise/all",
    // epi
    "epi/shell/_StatefulGetterSetterMixin",
    "epi/shell/command/DelegateCommand",
    "epi/dependency",
    "epi/datetime",
    //resources
    "epi/i18n!epi/cms/nls/commerce.widget.pricingoverview.grid",
    "epi/i18n!epi/cms/nls/commerce.widget.pricecollection.message"
],
function (
    //dojo
    declare,
    lang,
    currency,
    when,
    Stateful,
    Evented,
    all,
    // epi
    _StatefulGetterSetterMixin,
    DelegateCommand,
    dependency,
    epiDate,
    //resources
    resources,
    res
) {
    return declare([Stateful, _StatefulGetterSetterMixin, Evented], {
        // module:
        //      epi-ecf-ui/contentediting/viewmodel/PricingOverviewEditorModel
        // summary:
        //      Represents the model for PricingOverviewEditor

        _storeKey: "epi.commerce.price",

        store: null,

        metadataManager: null,

        contentLink: null,

        marketId: null,

        priceCode: null,

        queryOptions: null,

        getChildrenQueryName: "getpricechildren",

        postscript: function () {
            this.inherited(arguments);

            this.storeRegistry = dependency.resolve("epi.storeregistry");
            this.store = this.store || this.storeRegistry.get(this._storeKey);

            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");
        },

        _createQueryOptions: function () {
            // summary:
            //      Creates and returns query options, based on selected content link, market id and customer group (if any).
            // tags:
            //      private

            var query = { referenceId : this.get("contentLink"), query: this.getChildrenQueryName },
                ignoreOptions = ["query", "referenceId"];

            if (this.get("marketId")) {
                lang.mixin(query, { marketId: this.get("marketId") });
                if (query.marketId === "ALL") {
                    ignoreOptions.push("marketId");
                }
            }

            if (this.get("priceCode")) {
                lang.mixin(query, { priceCode: this.get("priceCode") });
                if (query.priceCode === "ALL"){
                    ignoreOptions.push("priceCode");
                }
            }

            return { query: query, options: { ignore: ignoreOptions } };
        },

        getCommands: function (model, category) {
            var commonSettings = {
                category: category,
                model: model,
                canExecute: true,
                isAvailable: true
            };

            return [
                new DelegateCommand(lang.mixin({
                    name: "duplicate",
                    label: resources.commands.duplicate,
                    iconClass: "epi-iconDuplicatePage",
                    delegate: lang.hitch(this, function (cmd) {
                        this.emit("duplicateCommandEvent");
                    })
                }, commonSettings)),
                new DelegateCommand(lang.mixin({
                    name: "remove",
                    label: resources.commands.remove,
                    iconClass: "epi-iconClose",
                    delegate: lang.hitch(this, function (cmd) {
                        this.emit("removeCommandEvent");
                    })
                }, commonSettings))
            ];
        },

        addItem: function(item) {
            return when(this.store.add(item), lang.hitch(this, function(data) {
                this.emit("itemAdded", { id: data.id });
            }));
        },

        removeItems: function (models) {

            var promises = [];

            for (var i = 0, j = models.length; i < j; i += 1) {
                promises.push(this.store.remove(models[i].id));
            }

            return all(promises).then(lang.hitch(this, function(removed) {
                this.emit("itemsRemoved", { removedItems: removed });
            }));
        },

        generateFormatters: function (columnDefinitions) {

            columnDefinitions.validDate.formatter = lang.hitch(this, this._formatValidDate);
            columnDefinitions.unitPrice.formatter = function(value) {
                return currency.format(value.amount, { currency: value.currency });
            };
        },

        _formatValidDate: function (value) {
            // Format datetime
            return this._formatDate(value.validFrom) + " - " + this._formatDate(value.validUntil);
        },

        _formatDate: function (datetime) {
            // summary:
            //      Format datetime to short type.
            // datetime: Object
            //      The raw data.
            // tags:
            //      public

            return datetime && datetime !== "" ? epiDate.toUserFriendlyString(datetime) : res.untildatenotdefined;
        }
    });
});
},
'epi-ecf-ui/contentediting/editors/SaleCodeEditor':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/dom-style",
    "dojo/keys",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/TextBox",
    "dijit/focus",
// cms
    "epi-cms/contentediting/editors/SelectionEditor",
// template
    "dojo/text!./templates/SaleCodeEditor.html"
], function (
// dojo
    declare,
    domStyle,
    keys,
// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    TextBox,
    focusUtil,
// CMS
    SelectionEditor,
// template
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // module:
        //  epi-ecf-ui/contentediting/editors/SaleCodeEditor
        // summary:
        //    Represents the widget to edit sale codes.
        // tags:
        //    public

        templateString: template,

        shouldShowDropDown: false,

        startup: function () {
            this.showDropDown(this.get("shouldShowDropDown"));
        },

        showDropDown: function (showDropDown) {
            this.set("shouldShowDropDown", showDropDown);
            domStyle.set(this.selectWidget.domNode, "display", showDropDown ? "" : "none");
            domStyle.set(this.textWidget.domNode, "display", showDropDown ? "none" : "");
        },

        _getValueAttr: function () {
            return this._getActiveWidget().get("value");
        },

        _setValueAttr: function(value){
            this.selectWidget.set("value", value);
            this.textWidget.set("value", value);
        },

        _getActiveWidget: function(){
            return this.get("shouldShowDropDown") ? this.selectWidget : this.textWidget;
        },

        _setSelectionsAttr: function (selections) {
            this.selectWidget.set("selections", selections);
        },

        _handleKey: function (e) {
            if(e.keyCode === keys.ENTER){
                e.preventDefault();
                focusUtil.curNode.blur();
            }
        },

        focus: function(){
            this._getActiveWidget().focus();
        }
    });
});

},
'url:epi-ecf-ui/contentediting/editors/templates/SaleCodeEditor.html':"﻿<div class=\"epi-saleCodeEditor\">\r\n    <div data-dojo-type=\"dijit/form/TextBox\" data-dojo-attach-point=\"textWidget\" data-dojo-attach-event=\"onKeyDown: _handleKey\"></div>\r\n    <div data-dojo-type=\"epi-cms/contentediting/editors/SelectionEditor\" data-dojo-attach-point=\"selectWidget\" data-dojo-attach-event=\"onKeyDown: _handleKey\"></div>\r\n</div>\r\n",
'epi-ecf-ui/contentediting/editors/MoneyEditor':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/keys",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/NumberTextBox",
    "dijit/focus",
// epi
    "epi/epi",
// epi-cms
    "epi-cms/contentediting/editors/SelectionEditor",
// template
    "dojo/text!./templates/MoneyEditor.html"
], function (
// dojo
    declare,
    keys,
// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    NumberTextBox,
    focusUtil,
// epi
    epi,
// epi-cms
    SelectionEditor,
// template
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // module:
        //  epi-ecf-ui/contentediting/editors/MoneyEditor
        // summary:
        //    Represents the widget to edit currency and amount.
        // tags:
        //    public

        templateString: template,

        value: null,

        _getValueAttr: function () {
            var oldValue = this.value;

            var newValue = {
                currency: this.currency.get("value"),
                amount: this.amount.get("value")
            };

            if (epi.areEqual(newValue, oldValue)){
                return oldValue;
            } else {
                return newValue;
            }
        },

        _setValueAttr: function(value){
            this._set("value", value);
            this.currency.set("value", value.currency);
            this.amount.set("value", value.amount);
        },

        _setSelectionsAttr: function (selections) {
            this.currency.set("selections", selections);
        },

        _handleKey: function (e) {
            if(e.keyCode === keys.ENTER){
                e.preventDefault();
                focusUtil.curNode.blur();
            }
        },

        focus: function(){
            this.amount.focus();
        },

        isValid: function () {
            return this.currency.isValid() && this.amount.isValid() && this.amount.value > 0;
        }
    });
});

},
'url:epi-ecf-ui/contentediting/editors/templates/MoneyEditor.html':"﻿<div class=\"epi-moneyEditor\">\r\n    <div data-dojo-type=\"epi-cms/contentediting/editors/SelectionEditor\" data-dojo-attach-point=\"currency\" data-dojo-attach-event=\"onKeyDown: _handleKey\"></div>\r\n    <div data-dojo-type=\"dijit/form/NumberTextBox\" data-dojo-attach-point=\"amount\" data-dojo-attach-event=\"onKeyDown: _handleKey\"></div>\r\n</div>",
'epi-ecf-ui/widget/viewmodel/PricingOverviewModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/Stateful",
    // EPi Framework
    "epi/dependency",
    "epi/datetime",
    "epi/shell/_StatefulGetterSetterMixin"
], function (
// dojo
    declare,
    lang,
    when,
    Stateful,
    // EPi Framework
    dependency,
    epiDate,
    _StatefulGetterSetterMixin
) {
    return declare([Stateful, _StatefulGetterSetterMixin], {
        // summary:
        //    Represents the Pricing overview widget's model.
        // model:
        //    "epi-ecf-ui/widget/viewmodel/PricingOverviewModel"
        // tags:
        //    public

        _customerGroupStore: null,

        _contentStructureStore: null,

        content: null,

        postscript: function () {
            // summary:
            //      Post properties mixin handler.
            // description:
            //		Set up model and resource for template binding.
            // tags:
            //		protected

            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            this._customerGroupStore = this._customerGroupStore || registry.get("epi.commerce.customergroup");
            this._contentStructureStore = this._contentStructureStore || registry.get("epi.cms.content.light");
        },

        populateData: function () {
            // summary:
            //      Loads data.
            // tags:
            //		protected

            when(this._customerGroupStore.query(), lang.hitch(this, function (customerGroupList) {
                this.set("customerGroups", customerGroupList);
            }));
        },

        _setValueAttr: function (value) {
            // summary:
            //      Sets value for this widget.

            this._set("value", value);

            when(this._contentStructureStore.get(value), lang.hitch(this, function (content) {
                this.set("content", content);
            }));
        },

        getDefaultPrice: function (marketId, priceCode) {
            // summary:
            //      Get default price of the current content data.
            // tags:
            //		protected

            if (!this.content) {
                return null;
            }

            var now = new Date();

            var priceTypeAll = 0;
            var priceTypePriceGroup = 2;

            return {
                contentLink: this.content.contentLink,
                name: this.content.name,
                code: this.content.properties.code,
                marketId: marketId,
                priceType: priceCode ? priceTypePriceGroup : priceTypeAll,
                priceCode: priceCode || "",
                unitPrice: null,
                minQuantity: 0,
                validDate: {
                    validFrom: epiDate.serialize(now),
                    validUntil: epiDate.serialize(now)
                }
            };
        }
    });
});

},
'url:epi-ecf-ui/widget/templates/PricingOverview.html':"﻿<div class=\"epi-pricingOverview\">\r\n    <div data-dojo-attach-point=\"header\">\r\n        <div data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-attach-point=\"notificationBar\"></div>\r\n        <div class=\"epi-pricingOverviewEdit\">\r\n            <h1 class=\"dijitInline\">${resources.heading}</h1>\r\n            <div class=\"epi-filterHolder\">\r\n                <div class=\"epi-filterHolderLeading\">\r\n                    <button class=\"epi-mediumButton\"\r\n                            data-dojo-attach-event='onClick: _onAddNewPrice'\r\n                            data-dojo-attach-point=\"addNewPrice\"\r\n                            data-dojo-type=\"dijit/form/Button\"\r\n                            data-dojo-props=\"label: '${resources.buttons.addprice}', title:'${resources.buttons.addprice}', iconClass:'epi-iconPlus'\"></button>\r\n                </div>\r\n                <div class=\"epi-filterHolderCenter clearfix\">\r\n                    <label for=\"customergroup\">${resources.selectors.customergroup}</label>\r\n                    <select name=\"customergroup\"\r\n                            data-dojo-type=\"dijit/form/Select\"\r\n                            data-dojo-attach-point=\"customerGroupSelector\"\r\n                            data-dojo-attach-event='onChange: _onCustomerGroupChanged'></select>\r\n                    <label for=\"markets\">${resources.selectors.market}</label>\r\n                    <select name=\"markets\"\r\n                            data-dojo-type=\"epi-ecf-ui/widget/MarketSelector\"\r\n                            data-dojo-attach-point=\"marketSelector\"\r\n                            data-dojo-attach-event='onChange: _onMarketChanged'></select>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point='priceListNode'></div>\r\n</div>",
'*now':function(r){r(['dojo/i18n!*preload*epi-ecf-ui/nls/widgets*["ar","ca","cs","da","de","el","en-gb","en-us","es-es","fi-fi","fr-fr","he-il","hu","it-it","ja-jp","ko-kr","nl-nl","nb","pl","pt-br","pt-pt","ru","sk","sl","sv","th","tr","zh-tw","zh-cn","ROOT"]']);}
}});
﻿/* Dummy file to trick the AMD loader when running debug mode */